import { Tabla } from 'componentes/tabla';
import { Boton } from 'componentes/boton';
import { Campo } from 'componentes/campo';
import { Bloque } from 'componentes/bloque';
import { Modal } from 'componentes/modal';
import { Existencias } from 'Recepcion/modelos/existencias';
import { LotesUbicacionesModelo, DetallesLineaPreparada, LotesUbicacionesTraspasosPantallaModelo } from 'Recepcion/dialogos/modelos/dialogo-lotes-ubicaciones-traspasos-modelo';
type LoteInicial = {
    LOTE?: string;
    PR_PRECIO?: number;
};
type CampoUbicacion = {
    nuevoValor: string;
    valorAnterior: string;
    valorHaCambiado: boolean;
};
export declare class DialogoLotesUbicacionesTraspasos {
    protected _inputGaartCod: Campo;
    protected _inputGaartDescrip: Campo;
    protected _inputPendiente: Campo;
    protected _tabla: Tabla<Existencias>;
    protected bloqueEdicion: Bloque;
    protected _inputLoteOrigen: Campo;
    protected _inputLoteDestino: Campo;
    protected _inputCantidad: Campo;
    protected _botonConsultaUbicacionDestino: Boton;
    protected _inputUbicDestino: Campo;
    protected esLoteInicial: boolean;
    protected loteInicial: LoteInicial;
    protected _botonAceptar: Boton;
    protected _modelo: LotesUbicacionesTraspasosPantallaModelo;
    protected _modal: Modal;
    protected _lineaPreparada: DetallesLineaPreparada;
    constructor(init: LotesUbicacionesModelo);
    ConfiguraPantalla(): void;
    validarUbicacionesAlmacen(gaubic_cod: CampoUbicacion): Promise<boolean>;
    ObtenerLotesArticuloAlmacen(): Promise<[{
        GAUBIC_COD: string;
        LOTE: string;
        C_UNID1: string;
    }]>;
    gestionaUbicacionXDefecto(): void;
    puedeAceptar(): boolean;
    actualizaLinea(p_loteOrigen: any, p_cantidad: any): Promise<boolean>;
    btnAceptarOInputLote(): void;
    actualizaVista(): void;
    actualizaModelo(): void;
    acepta(): Promise<void>;
}
export {};
