declare class Renderizado {
    private _documento;
    constructor(_documento: Document);
    documento(): Document;
    contenido(): Element;
    renombra(p_idPrefijo: string, p_elementos: Element[]): void;
    corrigeAtributoFor(p_idPrefijo: string, p_etiquetas: Element[]): void;
    inserta(p_opciones: {
        contenedor?: HTMLElement;
        prefijoId?: string;
    }): Insertado;
}
declare class Insertado {
    private _elemento;
    constructor(_elemento: Element);
    elemento(): Element;
    suprime(): void;
}
interface ISecciones {
    [nombre: string]: string | ISecciones;
}
declare class DefinicionPlantilla {
    private _valores?;
    constructor(_valores?: {
        nombre?: string;
        secciones?: ISecciones;
    });
    nombre(p_nombre: string): DefinicionPlantilla;
    secciones(p_secciones: any): DefinicionPlantilla;
    carga(p_valores: any): Promise<Plantilla>;
    crea(p_texto: string, p_secciones: any): Plantilla;
}
declare class Plantilla {
    private _texto;
    private _secciones;
    constructor(_texto: string, p_secciones?: ISecciones);
    texto(): string;
    renderiza(): Renderizado;
    inserta(): Insertado;
}
export declare function plantilla(p_definicion?: any): DefinicionPlantilla;
export {};
