declare class DefinicionOpcion {
    private _valores;
    constructor(_valores: {
        nombre?: string;
        titulo?: string;
        icono?: string;
        valor?: string;
        iconoValor?: string;
        clic?: () => void;
    });
    titulo(p_titulo: string): DefinicionOpcion;
    icono(p_icono: string): DefinicionOpcion;
    valor(p_valor: string): DefinicionOpcion;
    iconoValor(p_iconoValor: string): DefinicionOpcion;
    clic(p_funcion: () => void): DefinicionOpcion;
    crea(): Opcion;
}
declare class DefinicionOpcionFecha {
    private _valores;
    constructor(_valores: {
        nombre?: string;
        titulo?: string;
        icono?: string;
        valor?: string;
    });
    titulo(p_titulo: any): DefinicionOpcionFecha;
    icono(p_icono: any): DefinicionOpcionFecha;
    valor(p_valor: any): DefinicionOpcionFecha;
    cambio(p_funcion: any): DefinicionOpcionFecha;
    crea(): OpcionFecha;
}
export declare class DefinicionCortina {
    private _valores;
    constructor(_valores: {
        opciones?: (DefinicionOpcion | DefinicionOpcionFecha)[];
    });
    opcion(p_funcion: (p_opcion: DefinicionOpcion) => DefinicionOpcion): DefinicionCortina;
    opcion(p_nombre: string, p_funcion: (p_opcion: DefinicionOpcion) => DefinicionOpcion): DefinicionCortina;
    opcionFecha(p_funcion: (p_opcion: DefinicionOpcionFecha) => DefinicionOpcionFecha): DefinicionCortina;
    opcionFecha(p_nombre: string, p_funcion: (p_opcion: DefinicionOpcionFecha) => DefinicionOpcionFecha): DefinicionCortina;
    crea(): Cortina;
    activa(): Cortina;
}
declare class Opcion {
    private _id;
    private _valores;
    private elemento;
    private boton;
    constructor(_id: string, _valores: {
        nombre?: string;
        titulo?: string;
        icono?: string;
        valor?: any;
    });
    nombre(): string;
    titulo(): string;
    icono(): string;
    valor(p_valor: any): any;
    iconoValor(): any;
    habilita(): any;
    deshabilita(): any;
    habilitado(p_valor: any): any;
}
declare class OpcionFecha {
    private _id;
    private _valores;
    constructor(_id: string, _valores: {
        nombre: string;
        titulo: string;
        icono: string;
        valor: any;
    });
    nombre(): string;
    titulo(): string;
    icono(): string;
    valor(p_valor: any): any;
}
export declare class Cortina {
    opciones: {
        [nombre: string]: (Opcion | OpcionFecha);
    };
    constructor(opciones: {
        [nombre: string]: (Opcion | OpcionFecha);
    });
    abre(): void;
    cierra(): void;
}
export declare function cortina(): DefinicionCortina;
export {};
