define(["require", "exports", "componentes/api", "componentes/componentes", "componentes/foco", "componentes/pantalla", "Exwork/dialogos/js/dialogo-firma", "componentes/lov", "componentes/dialogo", "componentes/boton", "componentes/campo", "componentes/bloque", "lib/moment/moment"], function (require, exports, api_1, componentes_1, foco_1, pantalla_1, dialogo_firma_1, lov_1, dialogo_1, boton_1, campo_1, bloque_1, moment) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PantallaExwork = void 0;
    class PantallaExwork extends pantalla_1.Pantalla {
        constructor() {
            super();
            this.inicializa();
            this.asociaComponentes();
        }
        inicializaComponentes() {
            foco_1.foco.enPrimero(document);
            const vComponentes = {
                _txtAlbaran: (0, campo_1.campo)('txtAlbaran')
                    .cambio(async () => {
                    this.actualizaModelo();
                    await this.obtenerAlbaran();
                    this.actualizaVista();
                })
                    .notifica('al-validar'),
                _txtMatricula: (0, campo_1.campo)('txtMatricula')
                    .cambio(() => {
                    this.actualizaModelo();
                })
                    .notifica('al-validar'),
                _txtNomCli: (0, campo_1.campo)('txtNomCli'),
                _txtDireccion: (0, campo_1.campo)('txtDireccion'),
                _txtFecha: (0, campo_1.campo)('txtFecha')
                    .cambio(() => {
                    this.actualizaModelo();
                })
                    .notifica('al-validar'),
                _txtInt: (0, campo_1.campo)('txtInt')
                    .cambio(async () => {
                    await this.validarCampoInt();
                    this.actualizaVista();
                    foco_1.foco.en(this._txtPais);
                })
                    .notifica('con-pulsacion-retrasada'),
                _txtPais: (0, campo_1.campo)('txtPais')
                    .cambio(async () => {
                    let res = await this.validarCampoPais();
                    if (res.OK) {
                        this._camposExwork.Pais = res.mensaje;
                        this.actualizaVista();
                        foco_1.foco.en(this._txtTelefono);
                    }
                })
                    .notifica('con-pulsacion-retrasada'),
                _txtTelefono: (0, campo_1.campo)('txtTelefono')
                    .cambio(() => {
                    this.actualizaModelo();
                })
                    .notifica('al-validar'),
                _txtBultos: (0, campo_1.campo)('txtBultos'),
                _txtPeso: (0, campo_1.campo)('txtPeso'),
                _txtTransporte: (0, campo_1.campo)('txtTransporte'),
                _operarioBox: (0, bloque_1.bloque)('operarioBox'),
                _txtOperario: (0, campo_1.campo)('txtOperario')
                    .cambio(async () => {
                    this.actualizaModelo();
                    await this.dameOperario();
                    this.actualizaVista();
                }),
                _txtOperarioDescrip: (0, campo_1.campo)('txtOperarioDescrip'),
                _dialogLoV: (0, bloque_1.bloque)('dialogLoV'),
                _btnFirma: (0, boton_1.boton)('btnFirma').clic(async () => {
                    this.actualizaModelo();
                    if (this.comprobacionCampos()) {
                        let correcto = await (0, dialogo_1.dialogo)()
                            .titulo("Firma")
                            .cancelable(false)
                            .plantilla("Exwork/dialogos/plantillas/dialogo-firma")
                            .construye(pModal => new dialogo_firma_1.DialogoFirma(pModal, this._camposExwork))
                            .abre();
                        if (correcto) {
                            await (0, componentes_1.notificacion)().muestra("Firma registrada!");
                            this.inicializa();
                            this.actualizaVista();
                            foco_1.foco.en(this._txtAlbaran);
                        }
                    }
                    else {
                        await (0, componentes_1.mensaje)().muestra("Debe rellenar los campos antes de realizar la firma.");
                    }
                    this.actualizaVista();
                }),
                _btnLimpiar: (0, boton_1.boton)('btnLimpiar').clic(() => {
                    this.inicializa();
                    this.actualizaVista();
                    foco_1.foco.en(this._txtAlbaran);
                }),
                _btnOperarios: (0, boton_1.boton)('btnOperarios').clic(async () => {
                    await this.dameOperarios();
                    this.actualizaVista();
                    foco_1.foco.en(this._btnFirma);
                }),
            };
            return vComponentes;
        }
        async asociaComponentes() {
            const vComponentes = this.inicializaComponentes();
            Object.getOwnPropertyNames(vComponentes).forEach(pNombre => this[pNombre] = vComponentes[pNombre].crea());
            await this.operarioObligarorio();
            this.actualizaVista();
            return;
        }
        inicializa() {
            this._camposExwork = {
                Albaran: "",
                Matricula: "",
                NomCli: "",
                TIP_VC: "",
                Direccion: "",
                Fecha: "" + moment(new Date()).format("YYYY-MM-DD"),
                Int: "00",
                Pais: "",
                Telefono: "",
                Bultos: 0,
                Peso: 0,
                Transporte: "",
                Operario: "",
                OperarioDescrip: "",
                OperarioObligatorio: false,
                Firma: ""
            };
        }
        actualizaVista() {
            this._txtAlbaran.valor(this._camposExwork.Albaran);
            this._txtMatricula.valor(this._camposExwork.Matricula);
            this._txtNomCli.valor(this._camposExwork.NomCli);
            this._txtDireccion.valor(this._camposExwork.Direccion);
            this._txtFecha.valor(this._camposExwork.Fecha);
            this._txtInt.valor(this._camposExwork.Int);
            this._txtPais.valor(this._camposExwork.Pais);
            this._txtTelefono.valor(this._camposExwork.Telefono);
            this._txtBultos.valor(this._camposExwork.Bultos);
            this._txtPeso.valor(this._camposExwork.Peso);
            this._txtTransporte.valor(this._camposExwork.Transporte);
            this._txtOperario.valor(this._camposExwork.Operario);
            this._txtOperarioDescrip.valor(this._camposExwork.OperarioDescrip);
        }
        actualizaModelo() {
            this._camposExwork.Albaran = this._txtAlbaran.valor();
            this._camposExwork.Matricula = this._txtMatricula.valor();
            this._camposExwork.NomCli = this._txtNomCli.valor();
            this._camposExwork.Direccion = this._txtDireccion.valor();
            this._camposExwork.Fecha = moment(this._txtFecha.valor()).format("YYYY-MM-DD");
            this._camposExwork.Int = this._txtInt.valor();
            this._camposExwork.Pais = this._txtPais.valor();
            this._camposExwork.Telefono = this._txtTelefono.valor();
            this._camposExwork.Bultos = this._txtBultos.valor();
            this._camposExwork.Peso = this._txtPeso.valor();
            this._camposExwork.Transporte = this._txtTransporte.valor();
            this._camposExwork.Operario = this._txtOperario.valor();
            this._camposExwork.OperarioDescrip = this._txtOperarioDescrip.valor();
        }
        async obtenerAlbaran() {
            let vResultado;
            let vParametros;
            let vAlbaran;
            try {
                vAlbaran = this._camposExwork.Albaran;
                vParametros = {
                    empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                    emp_cod: sessionStorage.getItem("EMPR_COD"),
                    albaran: vAlbaran
                };
                [vResultado] = await (0, api_1.api)('/RF_Exwork')
                    .metodo('get')
                    .parametros(vParametros)
                    .invoca();
                if ([vResultado]) {
                    this._camposExwork.Albaran = vAlbaran;
                    this._camposExwork.NomCli = vResultado.NOMCLI;
                    this._camposExwork.Direccion = vResultado.DIR;
                    this._camposExwork.Bultos = vResultado.BULTOS;
                    this._camposExwork.Peso = vResultado.PESO;
                    this._camposExwork.Transporte = vResultado.GGMENVIO_DES;
                    this._camposExwork.TIP_VC = vResultado.TIP_VC;
                    if (this._camposExwork.Fecha.trim().toLowerCase().includes('invalid') || this._camposExwork.Fecha === null || this._camposExwork.Fecha.trim() === "") {
                        this._camposExwork.Fecha = moment(new Date()).format("YYYY-MM-DD");
                    }
                    foco_1.foco.en(this._txtMatricula);
                }
                else {
                    this.inicializa();
                    foco_1.foco.en(this._txtAlbaran);
                }
            }
            catch ([vMensaje]) {
                this._camposExwork.NomCli = "";
                this._camposExwork.Direccion = "";
                this._camposExwork.Bultos = 0;
                this._camposExwork.Peso = 0;
                this._camposExwork.Transporte = "";
                await (0, componentes_1.mensaje)().error().muestra(vMensaje);
                foco_1.foco.en(this._txtAlbaran);
            }
        }
        async operarioObligarorio() {
            let vResultado;
            let vParametros;
            try {
                vParametros = {
                    empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                    emp_cod: sessionStorage.getItem("EMPR_COD"),
                };
                [vResultado] = await (0, api_1.api)('/RF_Exwork/Inicio')
                    .metodo('get')
                    .parametros(vParametros)
                    .invoca();
                if ([vResultado]) {
                    if (vResultado.OPER_OBL) {
                        this._operarioBox.clase('operarioBoxTable', true);
                        this._camposExwork.OperarioObligatorio = true;
                    }
                    else {
                        this._operarioBox.clase('operarioBoxTable', false);
                        this._camposExwork.OperarioObligatorio = false;
                    }
                }
            }
            catch ([vMensaje]) {
                await (0, componentes_1.mensaje)().error().muestra(vMensaje);
            }
        }
        async validarCampoPais() {
            let vRespuesta = {
                OK: false,
                mensaje: ""
            };
            let vValorNumerico = parseInt(this._txtPais.valor().toString().trim());
            let vRango = vValorNumerico.toString().length > 0 && vValorNumerico.toString().length <= 3 ? true : false;
            let vEsNumerico = !isNaN(vValorNumerico) ? true : false;
            if (vRango) {
                if (vEsNumerico) {
                    if (vValorNumerico <= 0) {
                        await this.controlEstadoPais("");
                    }
                    else if (vValorNumerico > 999) {
                        await this.controlEstadoPais("");
                    }
                    else {
                        vRespuesta = {
                            OK: true,
                            mensaje: "" + vValorNumerico
                        };
                    }
                }
                else {
                    await this.controlEstadoPais("");
                }
            }
            else {
                await this.controlEstadoPais("");
            }
            return vRespuesta;
        }
        async controlEstadoPais(vMensaje) {
            this._camposExwork.Pais = "34";
            this.actualizaVista();
            if (vMensaje.length > 0) {
                await (0, componentes_1.mensaje)().error().muestra(vMensaje);
            }
            foco_1.foco.en(this._txtPais);
        }
        async validarCampoInt() {
            let vValorNumerico = parseInt(this._txtInt.valor().toString().trim());
            let vRango = vValorNumerico.toString().length > 0 && vValorNumerico.toString().length <= 2 ? true : false;
            let vEsNumerico = !isNaN(vValorNumerico) ? true : false;
            if (vRango) {
                if (vEsNumerico) {
                    if (vValorNumerico < 0) {
                        this._camposExwork.Int = "0" + Math.abs(vValorNumerico);
                    }
                    else if (vValorNumerico.toString().length === 1) {
                        this._camposExwork.Int = "0" + vValorNumerico;
                    }
                    else if (vValorNumerico.toString().length === 2) {
                        this._camposExwork.Int = "" + vValorNumerico;
                    }
                }
                else {
                    this._camposExwork.Int = "00";
                }
            }
            else {
                this._camposExwork.Int = "00";
            }
        }
        async dameOperarios() {
            let vResultado;
            let vParametros;
            let vOperarioSeleccionado;
            try {
                vParametros = {
                    empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                    emp_cod: sessionStorage.getItem("EMPR_COD"),
                };
                [vResultado] = await (0, api_1.api)('/RF_Exwork/Operarios')
                    .metodo('get')
                    .parametros(vParametros)
                    .invoca();
                if ([vResultado]) {
                    vOperarioSeleccionado = await (0, lov_1.lov)()
                        .titulo("LISTA DE OPERARIOS")
                        .columnas([
                        { propiedad: 'COD', titulo: "Código", ancho: '6em' },
                        { propiedad: 'NOMBRE', titulo: "Nombre" }
                    ])
                        .elige(vResultado);
                    if (typeof vOperarioSeleccionado != 'undefined' && vOperarioSeleccionado != null) {
                        this._camposExwork.Operario = vOperarioSeleccionado.COD;
                        this._camposExwork.OperarioDescrip = vOperarioSeleccionado.NOMBRE;
                    }
                }
            }
            catch ([vMensaje]) {
                await (0, componentes_1.mensaje)().error().muestra(vMensaje);
            }
        }
        async dameOperario() {
            let vResultado;
            let vParametros;
            try {
                vParametros = {
                    empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                    emp_cod: sessionStorage.getItem("EMPR_COD"),
                    gpoper_cod: this._camposExwork.Operario
                };
                [vResultado] = await (0, api_1.api)('/RF_Exwork/Operario')
                    .metodo('get')
                    .parametros(vParametros)
                    .invoca();
                if ([vResultado]) {
                    if (typeof vResultado != 'undefined' && vResultado != null) {
                        this._camposExwork.OperarioDescrip = vResultado.NOMBRE;
                        foco_1.foco.en(this._btnFirma);
                    }
                }
            }
            catch ([vMensaje]) {
                await (0, componentes_1.mensaje)().error().muestra(vMensaje);
                foco_1.foco.en(this._txtOperario);
            }
        }
        comprobacionCampos() {
            let datos = this._camposExwork.Albaran.trim() === "" ||
                this._camposExwork.Matricula.trim() === "" ||
                !moment(this._camposExwork.Fecha, moment.ISO_8601, true).isValid() ||
                this._camposExwork.Int.trim() === "" ||
                this._camposExwork.Pais.trim() === "" ||
                this._camposExwork.Telefono.trim() === "" ? false : true;
            if (this._camposExwork.OperarioObligatorio) {
                datos = this._camposExwork.Operario.trim() !== "" && this._camposExwork.OperarioDescrip.trim() !== "" && datos ? true : false;
            }
            return datos;
        }
    }
    exports.PantallaExwork = PantallaExwork;
});
