define(["require", "exports", "componentes/api", "componentes/boton", "componentes/campo", "componentes/foco", "componentes/lov", "componentes/mensaje", "componentes/notificacion", "componentes/pantalla", "Movimientos/modelos/cambio-ubicacion", "Movimientos/Shared/_BloqueDestino", "Movimientos/Shared/_BloqueOrigen", "Utilidades/assert"], function (require, exports, api_1, boton_1, campo_1, foco_1, lov_1, mensaje_1, notificacion_1, pantalla_1, cambio_ubicacion_1, _BloqueDestino_1, _BloqueOrigen_1, assert) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PantallaCambioUbicacion = void 0;
    class PantallaCambioUbicacion extends pantalla_1.Pantalla {
        constructor() {
            super();
            this._model = new cambio_ubicacion_1.CambioUbicacionModel();
            const v_componentes = this.inicializaComponentes();
            Object.getOwnPropertyNames(v_componentes).forEach((pNombre) => (this[pNombre] = v_componentes[pNombre].crea()));
            this.inicializaBloques();
            this.Inicializa();
        }
        set ControlLotes(p_lotes) {
            this._model.ControlLotes = p_lotes === 'S';
        }
        set ControlUbicaciones(Ubicaciones) {
            this._model.ControlUbicaciones = Ubicaciones === 'S';
        }
        inicializaComponentes() {
            const vComponentes = {
                _botonNuevo: (0, boton_1.boton)('btnNuevo').clic(() => {
                    this.Inicializa();
                }),
                _botonGuardar: (0, boton_1.boton)('btnGuardar').clic(async () => {
                    const resultado = await this.Confirmar();
                    if (resultado)
                        this.Inicializa();
                    this.actualizaVista();
                }),
                _inputArticulo: (0, campo_1.campo)('txtArticulo').cambio(async (p_valor) => {
                    await this.CambioArticulo(p_valor);
                    foco_1.foco.enSiguienteA(this._inputArticulo);
                    if (this._bloqueOrigen.Datos.Almacen)
                        foco_1.foco.enSiguienteA(this._bloqueOrigen._inputAlmacen);
                    if (this._bloqueOrigen.Datos.Ubicacion)
                        foco_1.foco.enSiguienteA(this._bloqueOrigen._inputUbicacion);
                }),
                _inputArticuloDescipcion: (0, campo_1.campo)('txtArticuloDescrip'),
                _inputCantidad: (0, campo_1.campo)('txtCantidad').cambio(async () => {
                    await this.CambioCantidad();
                }),
                _botonEstableceCantidad: (0, boton_1.boton)('btnEstableceCantidad').clic(async () => {
                    await this.establecerCantidad();
                    this.actualizaVista();
                    foco_1.foco.en(this._inputCantidad);
                }),
            };
            return vComponentes;
        }
        inicializaBloques() {
            this._bloqueOrigen = new _BloqueOrigen_1.BloqueOrigen(this);
            this._bloqueOrigen.actualizaBloque();
            this._model.DatosOrigen = this._bloqueOrigen.Datos;
            this._bloqueDestino = new _BloqueDestino_1.BloqueDestino(this);
            this._bloqueDestino.actualizaBloque();
            this._model.DatosDestino = this._bloqueDestino.Datos;
        }
        Inicializa() {
            this._model.Articulo = '';
            this._model.ArticuloDescripcion = '';
            this._model.Cantidad = null;
            this._model.DatosOrigen.Articulo = '';
            this._model.DatosOrigen.Ubicacion = '';
            this._model.DatosDestino.Articulo = '';
            this._model.DatosDestino.Ubicacion = '';
            this.ObtenerDatosCambioUbicacion().then((v_datosUbicacion) => {
                if (v_datosUbicacion) {
                    this._model.TipoMovimiento = v_datosUbicacion.GAMOVTIP[0];
                    this._model.GAALMNOM_DES_UNICO = v_datosUbicacion.GAALMNOM_DES_UNICO;
                    this._model.MOSTRAR_LOTE_DES = v_datosUbicacion.MOSTRAR_LOTE_DES;
                    this._model.DatosOrigen.AlmacenDefecto = v_datosUbicacion.GAALMNOM_ORI;
                    this._model.DatosOrigen.GAALMNOM_DES_UNICO =
                        v_datosUbicacion.GAALMNOM_DES_UNICO;
                    this._model.DatosOrigen.MOSTRAR_LOTE_DES =
                        v_datosUbicacion.MOSTRAR_LOTE_DES;
                    if (v_datosUbicacion.GAALMNOM_DES_UNICO)
                        this._model.DatosDestino.AlmacenDefecto =
                            this._model.DatosOrigen.AlmacenDefecto;
                    else
                        this._model.DatosDestino.AlmacenDefecto =
                            v_datosUbicacion.GAALMNOM_DES;
                    this._model.DatosDestino.GAALMNOM_DES_UNICO =
                        v_datosUbicacion.GAALMNOM_DES_UNICO;
                    this._model.DatosDestino.MOSTRAR_LOTE_DES =
                        v_datosUbicacion.MOSTRAR_LOTE_DES;
                }
            });
            this._bloqueOrigen.Inicializa();
            this._bloqueDestino.Inicializa();
            this.actualizaVista();
            foco_1.foco.en(this._inputArticulo);
        }
        actualizaVista() {
            const { _model, _inputArticulo, _inputArticuloDescipcion, _inputCantidad, _bloqueDestino, _bloqueOrigen, _botonGuardar, _botonEstableceCantidad, } = this;
            const { _bloqueDestinoAlmacen, _inputAlmacen, _labelUbicacion, _inputUbicacion, _botonConsultaUbicacion, _bloqueDestinoLote, _inputLote, } = _bloqueDestino;
            _inputArticulo.valor(_model.Articulo);
            _inputArticuloDescipcion.valor(_model.ArticuloDescripcion);
            _inputCantidad.valor(_model.Cantidad);
            _bloqueDestino.Datos = _model.DatosDestino;
            _bloqueOrigen.Datos = _model.DatosOrigen;
            const isAlmacenVisible = !_model.GAALMNOM_DES_UNICO;
            _bloqueDestinoAlmacen.visible(isAlmacenVisible);
            _inputAlmacen.visible(isAlmacenVisible);
            const isLoteVisible = _model.MOSTRAR_LOTE_DES;
            _bloqueDestinoLote.visible(isLoteVisible);
            _inputLote.visible(isLoteVisible);
            _labelUbicacion.obtenElemento().className = isLoteVisible
                ? 'f1 c1 l2'
                : 'f1 c1';
            _inputUbicacion.obtenElemento().className = isLoteVisible
                ? 'f2 c1 l3 form-control input-sm input-xs code focusable'
                : 'f1 c2 form-control input-sm input-xs code focusable';
            _botonConsultaUbicacion.obtenElemento().className =
                'f1 c3 rf-icon-button rf-ubicacion derecha';
            _bloqueDestino.actualizaBloque();
            _bloqueOrigen.actualizaBloque();
            const { ControlUbicaciones, ControlLotes, DatosOrigen: { Almacen, Ubicacion, Lote }, } = _model;
            const isEstableceCantidadEnabled = (!ControlUbicaciones && !ControlLotes) ||
                (ControlUbicaciones && !ControlLotes && Almacen && Ubicacion) ||
                (!ControlUbicaciones && ControlLotes && Almacen && Lote) ||
                (ControlUbicaciones && ControlLotes && Almacen && Ubicacion && Lote);
            if (this._model.Articulo) {
                _inputCantidad.habilita();
                _botonGuardar.habilitado(this._model.ModeloValido);
                isEstableceCantidadEnabled
                    ? _botonEstableceCantidad.habilita()
                    : _botonEstableceCantidad.deshabilita();
            }
            else {
                _inputCantidad.deshabilita();
                _botonEstableceCantidad.deshabilita();
            }
        }
        actualizaModelo() {
            this._model.Articulo = this._inputArticulo.valor();
            this._model.Cantidad = this._inputCantidad.valor();
            if (this._bloqueOrigen)
                this._model.DatosOrigen = this._bloqueOrigen.Datos;
            if (this._bloqueDestino)
                this._model.DatosDestino = this._bloqueDestino.Datos;
            if (this._bloqueOrigen.Datos.Almacen && this._model.GAALMNOM_DES_UNICO)
                this._model.DatosDestino.Almacen = this._bloqueOrigen.Datos.Almacen;
            if (this._bloqueDestino._actualizaLoteAuto)
                this._model.DatosDestino.Lote = this._bloqueOrigen.Datos.Lote;
        }
        limpiaCampoCantidad() {
            this._inputCantidad.valor(null);
        }
        async CambioArticulo(p_articulo) {
            const v_articulo = await this.BuscarCodigosAlternativos(p_articulo);
            const v_resultado = await this.ValidarArticulo(v_articulo);
            if (v_resultado) {
                this._model.Articulo = v_resultado.GAART_COD;
                this._model.ArticuloDescripcion = v_resultado.DESCRIP;
                this.ControlUbicaciones = v_resultado.UBIC_SN;
                this.ControlLotes = v_resultado.LOTES_SN;
                this._model.Cantidad = null;
                this._bloqueDestino.Articulo = v_resultado.GAART_COD;
                this._bloqueDestino._actualizaLoteAuto = true;
                this._bloqueDestino.ControlUbicaciones = v_resultado.UBIC_SN;
                this._bloqueDestino.ControlLotes = v_resultado.LOTES_SN;
                this._model.DatosDestino = this._bloqueDestino.Datos;
                this._bloqueOrigen.Articulo = v_resultado.GAART_COD;
                this._bloqueOrigen.ControlUbicaciones = v_resultado.UBIC_SN;
                this._bloqueOrigen.ControlLotes = v_resultado.LOTES_SN;
                if (this._bloqueOrigen.Datos.AlmacenDefecto &&
                    this._bloqueOrigen.Datos.ControlUbicaciones) {
                    this._bloqueOrigen.Datos.Ubicacion = (await this._bloqueOrigen.UbicacionDefecto()).GAUBIC_DEF;
                }
                if (this._bloqueDestino.Datos.AlmacenDefecto) {
                    this._bloqueDestino.Datos.Ubicacion = (await this._bloqueDestino.UbicacionDefecto()).GAUBIC_DEF;
                }
                this._model.DatosOrigen = this._bloqueOrigen.Datos;
                this.actualizaVista();
            }
        }
        async ValidarArticulo(p_articulo) {
            let v_item;
            try {
                [v_item] = await (0, api_1.api)('/Movimientos/ArticuloCompleto')
                    .metodo('get')
                    .parametros({
                    empgrupo_cod: this._model.Grupo,
                    emp_cod: this._model.Empresa,
                    lecturaarticulo: p_articulo,
                })
                    .invoca();
            }
            catch ([p_mensajeError]) {
                await (0, mensaje_1.mensaje)().error().muestra(p_mensajeError);
                this.Inicializa();
                return;
            }
            assert.esUn(v_item, 'GAART_COD', 'DESCRIP');
            return v_item;
        }
        async CambioCantidad() {
            this.actualizaModelo();
            if (!this._model.ModeloValido) {
                await (0, mensaje_1.mensaje)().muestra(Resources.PantallaMovimientos.Error.Datos_Faltantes);
                this._inputCantidad.valor(null);
                foco_1.foco.en(this._inputCantidad);
                this.actualizaVista();
                return;
            }
            this.actualizaVista();
            foco_1.foco.en(this._botonGuardar);
        }
        async ObtenerDatosCambioUbicacion() {
            let v_datosCambioUbicacion;
            [v_datosCambioUbicacion] = await (0, api_1.api)('RF_Movimientos/InicioCambioUbicacion')
                .parametros({
                empgrupo_cod: this._model.Grupo,
                emp_cod: this._model.Empresa,
            })
                .invoca();
            assert.esUn(v_datosCambioUbicacion, 'GAMOVTIP');
            return v_datosCambioUbicacion;
        }
        async Confirmar() {
            this.actualizaModelo();
            if (this._model.ModeloValido) {
                try {
                    let vObjeto, vMensaje;
                    [vObjeto, vMensaje] = await (0, api_1.api)('/Movimientos/CambiarUbicacion')
                        .metodo('put')
                        .parametros({
                        EMPGRUPO_COD: this._model.Grupo,
                        EMP_COD: this._model.Empresa,
                        GAMOVTIP_COD: this._model.TipoMovimiento.COD,
                        GAART_COD: this._model.Articulo,
                        GAALMNOM_ORI: this._model.DatosOrigen.Almacen,
                        GAUBIC_ORI: this._model.DatosOrigen.Ubicacion,
                        LOTE_ORI: this._model.DatosOrigen.Lote,
                        GAALMNOM_DES: this._model.DatosDestino.Almacen,
                        GAUBIC_DES: this._model.DatosDestino.Ubicacion,
                        LOTE_DES: this._model.DatosDestino.Lote,
                        C_UNID1: this._model.Cantidad,
                        C_UNID2: 0,
                    })
                        .invoca();
                    (0, notificacion_1.notificacion)().muestra(vMensaje);
                    return true;
                }
                catch ([p_mensajeError]) {
                    await (0, mensaje_1.mensaje)().error().muestra(p_mensajeError);
                }
            }
            else {
                await (0, mensaje_1.mensaje)().muestra(Resources.PantallaMovimientos.Error.Datos_Faltantes);
            }
            this.actualizaVista();
        }
        async BuscarCodigosAlternativos(v_articulo) {
            let v_articulos;
            try {
                [v_articulos] = await (0, api_1.api)('/Articulo/Articulos')
                    .parametros({
                    empgrupo_cod: this._model.Grupo,
                    emp_cod: this._model.Empresa,
                    codigoBarras: v_articulo,
                    opcion: 'T',
                })
                    .invoca();
            }
            catch ([p_mensajeError]) {
                await (0, mensaje_1.mensaje)().error().muestra(p_mensajeError);
                return;
            }
            if (!v_articulos.length)
                return v_articulo;
            assert.esUnArrayDe(v_articulos, 'GAART_COD', 'GAART_DESCRIP');
            if (v_articulos.length === 1) {
                return v_articulos[0].GAART_COD;
            }
            else {
                const vArticulo = await (0, lov_1.lov)()
                    .titulo(Resources.PantallaRecepcion.CodigosAlternativos.Lov.Titulo)
                    .columnas([
                    {
                        propiedad: 'GAART_COD',
                        titulo: Resources.PantallaRecepcion.CodigosAlternativos.Lov.Tabla.Codigo,
                        ancho: '6em',
                    },
                    {
                        propiedad: 'GAART_DESCRIP',
                        titulo: Resources.PantallaRecepcion.CodigosAlternativos.Lov.Tabla
                            .Descripcion,
                    },
                ])
                    .elige(v_articulos);
                if (typeof vArticulo !== 'undefined')
                    return vArticulo.GAART_COD;
            }
        }
        async establecerCantidad() {
            try {
                if (this._model.ControlUbicaciones || this._model.ControlLotes) {
                    let v_respuesta = null;
                    let v_valorFiltrado = null;
                    [v_respuesta] = await (0, api_1.api)('/Movimientos/LotesArticuloAlmacen')
                        .metodo('get')
                        .parametros({
                        empgrupo_cod: this._model.Grupo,
                        emp_cod: this._model.Empresa,
                        gaalmnom_cod: this._model.DatosOrigen.Almacen,
                        gaart_cod: this._model.Articulo,
                        opcion: 'ORIGEN',
                    })
                        .invoca();
                    if (v_respuesta) {
                        if (this._model.DatosOrigen.Almacen &&
                            this._model.DatosOrigen.Ubicacion &&
                            this._model.DatosOrigen.Lote) {
                            v_valorFiltrado = v_respuesta.find((v) => v.GAUBIC_COD === this._model.DatosOrigen.Ubicacion &&
                                v.LOTE === this._model.DatosOrigen.Lote);
                            this._model.Cantidad = parseInt(v_valorFiltrado?.C_UNID1) || null;
                            return true;
                        }
                    }
                    else {
                        await (0, notificacion_1.notificacion)()
                            .error()
                            .muestra(Resources.PantallaMovimientos.Error.Obtencion_cantidad);
                        foco_1.foco.en(this._inputCantidad);
                    }
                }
                else {
                    let v_respuesta = null;
                    [v_respuesta] = await (0, api_1.api)('/Movimientos/Articulo')
                        .metodo('get')
                        .parametros({
                        empgrupo_cod: this._model.Grupo,
                        emp_cod: this._model.Empresa,
                        gaalmnom_cod: this._model.DatosOrigen.Almacen,
                        lecturaarticulo: this._model.Articulo,
                    })
                        .invoca();
                    if (v_respuesta) {
                        this._model.Cantidad = v_respuesta?.C_EXIST1 || null;
                    }
                    else {
                        await (0, notificacion_1.notificacion)()
                            .error()
                            .muestra(Resources.PantallaMovimientos.Error.Obtencion_cantidad);
                        foco_1.foco.en(this._inputCantidad);
                    }
                }
            }
            catch ([p_mensajeError]) {
                await (0, mensaje_1.mensaje)().error().muestra(p_mensajeError);
            }
            return false;
        }
    }
    exports.PantallaCambioUbicacion = PantallaCambioUbicacion;
});
