define(["require", "exports", "componentes/api", "componentes/bloque", "componentes/boton", "componentes/campo", "componentes/foco", "componentes/label", "componentes/lov", "componentes/mensaje", "Movimientos/Shared/modelos/DatosAlmacen", "Utilidades/assert"], function (require, exports, api_1, bloque_1, boton_1, campo_1, foco_1, label_1, lov_1, mensaje_1, DatosAlmacen_1, assert) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.BloqueDestino = void 0;
    class BloqueDestino {
        constructor(Padre) {
            this._datosDestino = new DatosAlmacen_1.DatosAlmacen();
            const v_componentes = this.inicializaComponentes();
            Object.getOwnPropertyNames(v_componentes).forEach(pNombre => this[pNombre] = v_componentes[pNombre].crea());
            this._PantallaPadre = Padre;
        }
        get Datos() {
            return this._datosDestino;
        }
        set Datos(v_value) {
            this._datosDestino = v_value;
            this.actualizaBloque();
        }
        inicializaComponentes() {
            const vComponentes = {
                _bloqueDestinoAlmacen: (0, bloque_1.bloque)('bloqueDestinoAlmacen'),
                _botonConsulta: (0, boton_1.boton)('btnDestinoConsulta')
                    .clic(async () => {
                    const vUbicacionSeleccionada = await this.ConsultaDatos();
                    if (!vUbicacionSeleccionada && (this._datosDestino.ControlLotes || this._datosDestino.ControlUbicaciones))
                        if (!this._datosDestino.Almacen)
                            foco_1.foco.en(this._inputAlmacen);
                        else
                            foco_1.foco.enSiguienteA(this._inputAlmacen);
                    else
                        foco_1.foco.enSiguienteA(this._inputLote);
                }),
                _labelAlmacen: (0, label_1.label)('lblDestinoAlmacen'),
                _inputAlmacen: (0, campo_1.campo)('txtDestinoAlmacen')
                    .cambio(async (p_valor) => {
                    this.Almacen = p_valor;
                    let AlmacenValido = await this.ValidarAlmacen();
                    if (!AlmacenValido) {
                        foco_1.foco.en(this._inputAlmacen);
                    }
                    else {
                        foco_1.foco.enSiguienteA(this._inputAlmacen);
                        await this.GestionaUbicacionDefecto();
                    }
                    this.actualizaVista();
                }),
                _botonConsultaAlmacen: (0, boton_1.boton)('btnDestinoAlmacen')
                    .clic(async () => {
                    const AlmacenSeleccionado = await this.ConsultaAlmacen();
                    if (AlmacenSeleccionado)
                        foco_1.foco.enSiguienteA(this._inputAlmacen);
                    else
                        foco_1.foco.en(this._inputAlmacen);
                }),
                _botonConsultaUbicacion: (0, boton_1.boton)('btnDestinoUbicacion')
                    .clic(async () => {
                    const vSeleccionado = await this.ConsultaUbicaciones();
                    if (vSeleccionado)
                        foco_1.foco.enSiguienteA(this._inputUbicacion);
                    else
                        foco_1.foco.en(this._inputUbicacion);
                }),
                _bloqueDestinoUbicacion: (0, bloque_1.bloque)('bloqueDestinoUbicacion'),
                _bloqueDestinoLote: (0, bloque_1.bloque)('bloqueDestinoLote'),
                _labelUbicacion: (0, label_1.label)('lblDestinoUbicacion'),
                _inputUbicacion: (0, campo_1.campo)('txtDestinoUbicacion')
                    .cambio(async () => {
                    this.actualizaModelo();
                    const existe = await this.ValidarUbicacion();
                    if (!existe) {
                        this._datosDestino.Ubicacion = null;
                        foco_1.foco.en(this._inputUbicacion);
                    }
                    this.actualizaVista();
                }),
                _labelLote: (0, label_1.label)('lblDestinoLote'),
                _inputLote: (0, campo_1.campo)('txtDestinoLote')
                    .cambio(() => {
                    this.actualizaModelo();
                    this._actualizaLoteAuto = false;
                    this.actualizaVista();
                })
            };
            return vComponentes;
        }
        Inicializa() {
            this.Articulo = null;
            this._actualizaLoteAuto = true;
            this.actualizaBloque();
        }
        set Articulo(p_value) {
            this._datosDestino = new DatosAlmacen_1.DatosAlmacen({ Articulo: p_value, Almacen: this._datosDestino.AlmacenDefecto, AlmacenDefecto: this._datosDestino.AlmacenDefecto });
            this._datosDestino.Articulo = p_value;
        }
        set Almacen(p_value) {
            this._datosDestino.Almacen = p_value;
            this._datosDestino.Ubicacion = null;
            this._datosDestino.Lote = null;
        }
        set ControlLotes(p_lotes) {
            this._datosDestino.ControlLotes = p_lotes === 'S';
            this._bloqueDestinoUbicacion.clase('l2', !this._datosDestino.ControlLotes);
        }
        set ControlUbicaciones(p_ubicacion) {
            this._datosDestino.ControlUbicaciones = p_ubicacion === 'S';
            this._bloqueDestinoLote.clase('l2', !this._datosDestino.ControlUbicaciones);
        }
        actualizaVista() {
            this.actualizaBloque();
            this._PantallaPadre.actualizaModelo();
            this._PantallaPadre.actualizaVista();
        }
        actualizaBloque() {
            this._inputAlmacen.valor(this._datosDestino.Almacen);
            if (this._datosDestino.ControlUbicaciones) {
                this.ControlUbicaciones = 'S';
                this._inputUbicacion.valor(this._datosDestino.Ubicacion);
                this._bloqueDestinoUbicacion.visible(true);
            }
            else {
                this.ControlUbicaciones = 'N';
                this._bloqueDestinoUbicacion.visible(false);
            }
            if (this._datosDestino.ControlLotes) {
                this.ControlLotes = 'S';
                this._inputLote.valor(this._datosDestino.Lote);
                this._bloqueDestinoLote.visible(true);
            }
            else {
                this.ControlLotes = 'N';
                this._bloqueDestinoLote.visible(false);
            }
            this._inputLote.valor(this._datosDestino.Lote);
            if (this._datosDestino.Articulo)
                this.HabilitarCampos();
            else
                this.DeshabilitarCampos();
        }
        DeshabilitarCampos() {
            this._botonConsulta.deshabilita();
            this._botonConsultaAlmacen.deshabilita();
            this._botonConsultaUbicacion.deshabilita();
            this._inputAlmacen.deshabilita();
            this._inputUbicacion.deshabilita();
            this._inputLote.deshabilita();
        }
        HabilitarCampos() {
            this._botonConsulta.habilita();
            this._botonConsultaAlmacen.habilita();
            this._botonConsultaUbicacion.habilita();
            this._inputAlmacen.habilita();
            this._inputUbicacion.habilita();
            this._inputLote.habilita();
        }
        actualizaModelo() {
            this._datosDestino.Almacen = this._inputAlmacen.valor();
            this._datosDestino.Ubicacion = this._inputUbicacion.valor();
            this._datosDestino.Lote = this._inputLote.valor();
        }
        async ValidarUbicacionLote() {
            const LotesDisponibles = await this.ObtenerLotesArticuloAlmacen();
            const UbicacionLoteValido = LotesDisponibles.some(pLote => (!this._datosDestino.Ubicacion || pLote.GAUBIC_COD === this._datosDestino.Ubicacion) &&
                (!this._datosDestino.Lote || pLote.LOTE === this._datosDestino.Lote));
            return UbicacionLoteValido;
        }
        async ConsultaDatos() {
            try {
                const v_lotesArticuloAlmacen = await this.ObtenerLotesArticuloAlmacen();
                const vColumnas = [
                    { propiedad: 'C_UNID1', titulo: Resources.PantallaMovimientos.ConsultaUbicacionLote.Tabla.Disponible }
                ];
                if (this._datosDestino.ControlLotes)
                    vColumnas.unshift({ propiedad: 'LOTE', titulo: Resources.PantallaMovimientos.ConsultaUbicacionLote.Tabla.Lote });
                if (this._datosDestino.ControlUbicaciones)
                    vColumnas.unshift({ propiedad: 'GAUBIC_COD', titulo: Resources.PantallaMovimientos.ConsultaUbicacionLote.Tabla.Ubicacion, ancho: '6em' });
                let v_elegido = await (0, lov_1.lov)()
                    .titulo(Resources.PantallaMovimientos.ConsultaUbicacionLote.Destino.Titulo)
                    .columnas(vColumnas)
                    .elige(v_lotesArticuloAlmacen);
                if (typeof v_elegido !== 'undefined') {
                    this._datosDestino.Ubicacion = v_elegido.GAUBIC_COD;
                    this._datosDestino.Lote = v_elegido.LOTE;
                    this.actualizaVista();
                    return true;
                }
            }
            catch ([p_mensajeError]) {
                await (0, mensaje_1.mensaje)().error().muestra(p_mensajeError);
            }
            return false;
        }
        async ObtenerLotesArticuloAlmacen() {
            let v_lotesArticuloAlmacen = null;
            [v_lotesArticuloAlmacen] = await (0, api_1.api)("/Movimientos/LotesArticuloAlmacen")
                .metodo('get')
                .parametros({
                "empgrupo_cod": this._datosDestino.Grupo,
                "emp_cod": this._datosDestino.Empresa,
                "gaalmnom_cod": this._datosDestino.Almacen,
                "gaart_cod": this._datosDestino.Articulo,
                "opcion": 'DESTINO'
            })
                .invoca();
            return v_lotesArticuloAlmacen;
        }
        async ValidarUbicacion() {
            let v_ubicacion = null;
            try {
                [v_ubicacion] = await (0, api_1.api)("/Inventario/Ubicacion")
                    .metodo('get')
                    .parametros({
                    "empgrupo_cod": this._datosDestino.Grupo,
                    "emp_cod": this._datosDestino.Empresa,
                    "gaart_cod": this._datosDestino.Articulo,
                    "gaalmnom_cod": this._datosDestino.Almacen,
                    "gaubic_cod": this._datosDestino.Ubicacion,
                    "lote": this._datosDestino.Lote
                })
                    .invoca();
            }
            catch ([p_mensajeError]) {
                await (0, mensaje_1.mensaje)().error().muestra(p_mensajeError);
            }
            if (v_ubicacion)
                return true;
            return false;
        }
        async ValidarAlmacen() {
            const v_almacenes = await this.ObtenerAlmacenesActivos();
            const v_almacenValido = v_almacenes.some(pAlmacen => pAlmacen.COD === this._inputAlmacen.valor());
            if (!v_almacenValido) {
                await (0, mensaje_1.mensaje)().error().muestra(Resources.PantallaMovimientos.Error.Almacen_no_valido);
                this.Almacen = null;
            }
            return v_almacenValido;
        }
        async ObtenerAlmacenesActivos() {
            let v_almacenesActivos;
            try {
                [v_almacenesActivos] = await (0, api_1.api)('/Movimientos/AlmacenesActivos')
                    .parametros({
                    empgrupo_cod: this.Datos.Grupo,
                    emp_cod: this.Datos.Empresa,
                    gaart_cod: this.Datos.Articulo,
                    opcion: "A"
                })
                    .invoca();
            }
            catch ([p_mensajeError]) {
                await (0, mensaje_1.mensaje)().error().muestra(p_mensajeError);
                return;
            }
            assert.esUnArrayDe(v_almacenesActivos, 'COD', 'DESCRIP');
            return v_almacenesActivos;
        }
        async ConsultaAlmacen() {
            const v_almacenes = await this.ObtenerAlmacenesActivos();
            let vElegido = await (0, lov_1.lov)()
                .titulo(Resources.PantallaMovimientos.ConsultaAlmacen.Destino.Titulo)
                .columnas([
                { propiedad: 'COD', titulo: Resources.PantallaMovimientos.ConsultaAlmacen.Tabla.Codigo, ancho: '6em' },
                { propiedad: 'DESCRIP', titulo: Resources.PantallaMovimientos.ConsultaAlmacen.Tabla.Descripcion }
            ])
                .elige(v_almacenes);
            if (typeof vElegido !== 'undefined') {
                this.Almacen = vElegido.COD;
                await this.GestionaUbicacionDefecto();
                this.actualizaVista();
                return true;
            }
            return false;
        }
        async GestionaUbicacionDefecto() {
            const v_ubicacionOrigen = await this.UbicacionDefecto();
            this._datosDestino.Ubicacion = v_ubicacionOrigen.GAUBIC_DEF;
            if (this._datosDestino.Ubicacion)
                foco_1.foco.enSiguienteA(this._inputUbicacion);
        }
        async ObtenerUbicaciones() {
            let v_ubicaciones;
            try {
                [v_ubicaciones] = await (0, api_1.api)('/Movimientos/Ubicaciones')
                    .parametros({
                    empgrupo_cod: this.Datos.Grupo,
                    emp_cod: this.Datos.Empresa,
                    gaalmnom_cod: this.Datos.Almacen,
                    ori_des: "DES"
                })
                    .invoca();
            }
            catch ([p_mensajeError]) {
                await (0, mensaje_1.mensaje)().error().muestra(p_mensajeError);
                return;
            }
            assert.esUnArrayDe(v_ubicaciones, 'COD');
            return v_ubicaciones;
        }
        async ConsultaUbicaciones() {
            let v_ubicaciones = await this.ObtenerUbicaciones();
            let v_elegido = await (0, lov_1.lov)()
                .titulo(Resources.PantallaMovimientos.ConsultaUbicacion.Destino.Titulo)
                .columnas([
                { propiedad: 'COD', titulo: Resources.PantallaMovimientos.ConsultaUbicacionLote.Tabla.Ubicacion, ancho: '6em' }
            ])
                .elige(v_ubicaciones);
            if (typeof v_elegido !== 'undefined') {
                this._datosDestino.Ubicacion = v_elegido.COD;
                this.actualizaVista();
                return true;
            }
            return false;
        }
        async UbicacionDefecto() {
            if (!this.Datos.Almacen)
                return { GAUBIC_DEF: null };
            let v_ubicDefArticulo;
            try {
                [v_ubicDefArticulo] = await (0, api_1.api)("/Movimientos/UbicDefArticulo")
                    .metodo('get')
                    .parametros({
                    empgrupo_cod: this.Datos.Grupo,
                    emp_cod: this.Datos.Empresa,
                    gaart_cod: this._datosDestino.Articulo,
                    gaalmnom_cod: this._datosDestino.Almacen
                })
                    .invoca();
            }
            catch ([p_mensajeError]) {
                await (0, mensaje_1.mensaje)().error().muestra(p_mensajeError);
                return;
            }
            assert.esUn(v_ubicDefArticulo, "GAUBIC_DEF");
            return v_ubicDefArticulo;
        }
    }
    exports.BloqueDestino = BloqueDestino;
});
