define(["require", "exports", "componentes/foco", "componentes/boton", "Utilidades/utilidades", "Utilidades/assert", "componentes/componente-html"], function (require, exports, foco_1, boton_1, utilidades_1, assert_1, componente_html_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.campo = exports.Campo = exports.DefinicionCampo = void 0;
    class DefinicionCampo extends componente_html_1.ComponenteHTML {
        constructor(_elemento, _valores) {
            super(_elemento);
            this._valores = _valores;
        }
        cambio(p_funcion) {
            if (arguments.length === 1)
                return new DefinicionCampo(this._elemento, { ...this._valores, cambio: p_funcion });
            else
                return this._valores.cambio;
        }
        valida(p_funcion) {
            if (arguments.length === 1)
                return new DefinicionCampo(this._elemento, { ...this._valores, valida: p_funcion });
            else
                return this._valores.valida;
        }
        notifica(p_notifica) {
            if (arguments.length === 1)
                return new DefinicionCampo(this._elemento, { ...this._valores, notifica: p_notifica });
            else
                return this._valores.notifica;
        }
        lov(p_funcion) {
            if (arguments.length === 1)
                return new DefinicionCampo(this._elemento, { ...this._valores, lov: p_funcion });
            else
                return this._valores.lov;
        }
        ;
        crea() {
            return new Campo(this._elemento, this._valores);
        }
        creaAsincrono() {
            (0, assert_1.assert)(!(this._elemento instanceof HTMLInputElement));
            const v_promesa = new Promise((p_resuelve, p_rechaza) => {
                if (typeof this._valores.lov === 'function') {
                    require(['text!inputLov.pp.html'], plantillaInputLov => {
                        this._elemento.innerHTML = (0, utilidades_1.interpola)(plantillaInputLov, this._elemento.id);
                        const v_elementoCampo = document.getElementById('campo-' + this._elemento.id);
                        const v_boton = (0, boton_1.boton)('boton-lov-' + this._elemento.id)
                            .clic(async function () {
                            const v_aceptado = await this._valores.lov();
                            if (v_aceptado)
                                foco_1.foco.enSiguienteA(v_elementoCampo);
                            else
                                foco_1.foco.en(v_elementoCampo);
                        })
                            .crea();
                        p_resuelve(new Campo(v_elementoCampo, this._valores, v_boton));
                    });
                }
                else {
                    p_rechaza('no se que hacer');
                }
            });
            return v_promesa;
        }
    }
    exports.DefinicionCampo = DefinicionCampo;
    class Campo extends componente_html_1.ComponenteHTML {
        constructor(_elemento, _valores, _botonLov) {
            super(_elemento);
            this._valores = _valores;
            this._botonLov = _botonLov;
            this._valorAnterior = this.valor();
            this._elemento.setAttribute('autocomplete', 'off');
            let v_forzarEventoCambio = false;
            if (typeof this._valores.cambio === 'function') {
                switch (this._valores.notifica) {
                    case 'con-pulsacion':
                        this._elemento.addEventListener('keyup', p_evento => {
                            if (p_evento.key !== 'F9') {
                                v_forzarEventoCambio = false;
                                this._elemento.blur();
                                if (typeof this._valores.cambio === 'function')
                                    this._valores.cambio(this.valor());
                            }
                        });
                        break;
                    case 'con-pulsacion-retrasada': {
                        let v_temporizador = null;
                        this._elemento.addEventListener('keyup', p_evento => {
                            let shiftTabPressed = p_evento.shiftKey && p_evento.keyCode === 9;
                            let Shiftpressed = p_evento.keyCode === 16;
                            if (p_evento.key !== 'F9' && p_evento.keyCode !== 9 && !shiftTabPressed && !Shiftpressed) {
                                if (v_temporizador !== null) {
                                    clearTimeout(v_temporizador);
                                    v_temporizador = null;
                                }
                                v_temporizador = setTimeout(() => {
                                    v_forzarEventoCambio = false;
                                    this._elemento.blur();
                                    if (typeof this._valores.cambio === 'function')
                                        this._valores.cambio(this.valor());
                                }, 400);
                            }
                        });
                        break;
                    }
                    case 'al-validar':
                    default:
                        this._elemento.addEventListener('change', () => {
                            v_forzarEventoCambio = false;
                            this._elemento.blur();
                            if (typeof this._valores.cambio === 'function')
                                this._valores.cambio(this.valor());
                        });
                        break;
                }
                this._elemento.addEventListener('blur', () => {
                    if (v_forzarEventoCambio) {
                        v_forzarEventoCambio = false;
                        if (typeof this._valores.cambio === 'function')
                            this._valores.cambio(this.valor());
                    }
                });
            }
            this._elemento.addEventListener('keydown', async (p_evento) => {
                if (p_evento.key === 'Enter') {
                    if (typeof this._valores.valida === 'function') {
                        const v_valor = this.valor();
                        this._valores.valida({
                            nuevoValor: v_valor,
                            valorAnterior: this._valorAnterior,
                            valorHaCambiado: v_valor !== this._valorAnterior
                        });
                        this._valorAnterior = v_valor;
                    }
                }
                else if (typeof this._valores.lov === 'function' && p_evento.key === 'F9') {
                    p_evento.preventDefault();
                    const v_aceptado = await this._valores.lov();
                    if (v_aceptado)
                        foco_1.foco.enSiguienteA(this._elemento);
                    else
                        foco_1.foco.en(this._elemento);
                }
            });
            this._elemento.addEventListener('focus', () => this._elemento.select());
        }
        valor(p_valor) {
            let v_Elemento = this._elemento;
            if (arguments.length === 1)
                switch (v_Elemento.type) {
                    case 'checkbox':
                        v_Elemento.checked = p_valor;
                        break;
                    default: {
                        this._valorAnterior = v_Elemento.value = p_valor === null ? null : p_valor.toString();
                        break;
                    }
                }
            else
                switch (v_Elemento.type) {
                    case 'number': {
                        if (v_Elemento.value.length === 0)
                            return null;
                        return Number(v_Elemento.value);
                    }
                    case 'date': {
                        if (v_Elemento.value.length === 0)
                            return null;
                        return new Date(v_Elemento.value).toISOString();
                    }
                    case 'checkbox': return v_Elemento.checked;
                    default: return v_Elemento.value;
                }
        }
        foco() {
            foco_1.foco.en(this._elemento);
            return this;
        }
        deshabilita() {
            this._elemento.setAttribute("disabled", "true");
            if (typeof this._botonLov !== 'undefined')
                this._botonLov.deshabilita();
            return this;
        }
        habilita() {
            this._elemento.removeAttribute("disabled");
            if (typeof this._botonLov !== 'undefined')
                this._botonLov.habilita();
            return this;
        }
        habilitado(p_valor) {
            if (arguments.length === 0)
                return !this._elemento.hasAttribute('disabled');
            else if (p_valor)
                this.habilita();
            else
                this.deshabilita();
        }
        visible(p_valor) {
            if (arguments.length === 0)
                return !this._elemento.classList.contains('oculto');
            else {
                const v_etiquetas = Array.from(this._elemento.labels);
                const v_elementos = [this._elemento].concat(v_etiquetas);
                if (p_valor)
                    v_elementos.forEach(p => p.classList.remove('oculto'));
                else
                    v_elementos.forEach(p => p.classList.add('oculto'));
            }
        }
    }
    exports.Campo = Campo;
    function campo(p_elemento) {
        const v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento);
        return new DefinicionCampo(v_elemento, {
            cambio: void 0,
            lov: void 0
        });
    }
    exports.campo = campo;
});
