define(["require", "exports", "componentes/foco", "componentes/componente-html"], function (require, exports, foco_1, componente_html_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.casillaVerificacion = exports.CasillaVerificacion = exports.DefinicionCasillaVerificacion = void 0;
    class DefinicionCasillaVerificacion extends componente_html_1.ComponenteHTML {
        constructor(_elemento, _valores) {
            super(_elemento);
            this._valores = _valores;
        }
        valida(p_funcion) {
            return new DefinicionCasillaVerificacion(this._elemento, { ...this._valores, valida: p_funcion });
        }
        cambio(p_funcion) {
            return new DefinicionCasillaVerificacion(this._elemento, { ...this._valores, cambio: p_funcion });
        }
        crea() {
            return new CasillaVerificacion(this._elemento, this._valores);
        }
    }
    exports.DefinicionCasillaVerificacion = DefinicionCasillaVerificacion;
    class CasillaVerificacion extends componente_html_1.ComponenteHTML {
        constructor(_elemento, _valores) {
            super(_elemento);
            this._valores = _valores;
            _elemento.addEventListener('change', _valores.cambio);
            _elemento.addEventListener('focus', () => this.select());
        }
        valor(p_valor) {
            if (arguments.length === 1)
                this._elemento.checked = p_valor;
            else
                return this._elemento.checked;
        }
        foco() {
            foco_1.foco.en(this._elemento);
            return this;
        }
        deshabilita() {
            this._elemento.setAttribute("disabled", "true");
            return this;
        }
        habilita() {
            this._elemento.removeAttribute("disabled");
            return this;
        }
        habilitado(p_valor) {
            if (arguments.length === 0)
                return !this._elemento.hasAttribute('disabled');
            else if (p_valor)
                this.habilita();
            else
                this.deshabilita();
        }
        visible(p_valor) {
            if (arguments.length === 0)
                return !this._elemento.classList.contains('oculto');
            else {
                let v_elementos = [this._elemento].concat(Array.from(this._elemento.labels));
                if (p_valor)
                    v_elementos.forEach(p => p.classList.remove('oculto'));
                else
                    v_elementos.forEach(p => p.classList.add('oculto'));
            }
        }
    }
    exports.CasillaVerificacion = CasillaVerificacion;
    function casillaVerificacion(p_elemento) {
        const v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento);
        return new DefinicionCasillaVerificacion(v_elemento, {
            cambio: void 0
        });
    }
    exports.casillaVerificacion = casillaVerificacion;
});
