define(["require", "exports", "componentes/label", "componentes/boton", "componentes/campo", "componentes/tabla", "componentes/casilla-verificacion", "componentes/desplegable", "componentes/bloque"], function (require, exports, label_1, boton_1, campo_1, tabla_1, casilla_verificacion_1, desplegable_1, bloque_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.componente = void 0;
    function componente(p_elemento) {
        const v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento);
        const v_inputs = {
            text: campo_1.campo,
            number: campo_1.campo,
            button: boton_1.boton,
            checkbox: casilla_verificacion_1.casillaVerificacion
        };
        function input(p_elemento) {
            const v_type = p_elemento.type;
            return v_inputs[v_type](p_elemento);
        }
        const v_componentes = {
            LABEL: label_1.label,
            INPUT: input,
            BUTTON: boton_1.boton,
            TABLE: tabla_1.tabla,
            DIV: bloque_1.bloque,
            SELECT: desplegable_1.desplegable,
        };
        const v_componente = v_componentes[v_elemento.tagName];
        if (typeof v_componente === 'function')
            return v_componente(v_elemento);
        else
            throw new Error('No es un elemento/componente conocido: "' + p_elemento.tagName + '"');
    }
    exports.componente = componente;
});
