define(["require", "exports", "componentes/--plantilla", "componentes/modal", "componentes/componente-html"], function (require, exports, __plantilla_1, modal_1, componente_html_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.dialogo = exports.DefinicionDialogo = void 0;
    class Envoltura extends componente_html_1.ComponenteHTML {
        constructor(_elemento) {
            super(_elemento);
        }
        suprime() {
            this._elemento.remove();
        }
    }
    class DefinicionDialogo extends componente_html_1.ComponenteHTML {
        constructor(_valores) {
            super(_valores.elemento);
            this._valores = _valores;
        }
        titulo(p_titulo) {
            return new DefinicionDialogo({ ...this._valores, titulo: p_titulo });
        }
        cancelable(p_cancelable) {
            return new DefinicionDialogo({ ...this._valores, cancelable: p_cancelable });
        }
        plantilla(p_plantilla) {
            let v_plantilla;
            if (typeof p_plantilla === 'string')
                v_plantilla = { nombre: p_plantilla, secciones: {} };
            else
                v_plantilla = p_plantilla;
            return new DefinicionDialogo({ ...this._valores, plantilla: v_plantilla });
        }
        elemento(p_elemento) {
            return new DefinicionDialogo({ ...this._valores, elemento: p_elemento });
        }
        construye(p_construye) {
            return new DefinicionDialogo({ ...this._valores, construye: p_construye });
        }
        estilos(p_estilos) {
            return new DefinicionDialogo({ ...this._valores, estilos: p_estilos });
        }
        async abre() {
            let v_insertado;
            let v_elemento;
            if (typeof this._valores.elemento !== 'undefined') {
                v_insertado = new Envoltura(this._valores.elemento);
                v_elemento = v_insertado.obtenElemento();
            }
            else {
                const v_plantillaDialogo = await (0, __plantilla_1.plantilla)(this._valores.plantilla).carga(this._valores);
                v_insertado = v_plantillaDialogo.inserta();
                v_elemento = v_insertado.elemento();
            }
            let v_resultado;
            try {
                v_resultado = await (0, modal_1.modal)(v_elemento)
                    .titulo(this._valores.titulo)
                    .cancelable(this._valores.cancelable)
                    .construye(this._valores.construye)
                    .estilos(this._valores.estilos)
                    .abre();
            }
            finally {
                v_insertado.suprime();
            }
            return v_resultado;
        }
    }
    exports.DefinicionDialogo = DefinicionDialogo;
    function dialogo() {
        return new DefinicionDialogo({
            titulo: void 0,
            cancelable: true,
            plantilla: void 0,
            elemento: void 0,
            construye: p_modal => { },
            estilos: {}
        });
    }
    exports.dialogo = dialogo;
});
