define(["require", "exports", "componentes/componente-html"], function (require, exports, componente_html_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.label = exports.Label = exports.DefinicionLabel = void 0;
    class DefinicionLabel extends componente_html_1.ComponenteHTML {
        constructor(_elemento, _valores) {
            super(_elemento);
            this._valores = _valores;
        }
        texto(p_valor) {
            return new DefinicionLabel(this._elemento, { ...this._valores, texto: p_valor });
        }
        valor(p_valor) {
            return this.texto(p_valor);
        }
        color(p_color) {
            return new DefinicionLabel(this._elemento, { ...this._valores, color: p_color });
        }
        crea() {
            return new Label(this._elemento, this._valores);
        }
    }
    exports.DefinicionLabel = DefinicionLabel;
    class Label extends componente_html_1.ComponenteHTML {
        constructor(_elemento, _valores) {
            super(_elemento);
            this._valores = _valores;
            this.texto(_valores.texto);
        }
        texto(p_valor) {
            if (arguments.length === 1)
                this._elemento.textContent = p_valor;
            else
                return this._elemento.textContent;
        }
        valor(p_valor) {
            return this.texto(p_valor);
        }
        color(p_color) {
            if (arguments.length === 1)
                this._elemento.dataset.color = p_color;
            else
                return this._elemento.dataset._color;
        }
        visible(p_valor) {
            if (arguments.length === 0)
                return !this._elemento.classList.contains('oculto');
            else if (p_valor)
                this._elemento.classList.remove('oculto');
            else
                this._elemento.classList.add('oculto');
        }
    }
    exports.Label = Label;
    function label(p_elemento) {
        const v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento);
        return new DefinicionLabel(v_elemento, {
            texto: v_elemento.innerHTML
        });
    }
    exports.label = label;
});
