define(["require", "exports", "componentes/dialogo"], function (require, exports, dialogo_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.lov = void 0;
    class Lov {
        constructor(_titulo, _columnas, _cancelable) {
            this._titulo = _titulo;
            this._columnas = _columnas;
            this._cancelable = _cancelable;
        }
        titulo(p_titulo) {
            if (typeof p_titulo !== 'string')
                throw new Error('No es un título válido');
            return new Lov(p_titulo, this._columnas, this._cancelable);
        }
        columnas(p_columnas) {
            if (!Array.isArray(p_columnas)) {
                throw new Error('No son columnas válidas');
            }
            return new Lov(this._titulo, p_columnas, this._cancelable);
        }
        cancelable(p_valor = true) {
            if (typeof p_valor !== 'boolean')
                throw new Error('No es una opción válida');
            return new Lov(this._titulo, this._columnas, p_valor);
        }
        async elige(p_datos) {
            let v_resultado = await (0, dialogo_1.dialogo)()
                .titulo(this._titulo)
                .plantilla('componentes/lov.pp.html')
                .construye(p_modal => {
                let v_campoBusqueda, v_botonAceptar;
                const v_tabla = p_modal.tabla('tabla')
                    .columnas(this._columnas)
                    .datos(p_datos)
                    .seleccionado(p_fila => v_botonAceptar.habilitado(p_fila))
                    .crea();
                v_campoBusqueda = p_modal.campo('busqueda')
                    .cambio(() => v_tabla.filtro(v_campoBusqueda.valor()))
                    .notifica('con-pulsacion-retrasada')
                    .crea();
                v_botonAceptar = p_modal.boton('aceptar')
                    .clic(() => {
                    const v_objeto = v_tabla.seleccionado();
                    p_modal.cierra(v_objeto);
                })
                    .tecla('Enter')
                    .crea();
            })
                .abre();
            return v_resultado;
        }
    }
    function lov() {
        return new Lov('Seleccione', [], true);
    }
    exports.lov = lov;
    lov.siguienteId = 0;
});
