define(["require", "exports", "Utilidades/utilidades"], function (require, exports, utilidades_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.notificacion = void 0;
    class Notificacion {
        constructor(_texto, _error) {
            this._texto = _texto;
            this._error = _error;
        }
        texto(p_texto) {
            if (typeof p_texto !== 'string') {
                throw new Error('No es un texto válido');
            }
            return new Notificacion(p_texto, this._error);
        }
        error() {
            return new Notificacion(this._texto, true);
        }
        muestra(p_texto) {
            let v_texto = typeof p_texto === 'string' ? p_texto : this._texto;
            function muestraNotificacion() {
                const v_promesa = new Promise((p_resuelve, p_rechaza) => {
                    const v_id = 'notificacion-' + (0, utilidades_1.generaSecuencia)();
                    require(['text!componentes/notificacion.pp.html'], plantilla => {
                        const v_htmlNotificacion = (0, utilidades_1.interpola)(plantilla, { id: v_id, mensaje: v_texto, estilo: this._error ? "error" : "info" });
                        const v_parser = new DOMParser();
                        const v_documento = v_parser.parseFromString(v_htmlNotificacion, 'text/html');
                        const v_elementoNotificacion = v_documento.getElementById(v_id);
                        p_resuelve(v_elementoNotificacion);
                    });
                });
                v_promesa
                    .then(v_elementoNotificacion => {
                    v_elementoNotificacion.classList.add('notificacion-oculta');
                    document.body.appendChild(v_elementoNotificacion);
                    setTimeout(() => {
                        v_elementoNotificacion.classList.remove('notificacion-oculta');
                        setTimeout(() => {
                            v_elementoNotificacion.classList.add('notificacion-oculta');
                            v_elementoNotificacion.addEventListener('transitionend', () => document.body.removeChild(v_elementoNotificacion), { once: true });
                        }, Math.max(3000, 40 * v_texto.length));
                    }, 100);
                });
                return v_promesa;
            }
            return muestraNotificacion.apply(this);
        }
        ;
    }
    function notificacion(p_texto) {
        if (arguments.length === 0) {
            p_texto = '';
        }
        return new Notificacion(p_texto, false);
    }
    exports.notificacion = notificacion;
});
