define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.DialogoSeleccionTipoBulto = void 0;
    class DialogoSeleccionTipoBulto {
        constructor(_modal, p_tiposBulto, p_cantidad) {
            this._modal = _modal;
            this._numeroBultos = 1;
            this._cantidadPorBulto = this._cantidad = p_cantidad;
            this._campoNumeroBultos = _modal.campo('numero-bultos')
                .cambio((p_valor) => {
                this.actualizaModelo();
                this._numeroBultos = p_valor;
                this._cantidadPorBulto = null;
                this.actualizaVista();
            })
                .crea();
            this._campoCantidadPorBulto = _modal.campo('cantidad-por-bulto')
                .cambio((p_valor) => {
                this.actualizaModelo();
                this._cantidadPorBulto = p_valor;
                this.actualizaVista();
            })
                .crea();
            this._campoBusqueda = _modal.campo('busqueda')
                .cambio(() => { this._tabla.filtro(this._campoBusqueda.valor()); })
                .crea();
            this._tabla = _modal.tabla('tabla')
                .columnas([
                { propiedad: 'COD', titulo: Resources.PantallaExpedicion.DialogoSeleccionTipoBulto.Tabla.Columnas.Codigo, ancho: '6em' },
                { propiedad: 'DESCRIP', titulo: Resources.PantallaExpedicion.DialogoSeleccionTipoBulto.Tabla.Columnas.Descripcion }
            ])
                .datos(p_tiposBulto)
                .seleccionado(() => this.actualizaVista())
                .crea();
            this._botonAceptar = _modal.boton('aceptar')
                .clic(this.acepta.bind(this))
                .tecla('Enter')
                .crea();
        }
        acepta() {
            this.actualizaModelo();
            const v_tipoBulto = this._tabla.seleccionado();
            this._modal.cierra({ numeroBultos: this._numeroBultos, cantidadPorBulto: this._cantidadPorBulto, GVPALLETIP: v_tipoBulto });
        }
        actualizaVista() {
            this._campoNumeroBultos.valor(this._numeroBultos);
            this._campoCantidadPorBulto.valor(this._cantidadPorBulto);
            this._botonAceptar.habilitado(this._tabla.seleccionado() && this._numeroBultos && this._cantidadPorBulto &&
                this._numeroBultos * this._cantidadPorBulto === this._cantidad);
        }
        actualizaModelo() {
            this._numeroBultos = this._campoNumeroBultos.valor();
            this._cantidadPorBulto = this._campoCantidadPorBulto.valor();
        }
    }
    exports.DialogoSeleccionTipoBulto = DialogoSeleccionTipoBulto;
});
