define(["require", "exports", "componentes/api", "componentes/bloque", "componentes/boton", "componentes/campo", "componentes/componentes", "componentes/cortina", "componentes/foco", "componentes/pantalla", "componentes/tabla", "expedicion/dialogos/js/dialogo-consulta-bultos", "expedicion/dialogos/js/dialogo-datos-transporte", "expedicion/dialogos/js/dialogo-lotes-ubicaciones", "expedicion/dialogos/js/dialogo-resumen-bultos", "expedicion/dialogos/js/dialogo-seleccion-albaran", "expedicion/dialogos/js/dialogo-seleccion-bulto", "Utilidades/assert"], function (require, exports, api_1, bloque_1, boton_1, campo_1, componentes_1, cortina_1, foco_1, pantalla_1, tabla_1, dialogo_consulta_bultos_1, dialogo_datos_transporte_1, dialogo_lotes_ubicaciones_1, dialogo_resumen_bultos_1, dialogo_seleccion_albaran_1, dialogo_seleccion_bulto_1, assert) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PantallaExpedicion = void 0;
    class PantallaExpedicion extends pantalla_1.Pantalla {
        constructor() {
            super();
            this.inicializa();
        }
        inicializaComponentes() {
            foco_1.foco.enPrimero(document);
            return {
                botonNuevo: (0, boton_1.boton)('btnNuevoPedido')
                    .clic(async () => {
                    await this.nuevoPedido();
                    this.actualizaVista();
                    foco_1.foco.enPrimero(document);
                }),
                botonConfirmar: (0, boton_1.boton)('confirmar')
                    .clic(async () => {
                    this.actualizaModelo();
                    await this.confirmaPedido({ dejarPendiente: false });
                    this.actualizaVista();
                    foco_1.foco.enPrimero(document);
                })
                    .tecla('Enter'),
                botonPendiente: (0, boton_1.boton)('btnPdte')
                    .clic(async () => {
                    this.actualizaModelo();
                    await this.confirmaPedido({ dejarPendiente: true });
                    this.actualizaVista();
                    foco_1.foco.enPrimero(document);
                }),
                tablaLineas: (0, tabla_1.tabla)('tablaLineas')
                    .columnas([
                    { propiedad: 'GAART_COD', titulo: Resources.PantallaExpedicion.tablaLineas.columnas.GAART_COD, ancho: '6em' },
                    { propiedad: 'GAART_DESCRIP', titulo: Resources.PantallaExpedicion.tablaLineas.columnas.GAART_DESCRIP },
                    { propiedad: 'C_PDTE', titulo: Resources.PantallaExpedicion.tablaLineas.columnas.C_PDTE, ancho: '4em', numerico: true }
                ])
                    .seleccionado((p_seleccion) => this.seleccionaLinea(p_seleccion))
                    .formatoFila((p_formato, p_linea) => {
                    if (p_linea.C_PREP !== 0)
                        p_formato.fondo('verde');
                }),
                campoLecturaPedido: (0, campo_1.campo)('txtPedido')
                    .cambio(async () => {
                    this.actualizaModelo();
                    if (this.lecturaPedido) {
                        await this.cargaPedido();
                    }
                    this.actualizaVista();
                }),
                campoGGCLIPR_COD: (0, campo_1.campo)('txtCliente'),
                campoGGCLIPR_NOMBRE: (0, campo_1.campo)('txtNomCliente'),
                campoReferencia: (0, campo_1.campo)('campRefer')
                    .cambio(async () => {
                    this.campoReferencia.deshabilita();
                    setTimeout(async () => {
                        try {
                            this.actualizaModelo();
                            await this.obtenerLinea();
                            this.actualizaVista();
                        }
                        finally {
                            this.campoReferencia.habilita();
                        }
                    });
                }),
                bloqueReferencia: (0, bloque_1.bloque)('ref'),
                campoC_PREP: (0, campo_1.campo)('campCant')
                    .cambio(this.actualizaPreparadoArticuloSinLotesNiUbicaciones.bind(this))
            };
        }
        generaCortina() {
            let v_cortina = (0, cortina_1.cortina)();
            if (!this.pedido || !this.pedidoPreparado)
                return v_cortina;
            v_cortina = v_cortina
                .opcionFecha('fecha-albaran', p_opcion => p_opcion
                .titulo(Resources.PantallaExpedicion.Cortina.Titulo.Fecha_Albaran)
                .icono('fecha')
                .cambio(p_valor => {
                this.pedidoPreparado.F_ALBARAN = p_valor;
            })
                .valor(''))
                .opcion('datos-envio', p_opcion => p_opcion
                .titulo(Resources.PantallaExpedicion.Cortina.Titulo.Datos_Envio)
                .icono('observaciones')
                .iconoValor('buscador')
                .clic(this.mostrarPantallaTransporteCortina.bind(this)));
            if (Array.isArray(this.pedido.Albaranes) && this.pedido.Albaranes.length > 0) {
                v_cortina = v_cortina
                    .opcion('cambiar-albaran', p_opcion => p_opcion
                    .titulo(Resources.PantallaExpedicion.Cortina.Titulo.CambioAlbaran)
                    .icono('observaciones')
                    .iconoValor('buscador')
                    .clic(async () => {
                    const v_resultadoSeleccionAlbaran = await this.pideAlbaran(this.pedido.Albaranes);
                    if (typeof v_resultadoSeleccionAlbaran === 'undefined')
                        return;
                    this.seleccionaAlbaran(v_resultadoSeleccionAlbaran);
                    this.actualizaVista();
                }));
            }
            if (typeof this.pedido.OBSER === 'string' && this.pedido.OBSER.length > 0) {
                v_cortina = v_cortina
                    .opcion('observacion', p_opcion => p_opcion
                    .titulo(Resources.PantallaExpedicion.Cortina.Titulo.Observaciones)
                    .icono('observaciones')
                    .valor('Mostrar')
                    .iconoValor('abrir')
                    .clic(async () => await (0, componentes_1.mensaje)(this.pedido.OBSER).muestra()));
            }
            if (this.pedido.BultosPorLinea) {
                v_cortina = v_cortina
                    .opcion('bultos', p_opcion => p_opcion
                    .titulo(Resources.PantallaExpedicion.Cortina.Titulo.Bultos)
                    .icono('observaciones')
                    .iconoValor('abrir')
                    .clic(async () => {
                    await (0, componentes_1.dialogo)()
                        .titulo('Bultos')
                        .plantilla('expedicion/dialogos/plantillas/dialogo-consulta-bultos')
                        .construye(p_modal => new dialogo_consulta_bultos_1.DialogoConsultaBultos(p_modal, this.pedidoPreparado.Bultos))
                        .abre();
                }));
            }
            return v_cortina;
        }
        actualizaVista() {
            if (typeof this.botonNuevo === 'undefined') {
                const v_componentes = this.inicializaComponentes();
                v_componentes.tablaLineas.col;
                Object.getOwnPropertyNames(v_componentes).forEach(p_nombre => this[p_nombre] = v_componentes[p_nombre].crea());
            }
            this.campoLecturaPedido.valor(this.lecturaPedido);
            this.campoGGCLIPR_COD.valor(this.pedido === null ? null : this.pedido.GGCLIPR_COD);
            this.campoGGCLIPR_NOMBRE.valor(this.pedido === null ? null : this.pedido.GGCLIPR_NOMBRE);
            this.tablaLineas.datos(this.pedidoPreparado && this.pedidoPreparado.Lineas);
            if (this.pedidoPreparado && Array.isArray(this.pedidoPreparado.Lineas)) {
                let v_indices = this.pedidoPreparado.Lineas
                    .map((p_linea, p_indice) => ({ p_linea, p_indice }))
                    .filter(({ p_linea, p_indice }) => p_linea.C_PREP !== 0)
                    .map(({ p_linea, p_indice }) => p_indice);
            }
            this.tablaLineas.buscaYSelecciona(this.lineaSeleccionada, { notificar: false });
            this.campoReferencia.valor(this.lecturaArticulo);
            this.campoC_PREP.valor(this.lecturaCantidad);
            let v_sePuedeConfirmarPedido = this.sePuedeConfirmarPedido();
            this.botonConfirmar.habilitado(v_sePuedeConfirmarPedido);
            this.botonPendiente.habilitado(v_sePuedeConfirmarPedido);
            this.campoLecturaPedido.habilitado(!this.pedidoPreparado);
            this.campoReferencia.habilitado(this.pedidoPreparado !== null);
            this.bloqueReferencia.clase('solo-referencia', !this.lineaSeleccionada || (this.lineaSeleccionada.GAART_LOTES_SN === 'S' || this.lineaSeleccionada.GAART_UBIC_SN === 'S'));
            this.campoReferencia.valor(this.lecturaArticulo);
            if (this.pedidoPreparado) {
                if (this.pedidoPreparado.F_ALBARAN) {
                    let v_opcionFechaAlbaran = this.cortina.opciones['fecha-albaran'];
                    if (v_opcionFechaAlbaran) {
                        v_opcionFechaAlbaran.valor(this.pedidoPreparado.F_ALBARAN ? this.pedidoPreparado.F_ALBARAN : null);
                    }
                }
                const v_opcionDatosEnvio = this.cortina.opciones['datos-envio'];
                if (v_opcionDatosEnvio)
                    v_opcionDatosEnvio.valor(this.pedidoPreparado.GGMENVIO_PED_DES);
                let v_opcionCambiarAlbaran = this.cortina.opciones['cambiar-albaran'];
                if (v_opcionCambiarAlbaran)
                    v_opcionCambiarAlbaran.valor(this.pedidoPreparado.GGALBTIP_COD && this.pedidoPreparado.N_ALBARAN
                        ? `${this.pedidoPreparado.GGALBTIP_COD}-${this.pedidoPreparado.N_ALBARAN}`
                        : 'Nuevo');
                let v_opcionBultos = this.cortina.opciones['bultos'];
                if (v_opcionBultos) {
                    let v_texto;
                    switch (this.pedidoPreparado.Bultos.length) {
                        case 0:
                            v_texto = 'Sin bultos';
                            break;
                        case 1:
                            v_texto = '1 bulto';
                            break;
                        default:
                            v_texto = `${this.pedidoPreparado.Bultos.length} bultos`;
                            break;
                    }
                    v_opcionBultos.valor(v_texto);
                }
            }
        }
        async nuevoPedido() {
            await this.cambiaEstadoPedido(this.pedidoPreparado?.GGPEDTIP_COD, this.pedidoPreparado?.N_PEDIDO);
            this.inicializa();
            this.campoLecturaPedido.foco();
            return;
        }
        actualizaModelo() {
            this.lecturaPedido = this.campoLecturaPedido.valor().toUpperCase();
            this.lecturaArticulo = this.campoReferencia.valor().toUpperCase();
            this.lecturaCantidad = this.campoC_PREP.valor();
        }
        inicializa() {
            this.lecturaPedido = null;
            this.lecturaArticulo = null;
            this.lecturaCantidad = null;
            this.pedido = null;
            this.pedidoPreparado = null;
            this.lineaSeleccionada = null;
            this._DatosTransporte = null;
            this.alSalir(null);
            let v_cortina = this.generaCortina();
            this.cortina = v_cortina.activa();
        }
        async pideDatosTransporte(p_datosTransporte) {
            const v_resultadoDatosTransporte = await (0, componentes_1.dialogo)()
                .titulo(Resources.PantallaExpedicion.DialogoDatosTransporte.Titulo)
                .plantilla('expedicion/dialogos/plantillas/dialogo-datos-transporte')
                .construye(p_modal => new dialogo_datos_transporte_1.DialogoDatosTransporte(p_modal, p_datosTransporte))
                .abre();
            if (typeof v_resultadoDatosTransporte === 'undefined')
                return;
            assert.esUn(v_resultadoDatosTransporte, 'GGMENVIO_COD', 'GGMENVIO_DESCRIP', 'GGVEHICULO_COD', 'GGVEHICULO_DESCRIP');
            return v_resultadoDatosTransporte;
        }
        async cargaPedido() {
            let v_pedido;
            try {
                [v_pedido] = await (0, api_1.api)('/Expedicion/Pedido')
                    .parametros({
                    empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                    emp_cod: sessionStorage.getItem("EMPR_COD"),
                    lecturaPedido: this.lecturaPedido
                })
                    .invoca();
            }
            catch ([v_mensaje]) {
                await (0, componentes_1.mensaje)().error().muestra(v_mensaje);
                return;
            }
            assert.esUn(v_pedido, 'GGPEDTIP_COD', 'N_PEDIDO');
            this.alSalir(async () => {
                assert.esUn(v_pedido, 'GGPEDTIP_COD', 'N_PEDIDO');
                await this.cambiaEstadoPedido(v_pedido.GGPEDTIP_COD, v_pedido.N_PEDIDO);
            });
            if (typeof v_pedido.OBSER === 'string' && v_pedido.OBSER.length > 0) {
                let v_respuesta = await (0, componentes_1.mensaje)(v_pedido.OBSER).muestra();
                if (typeof v_respuesta === 'undefined') {
                    this.cambiaEstadoPedido(v_pedido.GGPEDTIP_COD, v_pedido.N_PEDIDO);
                    await this.nuevoPedido();
                    return;
                }
            }
            this._DatosTransporte = await this.obtenerDatosTransporte(v_pedido);
            if (typeof this._DatosTransporte === 'undefined') {
                this.cambiaEstadoPedido(v_pedido.GGPEDTIP_COD, v_pedido.N_PEDIDO);
                await this.nuevoPedido();
                return;
            }
            let v_resultadoSeleccionAlbaran = await this.pideAlbaran(v_pedido.Albaranes);
            if (typeof v_resultadoSeleccionAlbaran === 'undefined') {
                this.cambiaEstadoPedido(v_pedido.GGPEDTIP_COD, v_pedido.N_PEDIDO);
                await this.nuevoPedido();
                return;
            }
            this.pedido = v_pedido;
            this.disponible = this.pedido.Lineas
                .reduce((p_diccionario, p_linea) => {
                p_diccionario[p_linea.GAART_COD] = p_linea.Existencias;
                return p_diccionario;
            }, {});
            this.pedidoPreparado = {
                EMPGRUPO_COD: sessionStorage.getItem("EMPRGRUP_COD"),
                EMP_COD: sessionStorage.getItem("EMPR_COD"),
                GGPEDTIP_COD: v_pedido.GGPEDTIP_COD,
                N_PEDIDO: v_pedido.N_PEDIDO,
                GGMENVIO_COD: this._DatosTransporte.GGMENVIO_COD,
                GGMENVIO_DES: this._DatosTransporte.GGMENVIO_DESCRIP,
                GGVEHICULO_COD: this._DatosTransporte.GGVEHICULO_COD,
                GGVEHICULO_DES: this._DatosTransporte.GGVEHICULO_DESCRIP,
                GGMENVIO_PED_COD: this._DatosTransporte.GGMENVIO_COD,
                GGMENVIO_PED_DES: this._DatosTransporte.GGMENVIO_DESCRIP,
                GGVEHICULO_PED_COD: this._DatosTransporte.GGVEHICULO_COD,
                GGVEHICULO_PED_DES: this._DatosTransporte.GGVEHICULO_DESCRIP,
                Lineas: v_pedido.Lineas.map(p_linea => ({
                    N_LIN: p_linea.N_LIN,
                    GAART_COD: p_linea.GAART_COD,
                    GAART_DESCRIP: p_linea.GAART_DESCRIP,
                    GAUBIC_DEF: p_linea.GAUBIC_DEF,
                    C_PREP: 0,
                    C_PDTE: p_linea.C_PDTE,
                    C_PDTE2: p_linea.C_PDTE2,
                    C_UNI1: 0,
                    C_UNI2: null,
                    GAART_LOTES_SN: p_linea.GAART_LOTES_SN,
                    GAART_UBIC_SN: p_linea.GAART_UBIC_SN,
                    Detalles: []
                })),
                F_ALBARAN: null,
                N_ETIQUETAS: 0,
                PESO: 0,
                N_BULTOS: 0,
                Bultos: [],
                N_COPIAS: null,
                DejarPendiente: null,
                ImprimirValorado: null,
                AlbaranValorado: v_pedido.AlbaranValorado,
                OPCION_ETIQUETAS: null,
                ImprimirEtiquetas: false,
                PermitirSuperarCantPedido: v_pedido.PermitirSuperarCantPedido
            };
            this.seleccionaAlbaran(v_resultadoSeleccionAlbaran);
            const v_cortina = this.generaCortina();
            this.cortina = v_cortina.activa();
            this.campoReferencia.foco();
            return true;
        }
        async pideAlbaran(p_albaranesPedido) {
            if (!Array.isArray(p_albaranesPedido) || p_albaranesPedido.length === 0)
                return 'nuevo';
            const v_albaranes = p_albaranesPedido
                .map(p_albaran => ({
                GGALBTIP_COD: p_albaran.GGALBTIP_COD,
                N_ALBARAN: p_albaran.N_ALBARAN,
                F_ALBARAN: p_albaran.F_ALBARAN,
                SU_REF_ALB: p_albaran.SU_REF_ALB,
                GGESTADO_COD: p_albaran.GGESTADO_COD
            }));
            const v_resultadoSeleccionAlbaran = await (0, componentes_1.dialogo)()
                .titulo('Albaranes')
                .plantilla('expedicion/dialogos/plantillas/dialogo-seleccion-albaran')
                .construye(p_modal => new dialogo_seleccion_albaran_1.DialogoSeleccionAlbaran(p_modal, v_albaranes))
                .abre();
            return v_resultadoSeleccionAlbaran;
        }
        seleccionaDatosTransporte(p_resultadoDatosTransporte) {
            this.pedidoPreparado.GGMENVIO_COD = p_resultadoDatosTransporte.GGMENVIO_COD;
            this.pedidoPreparado.GGMENVIO_DES = p_resultadoDatosTransporte.GGMENVIO_DESCRIP;
            this.pedidoPreparado.GGVEHICULO_COD = p_resultadoDatosTransporte.GGVEHICULO_COD;
            this.pedidoPreparado.GGVEHICULO_DES = p_resultadoDatosTransporte.GGVEHICULO_DESCRIP;
            this.pedidoPreparado.GGMENVIO_PED_COD = p_resultadoDatosTransporte.GGMENVIO_COD;
            this.pedidoPreparado.GGMENVIO_PED_DES = p_resultadoDatosTransporte.GGMENVIO_DESCRIP;
            this.pedidoPreparado.GGVEHICULO_PED_COD = p_resultadoDatosTransporte.GGVEHICULO_COD;
            this.pedidoPreparado.GGVEHICULO_PED_DES = p_resultadoDatosTransporte.GGVEHICULO_DESCRIP;
        }
        seleccionaAlbaran(p_resultadoSeleccionAlbaran) {
            let v_ggalbtip_cod, v_n_albaran, v_f_albaran;
            if (p_resultadoSeleccionAlbaran !== "nuevo")
                ({ GGALBTIP_COD: v_ggalbtip_cod, N_ALBARAN: v_n_albaran, F_ALBARAN: v_f_albaran, } = p_resultadoSeleccionAlbaran);
            this.pedidoPreparado.GGALBTIP_COD = v_ggalbtip_cod;
            this.pedidoPreparado.N_ALBARAN = v_n_albaran;
            this.pedidoPreparado.F_ALBARAN = v_f_albaran;
        }
        async actualizaPreparadoArticuloSinLotesNiUbicaciones(p_valor) {
            let v_disponible = this.disponible[this.lineaSeleccionada.GAART_COD];
            await this.pideYActualizaBultos(this.lineaSeleccionada, v_disponible, { C_UNI1: this.lineaSeleccionada.C_PREP + p_valor, Detalles: [] });
            this.lineaSeleccionada = null;
            this.lecturaArticulo = null;
            this.lecturaCantidad = null;
            this.actualizaVista();
            this.campoReferencia.foco();
        }
        async pideYActualizaBultos(p_linea, p_disponible, p_preparado) {
            let v_c_uni1 = p_preparado.C_UNI1 - p_linea.C_PREP;
            let v_pedidoPreparado = this.pedidoPreparado;
            let v_pedido = this.pedido;
            if (this.pedido.BultosPorLinea) {
                let v_resultadoDialogoSeleccionBulto = await (0, componentes_1.dialogo)()
                    .titulo(Resources.PantallaExpedicion.DialogoSeleccionBulto.Titulo)
                    .plantilla('expedicion/dialogos/plantillas/dialogo-seleccion-bulto')
                    .construye(p_modal => new dialogo_seleccion_bulto_1.DialogoSeleccionBulto(p_modal, v_pedidoPreparado.Bultos, v_c_uni1, this.ultimoBultoSeleccionado))
                    .abre();
                if (typeof v_resultadoDialogoSeleccionBulto === 'undefined')
                    return;
                assert.esUn(v_resultadoDialogoSeleccionBulto, 'opcion');
                const v_resultadoDialogoSeleccionBulto_ = v_resultadoDialogoSeleccionBulto;
                this.actualizaLinea(p_linea, p_disponible, p_preparado);
                switch (v_resultadoDialogoSeleccionBulto_.opcion) {
                    case 'nuevo': {
                        let v_nuevosBultos = Array.from(new Array(v_resultadoDialogoSeleccionBulto_.numeroBultos), (_, p_indice) => ({
                            N_BULTO: v_pedidoPreparado.Bultos.length + p_indice + 1,
                            GVPALLETIP: v_resultadoDialogoSeleccionBulto_.GVPALLETIP,
                            GAART_COD: p_linea.GAART_COD,
                            GAART_DESCRIP: p_linea.GAART_DESCRIP,
                            C_UNI1: v_resultadoDialogoSeleccionBulto_.cantidadPorBulto,
                            GGPEDLIN_N_LIN: p_linea.N_LIN,
                            articulos: [{
                                    N_LIN: p_linea.N_LIN,
                                    GAART_COD: p_linea.GAART_COD,
                                    GAART_DESCRIP: p_linea.GAART_DESCRIP,
                                    CANTIDAD: v_resultadoDialogoSeleccionBulto_.cantidadPorBulto,
                                }]
                        }));
                        v_pedidoPreparado.Bultos.push.apply(v_pedidoPreparado.Bultos, v_nuevosBultos);
                        this.ultimoBultoSeleccionado = v_nuevosBultos[v_nuevosBultos.length - 1];
                        break;
                    }
                    case 'actualiza': {
                        let v_bulto = v_pedidoPreparado.Bultos.find(p_bulto => p_bulto.N_BULTO === v_resultadoDialogoSeleccionBulto_.bulto.N_BULTO);
                        if (typeof v_bulto === 'undefined')
                            throw new Error('No se ha encontrado el bulto a actualizar');
                        let v_linea = v_bulto.articulos.find(p => p.N_LIN === p_linea.N_LIN && p.GAART_COD === p_linea.GAART_COD);
                        if (typeof v_linea !== 'undefined')
                            v_linea.CANTIDAD += v_c_uni1;
                        else {
                            let v_nuevaLinea = {
                                N_LIN: p_linea.N_LIN,
                                GAART_COD: p_linea.GAART_COD,
                                GAART_DESCRIP: p_linea.GAART_DESCRIP,
                                CANTIDAD: v_c_uni1
                            };
                            v_bulto.articulos.push(v_nuevaLinea);
                        }
                        this.ultimoBultoSeleccionado = v_bulto;
                        break;
                    }
                    case 'ninguno':
                        break;
                    default:
                        throw new Error('No es una opción válida');
                }
            }
            else {
                this.actualizaLinea(p_linea, p_disponible, p_preparado);
            }
        }
        actualizaLinea(p_linea, p_disponible, p_preparado) {
            this.disponible[p_linea.GAART_COD] = p_disponible;
            let v_pedido = this.pedido;
            let v_lineaPedido = v_pedido.Lineas.find(p => p.N_LIN === p_linea.N_LIN);
            p_linea.C_UNI1 = p_preparado.C_UNI1;
            p_linea.C_PREP = p_preparado.C_UNI1;
            p_linea.C_PDTE = v_lineaPedido.C_PDTE - p_linea.C_PREP;
            p_linea.Detalles = p_preparado.Detalles;
        }
        async seleccionaLinea(p_lineaSeleccionada) {
            let v_lineaSeleccionada = p_lineaSeleccionada || null;
            this.lineaSeleccionada = v_lineaSeleccionada;
            this.lecturaArticulo = null;
            this.lecturaCantidad = null;
            if (v_lineaSeleccionada === null) {
                this.actualizaVista();
                this.campoReferencia.foco();
                return;
            }
            try {
                let v_disponible = this.disponible[v_lineaSeleccionada.GAART_COD];
                if (v_lineaSeleccionada.GAART_LOTES_SN === 'S' || v_lineaSeleccionada.GAART_UBIC_SN === 'S') {
                    try {
                        let v_preparado = {
                            C_UNI1: v_lineaSeleccionada.C_UNI1,
                            Detalles: v_lineaSeleccionada.Detalles
                        };
                        let v_resultado = await (0, componentes_1.dialogo)()
                            .titulo(Resources.PantallaExpedicion.DialogoLotesUbicaciones.Titulo)
                            .plantilla('expedicion/dialogos/plantillas/dialogo-lotes-ubicaciones')
                            .construye(p_modal => new dialogo_lotes_ubicaciones_1.DialogoLotesUbicaciones(p_modal, v_lineaSeleccionada, v_disponible, { PermitirSuperarCantPedido: this.pedidoPreparado.PermitirSuperarCantPedido, MostrarUbicDefDetLotes: this.pedido.MostrarUbicDefDetLotes }))
                            .abre();
                        if (typeof v_resultado === 'undefined')
                            return;
                        assert.esUn(v_resultado, 'disponible', 'preparado');
                        const { disponible: v_nuevoDisponible, preparado: v_nuevoPreparado } = v_resultado;
                        await this.pideYActualizaBultos(v_lineaSeleccionada, v_nuevoDisponible, v_nuevoPreparado);
                    }
                    finally {
                        this.lineaSeleccionada = null;
                        this.campoReferencia.foco();
                    }
                }
                else {
                    this.lecturaArticulo = v_lineaSeleccionada.GAART_COD;
                    this.campoC_PREP.foco();
                }
            }
            finally {
                this.actualizaVista();
            }
        }
        sePuedeConfirmarPedido() {
            let v_sePuedeConfirmar = this.pedidoPreparado !== null && this.pedidoPreparado.Lineas.some(p_linea => p_linea.C_PREP !== 0);
            return v_sePuedeConfirmar;
        }
        actualizaPreparadoConResumenBultos(p_resumenBultos, p_opciones) {
            this.pedidoPreparado = Object.assign(this.pedidoPreparado, {
                GGMENVIO_COD: p_resumenBultos.GGMENVIO_COD,
                GGMENVIO_DES: p_resumenBultos.GGMENVIO_DES,
                GGVEHICULO_COD: p_resumenBultos.GGVEHICULO_COD,
                GGVEHICULO_DES: p_resumenBultos.GGVEHICULO_DES,
                N_ETIQUETAS: p_resumenBultos.N_ETIQUETAS,
                PESO: p_resumenBultos.PESO,
                N_BULTOS: p_resumenBultos.N_BULTOS,
                N_COPIAS: p_resumenBultos.N_COPIAS,
                ImprimirValorado: p_resumenBultos.AlbaranValorado,
                AlbaranValorado: p_resumenBultos.AlbaranValorado,
                ImprimirEtiquetas: p_opciones.confirma && p_opciones.imprimeEtiquetas,
                OPCION_ETIQUETAS: p_resumenBultos.OpcionPredeterminada,
            });
        }
        async confirmaPedido(p_opciones) {
            const v_copiaPedidoPreparado = _.cloneDeep(this.pedidoPreparado);
            let v_sinPreparar = this.pedidoPreparado.Lineas.every(p_linea => typeof p_linea.C_PREP === 'undefined');
            if (v_sinPreparar) {
                await (0, componentes_1.mensaje)().error().muestra('Debe preparar el pedido antes de confirmarlo.');
                this.pedidoPreparado = v_copiaPedidoPreparado;
                return;
            }
            const { dejarPendiente: v_dejarPendiente } = p_opciones;
            this.pedidoPreparado = {
                ...this.pedidoPreparado,
                DejarPendiente: v_dejarPendiente
            };
            const v_resumenGeneraResumenBultos = await this.generaResumenBultos();
            if (typeof v_resumenGeneraResumenBultos === 'undefined') {
                this.pedidoPreparado = v_copiaPedidoPreparado;
                return;
            }
            let v_resultadoPideResumenBultos = await this.pideResumenBultos(v_resumenGeneraResumenBultos, v_dejarPendiente);
            if (typeof v_resultadoPideResumenBultos === 'undefined') {
                this.pedidoPreparado = v_copiaPedidoPreparado;
                return;
            }
            this.actualizaPreparadoConResumenBultos.apply(this, v_resultadoPideResumenBultos);
            if (v_dejarPendiente && this.pedidoPreparado.ImprimirEtiquetas) {
                const v_respuestaPregunta = await (0, componentes_1.pregunta)()
                    .opciones(['Albarán + Etiquetas', 'Albarán'])
                    .opcionPredeterminada('Albarán')
                    .muestra("Se está dejando el albarán en estado PENDIENTE.\n ¿Desea imprimir etiquetas o solo el albarán?");
                if (typeof v_respuestaPregunta !== 'undefined') {
                    let [v_indiceRespuestaPregunta] = v_respuestaPregunta;
                    if (v_indiceRespuestaPregunta === 1) {
                        this.pedidoPreparado = Object.assign(this.pedidoPreparado, {
                            ImprimirEtiquetas: false,
                        });
                    }
                }
            }
            let v_resultadoGeneraAlbaran = await this.generaAlbaran();
            if (typeof v_resultadoGeneraAlbaran === 'undefined') {
                this.pedidoPreparado = v_copiaPedidoPreparado;
                return;
            }
            if (typeof v_resultadoGeneraAlbaran.PREGUNTA_HIST === 'string' && v_resultadoGeneraAlbaran.PREGUNTA_HIST.length > 0) {
                const v_respuestaPregunta = await (0, componentes_1.pregunta)()
                    .cancelable(false)
                    .muestra(v_resultadoGeneraAlbaran.PREGUNTA_HIST);
                if (typeof v_respuestaPregunta !== 'undefined') {
                    const v_urls = ['/Expedicion/PonerHistorico', '/Expedicion/DejarActivo'], [v_dejarHistorico] = v_respuestaPregunta, v_url = v_urls[v_dejarHistorico];
                    await (0, api_1.api)(v_url)
                        .metodo('post')
                        .parametros({
                        EMPGRUPO_COD: this.pedidoPreparado.EMPGRUPO_COD,
                        EMP_COD: this.pedidoPreparado.EMP_COD,
                        GGPEDTIP_COD: this.pedidoPreparado.GGPEDTIP_COD,
                        N_PEDIDO: this.pedidoPreparado.N_PEDIDO
                    })
                        .invoca();
                }
            }
            (0, componentes_1.notificacion)().muestra(`Se ha generado el albarán ${v_resultadoGeneraAlbaran.GGALBTIP_COD}/${v_resultadoGeneraAlbaran.N_ALBARAN}`);
            this.inicializa();
        }
        async generaResumenBultos() {
            let v_resumenBultos;
            try {
                [v_resumenBultos] = await (0, api_1.api)('/Expedicion/ResumenBultos')
                    .metodo('put')
                    .parametros({
                    EMPGRUPO_COD: this.pedidoPreparado.EMPGRUPO_COD,
                    EMP_COD: this.pedidoPreparado.EMP_COD,
                    GGPEDTIP_COD: this.pedidoPreparado.GGPEDTIP_COD,
                    N_PEDIDO: this.pedidoPreparado.N_PEDIDO,
                    GGALBTIP_COD: this.pedidoPreparado.GGALBTIP_COD,
                    N_ALBARAN: this.pedidoPreparado.N_ALBARAN,
                    GGMENVIO_COD: this.pedidoPreparado.GGMENVIO_COD,
                    GGVEHICULO_COD: this.pedidoPreparado.GGVEHICULO_COD,
                    N_BULTOS: this.pedidoPreparado.N_BULTOS,
                    Bultos: this.pedidoPreparado.Bultos,
                    PESO: this.pedidoPreparado.PESO,
                    N_ETIQUETAS: this.pedidoPreparado.N_ETIQUETAS,
                    Lineas: this.pedidoPreparado.Lineas
                        .filter(p_linea => p_linea.C_PREP !== 0)
                        .map(p_linea => ({
                        N_LIN: p_linea.N_LIN,
                        C_UNI1: p_linea.C_UNI1,
                        Detalles: p_linea.Detalles
                            .filter(p_detalle => p_detalle.C_UNI1 !== null)
                            .map(p_detalle => ({
                            GAUBIC_COD: p_detalle.GAUBIC_COD,
                            LOTE: p_detalle.LOTE,
                            C_UNI1: p_detalle.C_UNI1
                        }))
                    })),
                    N_COPIAS: this.pedidoPreparado.N_COPIAS,
                    DejarPendiente: this.pedidoPreparado.DejarPendiente,
                    ImprimirValorado: this.pedidoPreparado.ImprimirValorado,
                    AlbaranValorado: this.pedidoPreparado.AlbaranValorado,
                    OPCION_ETIQUETAS: this.pedidoPreparado.OPCION_ETIQUETAS,
                    ImprimirEtiquetas: this.pedidoPreparado.ImprimirEtiquetas,
                })
                    .invoca();
            }
            catch ([v_mensaje]) {
                await (0, componentes_1.mensaje)().error().muestra(v_mensaje);
                return;
            }
            assert.esUn(v_resumenBultos);
            return v_resumenBultos;
        }
        async pideResumenBultos(p_resumenBultos, p_dejarPendiente) {
            let v_resultadoPideResumenBultos = await (0, componentes_1.dialogo)()
                .titulo(Resources.PantallaExpedicion.DialogoResumenBultos.Titulo)
                .plantilla('expedicion/dialogos/plantillas/dialogo-resumen-bultos')
                .construye(p_modal => new dialogo_resumen_bultos_1.DialogoResumenBultos(p_modal, {
                ...p_resumenBultos,
                GGMENVIO_COD: this.pedidoPreparado.GGMENVIO_COD,
                GGMENVIO_DES: this.pedidoPreparado.GGMENVIO_DES,
                GGVEHICULO_COD: this.pedidoPreparado.GGVEHICULO_COD,
                GGVEHICULO_DES: this.pedidoPreparado.GGVEHICULO_DES,
                AlbaranValorado: this.pedidoPreparado.AlbaranValorado,
            }, {
                mostrarAlbaranValorado: this.pedido.MostrarAlbaranValorado,
                mostrarCopias: p_dejarPendiente,
                detalleBultos: this.pedidoPreparado.Bultos,
                fechaAlbaran: this.pedidoPreparado.F_ALBARAN
            }))
                .abre();
            return v_resultadoPideResumenBultos;
        }
        async generaAlbaran() {
            let v_resultadoExpedir;
            try {
                [v_resultadoExpedir] = await (0, api_1.api)('/Expedicion/Expedir')
                    .metodo('post')
                    .parametros({
                    EMPGRUPO_COD: this.pedidoPreparado.EMPGRUPO_COD,
                    EMP_COD: this.pedidoPreparado.EMP_COD,
                    GGPEDTIP_COD: this.pedidoPreparado.GGPEDTIP_COD,
                    N_PEDIDO: this.pedidoPreparado.N_PEDIDO,
                    GGALBTIP_COD: this.pedidoPreparado.GGALBTIP_COD,
                    N_ALBARAN: this.pedidoPreparado.N_ALBARAN,
                    F_ALBARAN: moment.utc(this.pedidoPreparado.F_ALBARAN, 'DD/MM/YYYY').toISOString(true),
                    GGMENVIO_COD: this.pedidoPreparado.GGMENVIO_COD,
                    GGVEHICULO_COD: this.pedidoPreparado.GGVEHICULO_COD,
                    GGMENVIO_PED: this.pedidoPreparado.GGMENVIO_PED_COD,
                    GGVEHICULO_PED: this.pedidoPreparado.GGVEHICULO_PED_COD,
                    N_BULTOS: this.pedidoPreparado.N_BULTOS,
                    Bultos: this.pedidoPreparado.Bultos
                        .reduce((p_nuevosBultos, p_bulto) => {
                        p_nuevosBultos = p_nuevosBultos.concat(p_bulto.articulos.map(p_articulo => ({
                            N_BULTO: p_bulto.N_BULTO,
                            GAART_COD: p_articulo.GAART_COD,
                            GAART_DESCRIP: p_articulo.GAART_DESCRIP,
                            C_UNI1: p_articulo.CANTIDAD,
                            GGPEDLIN_N_LIN: p_articulo.N_LIN,
                            GVPALLETIP_COD: p_bulto.GVPALLETIP.COD,
                        })));
                        return p_nuevosBultos;
                    }, []),
                    PESO: this.pedidoPreparado.PESO,
                    N_ETIQUETAS: this.pedidoPreparado.N_ETIQUETAS,
                    Lineas: this.pedidoPreparado.Lineas
                        .filter(p_linea => typeof p_linea.C_PREP !== 'undefined')
                        .map(p_linea => ({
                        N_LIN: p_linea.N_LIN,
                        C_UNI1: p_linea.C_PREP,
                        Detalles: p_linea.Detalles
                            .filter(p_detalle => p_detalle.C_UNI1 !== null)
                            .map(p_detalle => ({
                            GAUBIC_COD: p_detalle.GAUBIC_COD,
                            LOTE: p_detalle.LOTE,
                            C_UNI1: p_detalle.C_UNI1
                        }))
                    })),
                    ImprimirEtiquetas: this.pedidoPreparado.ImprimirEtiquetas,
                    OPCION_ETIQUETAS: this.pedidoPreparado.OPCION_ETIQUETAS,
                    ImprimirValorado: this.pedidoPreparado.AlbaranValorado,
                    DejarPendiente: this.pedidoPreparado.DejarPendiente,
                    N_COPIAS: this.pedidoPreparado.N_COPIAS
                })
                    .invoca();
            }
            catch ([v_mensaje]) {
                await (0, componentes_1.mensaje)().error().muestra(v_mensaje);
                return;
            }
            assert.esUn(v_resultadoExpedir, 'GGALBTIP_COD', 'N_ALBARAN', 'PREGUNTA_HIST');
            return v_resultadoExpedir;
        }
        async obtenerLinea() {
            const v_lecturaArticulo = this.lecturaArticulo;
            const v_busqueda = this.tablaLineas.busca({ GAART_COD: v_lecturaArticulo });
            assert.esUnArrayDe(v_busqueda, "Indice");
            if (v_busqueda.length > 0) {
                this.tablaLineas.selecciona(v_busqueda[0].Indice, {});
                return;
            }
            let v_articulos;
            try {
                [v_articulos] = await (0, api_1.api)('/Articulo/Articulos')
                    .parametros({
                    empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                    emp_cod: sessionStorage.getItem("EMPR_COD"),
                    codigoBarras: v_lecturaArticulo
                })
                    .invoca();
            }
            catch ([v_mensaje]) {
                await (0, componentes_1.mensaje)().error().muestra(v_mensaje);
                return;
            }
            assert.esUnArrayDe(v_articulos, 'GAART_COD', 'GAART_DESCRIP');
            const v_articulosDelPedido = v_articulos.filter(p_articulo => this.pedido.Lineas.find(p_linea => p_linea.GAART_COD === p_articulo.GAART_COD));
            let v_gaart_cod;
            if (v_articulosDelPedido.length === 1) {
                v_gaart_cod = v_articulosDelPedido[0].GAART_COD;
            }
            else if (v_articulosDelPedido.length > 1) {
                const v_articulo = await (0, componentes_1.lov)()
                    .titulo(Resources.PantallaRecepcion.CodigosAlternativos.Lov.Titulo)
                    .columnas([
                    { propiedad: 'GAART_COD', titulo: Resources.PantallaRecepcion.CodigosAlternativos.Lov.Tabla.Codigo, ancho: '6em' },
                    { propiedad: 'GAART_DESCRIP', titulo: Resources.PantallaRecepcion.CodigosAlternativos.Lov.Tabla.Descripcion }
                ])
                    .elige(v_articulosDelPedido);
                if (typeof v_articulo !== 'undefined')
                    v_gaart_cod = v_articulo.GAART_COD;
            }
            if (v_gaart_cod) {
                const v_linea = this.tablaLineas.buscaYSelecciona({ GAART_COD: v_gaart_cod }, { seleccionaPrimero: true });
                if (typeof v_linea !== 'undefined')
                    return;
            }
            await (0, componentes_1.notificacion)().error().muestra('Referencia erronea o inexistente.');
            this.lecturaArticulo = null;
            this.lecturaCantidad = null;
            this.campoReferencia.foco();
        }
        async obtenerDatosTransporte(v_pedido) {
            let vResultadoDatosTransporte;
            if (v_pedido.DatosEnvioInicial) {
                vResultadoDatosTransporte = await this.pideDatosTransporte({
                    GGMENVIO_COD: v_pedido.GGMENVIO_COD,
                    GGMENVIO_DESCRIP: v_pedido.GGMENVIO_DESCRIP,
                    GGVEHICULO_COD: v_pedido.GGVEHICULO_COD,
                    GGVEHICULO_DESCRIP: v_pedido.GGVEHICULO_DESCRIP
                });
            }
            else {
                vResultadoDatosTransporte = {
                    GGMENVIO_COD: v_pedido.GGMENVIO_COD,
                    GGMENVIO_DESCRIP: v_pedido.GGMENVIO_DESCRIP,
                    GGVEHICULO_COD: v_pedido.GGVEHICULO_COD,
                    GGVEHICULO_DESCRIP: v_pedido.GGVEHICULO_DESCRIP,
                };
            }
            return vResultadoDatosTransporte;
        }
        async mostrarPantallaTransporteCortina() {
            const v_resultadoDatosTransporte = await this.pideDatosTransporte({
                GGMENVIO_COD: this.pedidoPreparado.GGMENVIO_PED_COD,
                GGMENVIO_DESCRIP: this.pedidoPreparado.GGMENVIO_PED_DES,
                GGVEHICULO_COD: this.pedidoPreparado.GGVEHICULO_PED_COD,
                GGVEHICULO_DESCRIP: this.pedidoPreparado.GGVEHICULO_PED_DES
            });
            if (typeof v_resultadoDatosTransporte === 'undefined')
                return;
            this.seleccionaDatosTransporte(v_resultadoDatosTransporte);
            this.actualizaVista();
        }
        async cambiaEstadoPedido(GGPEDTIP_COD, N_PEDIDO) {
            if (GGPEDTIP_COD && N_PEDIDO)
                try {
                    await (0, api_1.api)('/Expedicion/CambiaSalePedido')
                        .metodo("post")
                        .parametros({
                        empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                        emp_cod: sessionStorage.getItem("EMPR_COD"),
                        GGPEDTIP_COD: GGPEDTIP_COD,
                        N_PEDIDO: N_PEDIDO
                    })
                        .invoca();
                }
                catch ([v_mensaje]) {
                    await (0, componentes_1.mensaje)().error().muestra(v_mensaje);
                    return;
                }
        }
    }
    exports.PantallaExpedicion = PantallaExpedicion;
});
