import { Boton } from 'componentes/boton';
import { Campo } from 'componentes/campo';
import { Pantalla } from 'componentes/pantalla';
export type ArticuloInventario = {
    COD: string;
    DESCRIP: string;
    UBIC_SN: 'S' | 'N';
    LOTES_SN: 'S' | 'N';
    C_EXIST1: number;
    C_EXIST2: number;
};
type Articulo = {
    COD: string;
    DESCRIP: string;
};
type AlmacenInventario = {
    COD: string;
    DESCRIP: string;
};
type ExistenciasInventario = {
    C_EXIST1: number;
    C_EXIST2: number;
};
export type ModeloInventario = {
    EMP_COD: string;
    EMPGRUPO_COD: string;
    GAART_COD: string;
    GAART_DESCRIP: string;
    GAALMNOM_COD: string;
    GAALMNOM_DESCRIP: string;
    GAUBIC_COD: string;
    Lote: string;
    Existencias: number;
    Cantidad: number;
    ControlUbicaciones: 'S' | 'N';
    ControlLotes: 'S' | 'N';
};
export declare class PantallaInventario extends Pantalla {
    _botonNuevo: Boton;
    _botonConfirmar: Boton;
    _inputAlmacen: Campo;
    _inputArticulo: Campo;
    _inputArticuloDescrip: Campo;
    _inputUbicacion: Campo;
    _inputLote: Campo;
    _inputExistencias: Campo;
    _inputNuevas: Campo;
    _btnBuscaAlmacen: Boton;
    _btnArt: Boton;
    _btnUbic: Boton;
    _btnLote: Boton;
    protected _modelo: ModeloInventario;
    protected _loteUbicacionValido: boolean;
    constructor();
    protected asociaComponentes(): void;
    actualizaVista(): void;
    actualizaModelo(): void;
    protected inicializa(): void;
    protected inicializaComponentes(): {
        _botonNuevo: import("componentes/boton").DefinicionBoton;
        _botonConfirmar: import("componentes/boton").DefinicionBoton;
        _inputAlmacen: import("componentes/campo").DefinicionCampo;
        _btnBuscaAlmacen: import("componentes/boton").DefinicionBoton;
        _inputArticulo: import("componentes/campo").DefinicionCampo;
        _btnArt: import("componentes/boton").DefinicionBoton;
        _inputArticuloDescrip: import("componentes/campo").DefinicionCampo;
        _inputUbicacion: import("componentes/campo").DefinicionCampo;
        _btnUbic: import("componentes/boton").DefinicionBoton;
        _inputLote: import("componentes/campo").DefinicionCampo;
        _btnLote: import("componentes/boton").DefinicionBoton;
        _inputExistencias: import("componentes/campo").DefinicionCampo;
        _inputNuevas: import("componentes/campo").DefinicionCampo;
    };
    protected nuevo(): void;
    protected habilitarConfirmacion(): boolean;
    protected confirmar(): Promise<void>;
    lovArticulo(): Promise<void>;
    lovAlmacen(): Promise<void>;
    lovUbicacion(): Promise<void>;
    lovLote(): Promise<void>;
    protected obtenerArticulo(): Promise<ArticuloInventario>;
    protected obtenerArticulos(): Promise<Articulo[]>;
    protected obtenerExistencias(): Promise<ExistenciasInventario>;
    protected obtenerAlmacenes(): Promise<AlmacenInventario[]>;
    protected obtenerUbicaciones(): Promise<{
        COD: any;
    }[]>;
    protected obtenerLotes(): Promise<{
        COD: any;
    }[]>;
    protected obtenerAlmacen(): Promise<{
        COD: any;
    } & {
        DESCRIP: any;
    } & {
        GAUBIC_DEF: any;
    } & {
        LOTE_DEF: any;
    }>;
    protected obtenerUbicacion(): Promise<{
        COD: any;
    }>;
    protected cambioArticulo(): Promise<{
        COD: any;
    } & {
        DESCRIP: any;
    } & {
        GAUBIC_DEF: any;
    } & {
        LOTE_DEF: any;
    }>;
    protected confirmarInventario(): Promise<unknown[]>;
}
export {};
