import { DatosAdicionalesAlbaran } from 'Recepcion/dialogos/modelos/dialogo-datos-adicionales-albaran-modelo';
import { LineaPreparada } from 'Recepcion/dialogos/modelos/dialogo-lotes-ubicaciones-modelo';
import { Albaran } from 'Recepcion/modelos/albaran';
import { DatosPantalla } from 'Recepcion/modelos/pantalla_modelo';
import { Pedido, PedidoPreparado } from 'Recepcion/modelos/pedido';
import { PedidoLinea } from 'Recepcion/modelos/pedido_linea';
import { Bloque } from 'componentes/bloque';
import { Boton } from 'componentes/boton';
import { Campo } from 'componentes/campo';
import { Cortina } from 'componentes/cortina';
import { Pantalla } from 'componentes/pantalla';
import { Tabla } from 'componentes/tabla';
export declare class PantallaRecepcion extends Pantalla {
    _botonNuevo: Boton;
    _botonConfirmar: Boton;
    _inputPedido: Campo;
    _inputReferencia: Campo;
    _inputCantidad: Campo;
    _bloqueReferencia: Bloque;
    _tabla: Tabla<PedidoLinea>;
    _cortina: Cortina;
    _DatosPantalla: DatosPantalla;
    _Pedido: Pedido;
    _PedidoPreparado: PedidoPreparado;
    _LineaSeleccionada: PedidoLinea;
    constructor();
    asociaComponentes(): void;
    actualizaVista(): void;
    actualizaModelo(): void;
    inicializa(): void;
    inicializaComponentes(): {
        _botonNuevo: import("componentes/boton").DefinicionBoton;
        _botonConfirmar: import("componentes/boton").DefinicionBoton;
        _inputPedido: import("componentes/campo").DefinicionCampo;
        _inputReferencia: import("componentes/campo").DefinicionCampo;
        _inputCantidad: import("componentes/campo").DefinicionCampo;
        _bloqueReferencia: import("componentes/bloque").DefinicionBloque;
        _tabla: any;
    };
    generaCortina(): import("componentes/cortina").DefinicionCortina;
    nuevo(): void;
    ObtenerPedido(): Promise<void>;
    ObtenerAlbaranes(): Promise<Albaran>;
    protected cambiaReferencia(): Promise<boolean>;
    BuscarReferenciaEnTabla(Articulo: string): PedidoLinea[];
    dameArticulos(p_lectura: string): Promise<{
        GAART_COD: string;
        GAART_DESCRIP: string;
    }[]>;
    protected resuelveArticulo(p_lectura: string): Promise<{
        GAART_COD: string;
        GAART_DESCRIP: string;
    }>;
    BuscarCodigosAlternativos(Articulo: string): Promise<PedidoLinea[]>;
    protected completaLectura(p_lectura: string, p_seleccionado?: {
        GAART_COD: string;
        GAART_DESCRIP: string;
    }): Promise<{
        GAART_COD: string;
        GAART_DESCRIP: string;
    }>;
    protected seleccionaLinea(item: PedidoLinea): Promise<void>;
    ActualizaCantidadesPedido(pLineaSeleccionada: PedidoLinea, pResultadoSeleccionLinea: LineaPreparada): void;
    actualizaPreparadoArticuloSinLotesNiUbicaciones(pValor: number): Promise<void>;
    ObtenerDatosAdicionalesAlbaran(): Promise<DatosAdicionalesAlbaran>;
    recepcionar(): Promise<void>;
}
