import { Boton } from 'componentes/boton';
import { ComponenteHTML } from 'componentes/componente-html';
type NotificaCampo = 'con-pulsacion' | 'con-pulsacion-retrasada' | 'al-validar';
type TiposCampo = string | number | Date | boolean;
type ManejadorCambioCampo = (p_valor: TiposCampo) => void;
type ManejadorValidaCampo = (p_validacion: {
    nuevoValor: TiposCampo;
    valorAnterior: TiposCampo;
    valorHaCambiado: boolean;
}) => void;
type ManejadorLovCampo = () => Promise<boolean>;
export declare class DefinicionCampo extends ComponenteHTML {
    private _valores;
    constructor(_elemento: HTMLElement, _valores: {
        cambio?: ManejadorCambioCampo;
        valida?: ManejadorValidaCampo;
        notifica?: NotificaCampo;
        lov?: ManejadorLovCampo;
    });
    cambio(p_funcion: ManejadorCambioCampo): DefinicionCampo;
    cambio(): ManejadorCambioCampo;
    valida(p_funcion: ManejadorValidaCampo): DefinicionCampo;
    valida(): ManejadorValidaCampo;
    notifica(p_notifica: NotificaCampo): DefinicionCampo;
    notifica(): NotificaCampo;
    lov(p_funcion: ManejadorLovCampo): DefinicionCampo;
    lov(): ManejadorLovCampo;
    crea(): Campo;
    creaAsincrono(): Promise<Campo>;
}
export declare class Campo extends ComponenteHTML {
    private _valores;
    private _botonLov?;
    private _valorAnterior;
    constructor(_elemento: HTMLInputElement | HTMLTextAreaElement, _valores: {
        cambio?: ManejadorCambioCampo;
        valida?: ManejadorValidaCampo;
        notifica?: NotificaCampo;
        lov?: () => Promise<boolean>;
    }, _botonLov?: Boton);
    valor(p_valor?: TiposCampo): string | number | boolean;
    foco(): this;
    deshabilita(): this;
    habilita(): this;
    habilitado(p_valor: boolean): boolean;
    visible(p_valor: boolean): boolean;
}
export declare function campo(p_elemento: HTMLElement | string): DefinicionCampo;
export {};
