declare class FormateadorCelda {
    constructor(p_td: any);
    fondo(p_color: any): void;
}
type ColumnaTabla = {
    propiedad: string;
    titulo: string;
    ancho?: string;
    numerico?: boolean;
    alineacion?: 'centro' | 'derecha' | 'izquierda';
    editable?: boolean;
    cambio?: (p_valor?: any) => void;
    formatoCelda?: (p_celda: FormateadorCelda, p_objeto: any, p_propiedad: string, p_valor: any) => void;
    tipoDato?: <Type>(type: Type) => void;
    className?: string;
    orden?: 'asc' | 'desc';
    ordenColumnas?: string[];
    visible?: boolean;
};
type ManejadorSeleccionadoTabla<T> = (p_seleccionado: T) => void;
export declare class DefinicionTabla<T = unknown> {
    private _selectorTabla;
    private _valores;
    constructor(_selectorTabla: string, _valores: any);
    datos<U>(p_datos: U[]): DefinicionTabla<U>;
    datos(): T[];
    columnas(p_columnas: ColumnaTabla[]): DefinicionTabla<T>;
    columnas(): ColumnaTabla[];
    opciones(p_opciones: any): any;
    filtro(p_filtro: any): any;
    seleccionado(p_seleccionado: ManejadorSeleccionadoTabla<T>): DefinicionTabla<T>;
    seleccionado(): ManejadorSeleccionadoTabla<T>;
    formatoFila(p_formato: any): any;
    crea(): Tabla<T>;
}
export declare class Tabla<T = unknown> {
    private _selectorTabla;
    private _valores;
    private _arrayDatos;
    private readonly _nuevasFunciones;
    private _funcionesSuplantadas;
    private _dataTable;
    constructor(_selectorTabla: any, _valores: any);
    datos(p_datos: T[], extraRowFormatCallback?: any): this;
    refresca(): void;
    filtro(p_filtro: any): void;
    seleccionado(): T;
    ocultarColumna(propiedad: string): void;
    mostrarColumna(propiedad: string): void;
    visualizarColumna(propiedad: string, visible: boolean): void;
    busca(p_objeto: any): T[];
    selecciona(p_argumento: any, p_opciones: any): void;
    buscaYSelecciona(p_objeto: any, p_opciones: any): T[];
    editable(p_editable: any): any;
    configuraEditorCelda(p_td: any, p_celda: any): void;
    private static readonly _botones;
    private static _generateColumn;
    private static _creaColumnasDataTable;
    private static _creaDefinicionesDataTable;
}
export declare function tabla<T = unknown>(p_elemento: HTMLElement | string): DefinicionTabla<T>;
export {};
