define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.DatosAlmacen = void 0;
    class DatosAlmacen {
        constructor(init) {
            this._empgrupo_cod = sessionStorage.getItem("EMPRGRUP_COD");
            this._emp_cod = sessionStorage.getItem("EMPR_COD");
            this._MOSTRAR_LOTE_DES = false;
            this._GAALMNOM_DES_UNICO = false;
            this._articulo = null;
            this._almacen = null;
            this._AlmacenDefecto = null;
            this._ubicacion = null;
            this._lote = null;
            this._ControlUbicaciones = false;
            this._ControlLotes = false;
            Object.assign(this, init);
        }
        get Grupo() {
            return this._empgrupo_cod;
        }
        get Empresa() {
            return this._emp_cod;
        }
        set GAALMNOM_DES_UNICO(value) {
            this._GAALMNOM_DES_UNICO = value;
        }
        get GAALMNOM_DES_UNICO() {
            return this._GAALMNOM_DES_UNICO;
        }
        set MOSTRAR_LOTE_DES(value) {
            this._MOSTRAR_LOTE_DES = value;
        }
        get MOSTRAR_LOTE_DES() {
            return this._MOSTRAR_LOTE_DES;
        }
        get Articulo() {
            return this._articulo;
        }
        set Articulo(value) {
            this._articulo = value;
        }
        get Almacen() {
            return this._almacen;
        }
        set Almacen(value) {
            this._almacen = value;
        }
        get AlmacenDefecto() {
            return this._AlmacenDefecto;
        }
        set AlmacenDefecto(value) {
            this._AlmacenDefecto = value;
        }
        get Ubicacion() {
            return this._ubicacion;
        }
        set Ubicacion(value) {
            this._ubicacion = value;
            this._lote = null;
        }
        get Lote() {
            return this._lote;
        }
        set Lote(value) {
            this._lote = value;
        }
        get ControlUbicaciones() {
            return this._ControlUbicaciones;
        }
        set ControlUbicaciones(value) {
            this._ControlUbicaciones = value;
        }
        get ControlLotes() {
            return this._ControlLotes;
        }
        set ControlLotes(value) {
            this._ControlLotes = value;
        }
        get ModeloValido() {
            if (!this._almacen)
                return false;
            if (this.ControlLotes && !this.Lote)
                return false;
            if (this.ControlUbicaciones && !this.Ubicacion)
                return false;
            return true;
        }
    }
    exports.DatosAlmacen = DatosAlmacen;
});
