define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.esUn = exports.esUnArrayDe = exports.assert = void 0;
    function assert(p_condicion, p_mensaje = 'No se cumple la afirmación') {
        if (!p_condicion) {
            throw new Error(p_mensaje);
        }
    }
    exports.assert = assert;
    function esUnArrayDe(p_valor, ...p_propiedades) {
        if (!Array.isArray(p_valor))
            throw new Error('No es un array');
        p_valor.every(p => esUn(p, ...p_propiedades));
    }
    exports.esUnArrayDe = esUnArrayDe;
    function esUn(p_valor, ...p_propiedades) {
        if (!p_propiedades.every(p_propiedad => p_propiedad in p_valor))
            throw new Error(`No tiene ${p_propiedades.filter(p_propiedad => !(p_propiedad in p_valor)).join(', ')}`);
    }
    exports.esUn = esUn;
});
