define(["require", "exports", "componentes/mensaje"], function (require, exports, mensaje_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.api = void 0;
    class Api {
        constructor(_url, _metodo, _parametros, _ok, _error, _loguea) {
            this._url = _url;
            this._metodo = _metodo;
            this._parametros = _parametros;
            this._ok = _ok;
            this._error = _error;
            this._loguea = _loguea;
        }
        url(p_url) {
            if (arguments.length === 1) {
                if (typeof p_url !== 'string')
                    throw new Error('No es una url no válida');
                return new Api(p_url, this._metodo, this._parametros, this._ok, this._error, this._loguea);
            }
            else
                return this.url;
        }
        metodo(p_metodo) {
            if (arguments.length === 1) {
                if (typeof p_metodo !== 'string')
                    throw new Error('No es un método no válido');
                return new Api(this._url, p_metodo, this._parametros, this._ok, this._error, this._loguea);
            }
            else
                return this._metodo;
        }
        ;
        parametros(p_parametros) {
            if (arguments.length === 1) {
                return new Api(this._url, this._metodo, p_parametros, this._ok, this._error, this._loguea);
            }
            else
                return this._parametros;
        }
        ;
        ok(p_funcion) {
            if (typeof p_funcion !== 'function')
                throw new Error('No es una función');
            return new Api(this._url, this._metodo, this._parametros, p_funcion, this._error, this._loguea);
        }
        ;
        error(p_funcion) {
            if (typeof p_funcion !== 'function')
                throw new Error('No es una función');
            return new Api(this._url, this._metodo, this._parametros, this._ok, p_funcion, this._loguea);
        }
        ;
        loguea(p_funcion) {
            if (typeof p_funcion !== 'function')
                throw new Error('No es una función');
            return new Api(this._url, this._metodo, this._parametros, this._ok, this._error, p_funcion);
        }
        invoca() {
            let v_promesa = new Promise((p_resuelve, p_rechaza) => {
                apiGeneral(this._url, this._metodo.toUpperCase(), this._parametros, function (p_respuesta) {
                    if (p_respuesta.Ok)
                        p_resuelve([p_respuesta.Objeto, p_respuesta.Mensaje]);
                    else
                        p_rechaza([p_respuesta.Mensaje, p_respuesta.Objeto]);
                }, this._loguea);
            });
            if (typeof this._ok === 'function' && typeof this._error === 'function') {
                v_promesa = v_promesa
                    .then(([p_resultado, p_mensaje]) => { this._ok(p_resultado, p_mensaje); })
                    .catch(([p_mensaje, p_resultado]) => { this._error(p_mensaje, p_resultado); });
            }
            else
                return v_promesa;
        }
        ;
    }
    function api(p_url) {
        const v_errorPredeterminado = async function (p_mensaje, p_resultado) {
            await (0, mensaje_1.mensaje)().error().muestra(p_mensaje);
        };
        return new Api(p_url, 'get', {}, void 0, v_errorPredeterminado);
    }
    exports.api = api;
});
