define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.bloque = exports.Bloque = exports.DefinicionBloque = void 0;
    class DefinicionBloque {
        constructor(_elemento) {
            this._elemento = _elemento;
        }
        crea() {
            return new Bloque(this._elemento);
        }
    }
    exports.DefinicionBloque = DefinicionBloque;
    class Bloque {
        constructor(_elemento) {
            this._elemento = _elemento;
        }
        visible(p_valor) {
            if (arguments.length === 0)
                return !this._elemento.classList.contains('oculto');
            else if (p_valor)
                this._elemento.classList.remove('oculto');
            else
                this._elemento.classList.add('oculto');
        }
        clase(p_clase, p_activa) {
            if (p_activa)
                this._elemento.classList.add(p_clase);
            else
                this._elemento.classList.remove(p_clase);
        }
        elemento() {
            return this._elemento;
        }
    }
    exports.Bloque = Bloque;
    function bloque(p_elemento) {
        const v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento);
        return new DefinicionBloque(v_elemento, {});
    }
    exports.bloque = bloque;
});
