define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.manejadorTeclado = void 0;
    class ManejadorTeclado {
        constructor() {
            this._contextos = [];
            this._manejador = {
                handleEvent: (p_evento) => {
                    const v_contexto = this._contextos[this._contextos.length - 1];
                    const v_opcionesTecla = v_contexto[p_evento.key];
                    if (typeof v_opcionesTecla === 'undefined')
                        return;
                    if (p_evento.key === 'Enter' && (document.activeElement instanceof HTMLInputElement || document.activeElement instanceof HTMLSelectElement))
                        return;
                    v_opcionesTecla.accion();
                    p_evento.preventDefault();
                }
            };
        }
        captura(p_tecla, p_elemento, p_accion) {
            if (this._contextos.length === 0)
                this.iniciaContexto();
            let v_contenedor = document.createElement('div');
            v_contenedor = p_elemento.parentNode.insertBefore(v_contenedor, p_elemento);
            v_contenedor.appendChild(p_elemento);
            const v_contexto = this._contextos[this._contextos.length - 1];
            v_contexto[p_tecla] = { elemento: v_contenedor, accion: p_accion };
            v_contenedor.classList.add('con-tecla');
            const v_tecla = p_tecla.replace(/([a-z])([A-Z])/g, "$1-$2").toLowerCase();
            v_contenedor.classList.add(`tecla-${v_tecla}`);
            p_elemento.classList.add('focusable');
        }
        iniciaContexto() {
            if (this._contextos.length === 0)
                document.addEventListener('keydown', this._manejador);
            this._contextos.push({});
        }
        finalizaContexto() {
            this._contextos.pop();
            if (this._contextos.length === 0)
                document.removeEventListener('keydown', this._manejador);
        }
    }
    exports.manejadorTeclado = new ManejadorTeclado();
});
