define(["require", "exports", "componentes/--plantilla", "componentes/componente", "componentes/bloque", "componentes/label", "componentes/boton", "componentes/campo", "componentes/casilla-verificacion", "componentes/tabla", "componentes/foco", "componentes/manejador-teclado", "Utilidades/utilidades", "componentes/componente-html"], function (require, exports, __plantilla_1, componente_1, bloque_1, label_1, boton_1, campo_1, casilla_verificacion_1, tabla_1, foco_1, manejador_teclado_1, utilidades_1, componente_html_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.modal = exports.Modal = exports.DefinicionModal = void 0;
    class DefinicionModal extends componente_html_1.ComponenteHTML {
        constructor(_elemento, _valores) {
            super(_elemento);
            this._valores = _valores;
        }
        titulo(p_titulo) {
            return new DefinicionModal(this._elemento, { ...this._valores, titulo: p_titulo });
        }
        estilos(p_estilos) {
            return new DefinicionModal(this._elemento, { ...this._valores, estilos: p_estilos });
        }
        cancelable(p_cancelable) {
            return new DefinicionModal(this._elemento, { ...this._valores, cancelable: p_cancelable });
        }
        construye(p_construye) {
            return new DefinicionModal(this._elemento, { ...this._valores, construye: p_construye });
        }
        async abre() {
            const v_elementoEnFoco = foco_1.foco.en();
            document.activeElement.blur();
            const v_estilos = { titulo: 'info', ...this._valores.estilos };
            const v_plantillaModal = await (0, __plantilla_1.plantilla)().nombre('componentes/modal.pp.html').carga({ estiloTitulo: v_estilos.titulo });
            const v_renderizado = v_plantillaModal.renderiza();
            const v_contenido = v_renderizado.documento().getElementById('cuerpo');
            v_contenido.appendChild(this._elemento);
            const v_id = 'modal-' + (0, utilidades_1.generaSecuencia)();
            const v_insertado = v_renderizado.inserta({ prefijoId: v_id });
            const v_promesa = new Promise((p_resuelve, p_rechaza) => {
                function combina(a, b) {
                    return (p_resultado) => {
                        a(p_resultado);
                        b(p_resultado);
                    };
                }
                let v_resuelve = p_resuelve;
                if (!v_insertado.elemento().classList.contains('fade')) {
                    v_resuelve = combina(() => { v_insertado.elemento().classList.remove('fade'); }, v_resuelve);
                }
                $('#' + v_insertado.elemento().id).on('shown.bs.modal', () => setTimeout(() => foco_1.foco.enPrimero(this._elemento), 0));
                showDialog('#' + v_insertado.elemento().id);
                const v_modal = new Modal(v_insertado, v_resuelve, this._valores.titulo, v_elementoEnFoco, this._valores.cancelable);
                const v_controlador = this._valores.construye(v_modal);
                if (typeof v_controlador !== 'undefined' && typeof v_controlador.actualizaVista === 'function')
                    v_controlador.actualizaVista();
            });
            return v_promesa;
        }
    }
    exports.DefinicionModal = DefinicionModal;
    class Modal extends componente_html_1.ComponenteHTML {
        constructor(_insertado, _resuelve, _titulo, _elementoEnFoco, _cancelable) {
            super(_insertado.elemento());
            this._insertado = _insertado;
            this._resuelve = _resuelve;
            this._titulo = _titulo;
            this._elementoEnFoco = _elementoEnFoco;
            this._cancelable = _cancelable;
            manejador_teclado_1.manejadorTeclado.iniciaContexto();
            this._etiquetaTitulo = this.etiqueta('titulo')
                .texto(this._elemento.dataset.titulo)
                .crea();
            this._botonCerrar = this.boton('cerrar')
                .clic(() => this.cierra())
                .tecla('Escape')
                .crea();
            this.titulo(_titulo);
            this.cancelable(_cancelable);
            foco_1.foco.enPrimero(this._elemento);
        }
        componente(p_elemento) { return (0, componente_1.componente)(`${this._elemento.id}.${p_elemento}`); }
        bloque(p_elemento) { return (0, bloque_1.bloque)(`${this._elemento.id}.${p_elemento}`); }
        etiqueta(p_elemento) { return (0, label_1.label)(`${this._elemento.id}.${p_elemento}`); }
        boton(p_elemento) { return (0, boton_1.boton)(`${this._elemento.id}.${p_elemento}`, { contenedor: this }); }
        campo(p_elemento) { return (0, campo_1.campo)(`${this._elemento.id}.${p_elemento}`); }
        casillaVerificacion(p_elemento) { return (0, casilla_verificacion_1.casillaVerificacion)(`${this._elemento.id}.${p_elemento}`); }
        tabla(p_elemento) { return (0, tabla_1.tabla)(`${this._elemento.id}.${p_elemento}`); }
        label(p_elemento) { return this.etiqueta(p_elemento); }
        input(p_elemento) { return this.campo(p_elemento); }
        check(p_elemento) { return this.casillaVerificacion(p_elemento); }
        cierra(p_resultado) {
            $('#' + this._elemento.id)
                .on('hidden.bs.modal', () => {
                this._resuelve(p_resultado);
                this._insertado.suprime();
                foco_1.foco.enSiguienteA(this._elementoEnFoco);
                manejador_teclado_1.manejadorTeclado.finalizaContexto();
            })
                .modal('hide');
        }
        titulo(p_titulo) {
            this._etiquetaTitulo.texto(p_titulo);
        }
        cancelable(p_cancelable) {
            if (arguments.length === 0)
                return this._botonCerrar.visible();
            else
                return this._botonCerrar.visible(p_cancelable);
        }
        capturaTecla(p_tecla, p_elemento, p_manejador) {
            manejador_teclado_1.manejadorTeclado.captura(p_tecla, p_elemento, p_manejador);
        }
        id() {
            return this._elemento.id;
        }
    }
    exports.Modal = Modal;
    function modal(p_elemento) {
        const v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento);
        if (v_elemento === null)
            throw new Error('No es un elemento válido');
        return new DefinicionModal(v_elemento, {
            titulo: void 0,
            cancelable: true,
            construye: p_modal => { },
            estilos: {}
        });
    }
    exports.modal = modal;
});
