define(["require", "exports", "componentes/componentes", "expedicion/dialogos/js/dialogo-detalle-bulto"], function (require, exports, componentes_1, dialogo_detalle_bulto_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.DialogoConsultaBultos = void 0;
    class DialogoConsultaBultos {
        constructor(_modal, p_bultos) {
            this._modal = _modal;
            this._bultos = p_bultos.map(p_bulto => ({
                N_BULTO: p_bulto.N_BULTO,
                GVPALLETIP_COD: p_bulto.GVPALLETIP.COD,
                GVPALLETIP_DESCRIP: p_bulto.GVPALLETIP.DESCRIP,
                CANTIDAD: p_bulto.articulos.map(p_articulo => p_articulo.CANTIDAD).reduce((p_total, p_cantidad) => p_total + p_cantidad, 0),
                articulos: p_bulto.articulos
            }));
            this._tabla = _modal.tabla('bultos')
                .seleccionado(this.seleccionaBulto.bind(this))
                .datos(this._bultos)
                .columnas([
                { propiedad: 'N_BULTO', titulo: Resources.PantallaExpedicion.DialogoConsultaBultos.Tabla.Columnas.Numero, ancho: '2em', numerico: true },
                { propiedad: 'GVPALLETIP_COD', titulo: Resources.PantallaExpedicion.DialogoConsultaBultos.Tabla.Columnas.Bulto, ancho: '3em' },
                { propiedad: 'GVPALLETIP_DESCRIP', titulo: Resources.PantallaExpedicion.DialogoConsultaBultos.Tabla.Columnas.Descripcion, ancho: 'auto' },
                { propiedad: 'CANTIDAD', titulo: Resources.PantallaExpedicion.DialogoConsultaBultos.Tabla.Columnas.Cantidad, ancho: '6em', numerico: true, },
            ])
                .crea();
            this._botonDetalles = _modal.boton('detalles')
                .clic(this.detalles.bind(this))
                .tecla('Enter')
                .crea();
        }
        seleccionaBulto(p_bulto) {
            this._seleccionado = p_bulto;
            this.actualizaVista();
        }
        actualizaVista() {
            this._tabla.datos(this._bultos);
            this._botonDetalles.habilitado(typeof this._seleccionado !== 'undefined');
        }
        async detalles() {
            const v_seleccionado = this._seleccionado;
            await (0, componentes_1.dialogo)()
                .titulo(Resources.PantallaExpedicion.DialogoDetalleBulto.Titulo)
                .plantilla('expedicion/dialogos/plantillas/dialogo-detalle-bulto')
                .construye(p_modal => new dialogo_detalle_bulto_1.DialogoDetalleBulto(p_modal, v_seleccionado))
                .abre();
        }
    }
    exports.DialogoConsultaBultos = DialogoConsultaBultos;
});
