define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.DialogoDetalleBulto = void 0;
    class DialogoDetalleBulto {
        constructor(_modal, p_bulto) {
            this._modal = _modal;
            this._tabla = _modal.tabla('detalle')
                .datos(p_bulto.articulos)
                .columnas([
                { propiedad: 'GAART_COD', titulo: Resources.PantallaExpedicion.DialogoDetalleBulto.Tabla.Columnas.Codigo, ancho: 'auto' },
                { propiedad: 'GAART_DESCRIP', titulo: Resources.PantallaExpedicion.DialogoDetalleBulto.Tabla.Columnas.Descripcion, ancho: 'auto' },
                { propiedad: 'CANTIDAD', titulo: Resources.PantallaExpedicion.DialogoDetalleBulto.Tabla.Columnas.Cantidad, ancho: '6em', numerico: true, },
            ])
                .crea();
            this._botonAceptar = _modal.boton('aceptar')
                .clic(this.acepta.bind(this))
                .tecla('Enter')
                .crea();
        }
        acepta() {
            this._modal.cierra();
        }
    }
    exports.DialogoDetalleBulto = DialogoDetalleBulto;
});
