﻿
var _scannerIsRunning = false;
var _scannerFromInput;
var hold = false;
function setHold() {
    hold = !hold;
    if (hold) {
        startScanner();
        hold = false;
    }
}
function cameraFunction() {
    var v_cameraInputs = "input:enabled";
    var timeoutId = 0;
    
    $("html").on("touchstart mousedown", v_cameraInputs, function (e) {
        timeoutId = setTimeout(setHold, 1500);
        _scannerFromInput = $(this);
    }).on("touchend mouseup", v_cameraInputs, function () {
        clearTimeout(timeoutId);
    });
    
    $('#cameraDialog .close, #cameraClose').on('click', function (e) {
        Quagga.stop();
        closeModal($('#cameraDialog'));
        e.preventDefault();
    });
}

function startScanner() {
    showDialog('#cameraDialog');
    var v_width = $('#cameraDialog .modal-body').width() - 20;
    closeModal($('#cameraDialog'));
    Quagga.init({
        inputStream: {
            name: "Live",
            type: "LiveStream",
            target: document.querySelector('#cameraContainer'),
            constraints: {
                audio: false,
                width: v_width,
                height: $('#cameraDialog .modal-body').innerHeight() - 70
            }
        },
        decoder: {
            readers: [
                "code_128_reader",
                "ean_reader",
                "ean_8_reader",
                "code_39_reader",
                "code_39_vin_reader",
                "codabar_reader",
                "upc_reader",
                "upc_e_reader",
                "i2of5_reader"
            ],
            debug: {
                showCanvas: true,
                showPatches: true,
                showFoundPatches: true,
                showSkeleton: true,
                showLabels: true,
                showPatchLabels: true,
                showRemainingPatchLabels: true,
                boxFromPatches: {
                    showTransformed: true,
                    showTransformedBox: true,
                    showBB: true
                }
            }
        }

    }, function (err) {
        if (err) {
            return
        }
        Quagga.start();
        showDialog('#cameraDialog');
        // Set flag to is running
        _scannerIsRunning = true;
    });
    Quagga.onProcessed(function (result) {
        var drawingCtx = Quagga.canvas.ctx.overlay,
        drawingCanvas = Quagga.canvas.dom.overlay;

        if (result) {
            if (result.boxes) {
                drawingCtx.clearRect(0, 0, parseInt(drawingCanvas.getAttribute("width")), parseInt(drawingCanvas.getAttribute("height")));
                result.boxes.filter(function (box) {
                    return box !== result.box;
                }).forEach(function (box) {
                    Quagga.ImageDebug.drawPath(box, { x: 0, y: 1 }, drawingCtx, { color: "green", lineWidth: 2 });
                });
            }

            if (result.box) {
                Quagga.ImageDebug.drawPath(result.box, { x: 0, y: 1 }, drawingCtx, { color: "#00F", lineWidth: 2 });
            }

            if (result.codeResult && result.codeResult.code) {
                Quagga.ImageDebug.drawPath(result.line, { x: 'x', y: 'y' }, drawingCtx, { color: 'red', lineWidth: 3 });
            }
        }
    });


    Quagga.onDetected(function (result) {
        _scannerFromInput.val(result.codeResult.code);
        var e = jQuery.Event("keypress");
        e.which = 13;
        _scannerFromInput.trigger(e);
        Quagga.stop();
        closeModal($('#cameraDialog'));
    });
}