﻿$(document).ready(function () {
    class CONFIG {
        constructor() {
            this.init();
        }
        init() {
            this.GGPEDTIP_COD = "";
            this.N_PEDIDO = "";
            this.GGCLIPR_COD = "";
            this.GGCLIPR_NOMBRE = "";
            this.DOCTIP = "";
            this.OPCION = "";
            this.PROGRAMA = $(txtPrograma).val();
        }
    }

    // Elementos
    var btnNuevo = document.getElementById('btnNuevo');
    var btnConfirmar = document.getElementById('btnConfirmar');
    var txtPedido = document.getElementById('txtPedido');
    var txtCliente = document.getElementById('txtCliente');
    var tipo = document.getElementById('tipo');
    var txtPrograma = document.getElementById('txtPrograma'); 
    var config = new CONFIG();

    init();
    var table = $('#tablaArticulos').DataTable();

    // Eventos
    addChangeEvent(tipo, tipoChange);
    addEvent(btnConfirmar, 'click', confirmarEtiquetas);
    addEvent(btnNuevo, 'click', limpiarCampos);

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$(txtPedido).keypress(function (e) { if (e.which === 13) getPedido(); });
    $(txtPedido).on("change", function (e) { getPedido(); });

    function init() {
        initializeTable();
        //opcionesImpresion();
    }

    function opcionesImpresion() {
        var url = 'Etiquetas/OpcionesImpresionPedido';
        var method = 'GET';
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            programa: config.PROGRAMA,
            GGPEDTIP_COD: config.GGPEDTIP_COD,
            n_pedido: config.N_PEDIDO
        };

        var success = function (response) {
            var Ok = function () {
                $(tipo).empty();
                $.each(response.Objeto, function (i, Obj) {
                    $(tipo).append($('<option>', {
                        value: Obj.OPCION,
                        text: Obj.OPCION,
                        DOCTIP: Obj.DOCTIP
                    }));
                });
                $(tipo).trigger('change');
            };
            handleResponse(response, Ok);
        };
        apiGeneral(url, method, data, success);
    }
    function initializeTable() {
        var columns = [
            generateColumn('GAART_COD', 'Cod'),
            generateColumn('GAART_DESCRIP', 'Descrip.'),
            generateColumn('C_UNI1', 'Cant.', true, true)
        ];
        var columnDefs = [
            { "width": "5em", "targets": 0 },
            { "width": "4em", "targets": 2 }
        ];
        createTableJson('#tablaArticulos', null, columns, null, null, columnDefs, false);
    }

    function tipoChange() {
        config.DOCTIP = $(tipo).find(':selected').attr('doctip');
        config.OPCION = $(tipo).val();
    }

    function getPedido() {
        var url = 'Etiquetas/Pedido';
        var method = 'GET';
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            lectura_pedido: $(txtPedido).val()
        };
        var success = function (response) {
            var Ok = function () {
                table.clear().draw();
                config.GGPEDTIP_COD = response.Objeto.GGPEDTIP_COD;
                config.N_PEDIDO = response.Objeto.N_PEDIDO;
                config.GGCLIPR_COD = response.Objeto.GGCLIPR_COD;
                config.GGCLIPR_NOMBRE = response.Objeto.GGCLIPR_NOMBRE;
                $(txtCliente).val(response.Objeto.GGCLIPR_NOMBRE);
                table.rows.add(response.Objeto.Lineas).draw();

                opcionesImpresion();
            };
            var error = function () {
                limpiarPedido();
            };
            handleResponse(response, Ok, error);
        };
        apiGeneral(url, method, data, success);
    }

    function confirmarEtiquetas() {
        var url = "Etiquetas/ImprimirPedido";
        var method = "PUT";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            PROGRAMA: config.PROGRAMA,
            GGPEDTIP_COD: config.GGPEDTIP_COD,
            N_PEDIDO: config.N_PEDIDO,
            DOCTIP: config.DOCTIP,
            OPCION: config.OPCION
        };
        var success = function (response) {
            var Ok = function () {
                limpiarCampos();
            };
            handleResponse(response, Ok);
        };
        apiGeneral(url, method, data, success);
    }

    function limpiarPedido() {
        config.init();
        $(txtCliente).val("");
        $(tipo).prop("selectedIndex", 0);
        $(tipo).trigger('change');
        table.clear().draw();
        $(txtPedido).focus().select();
    }

    function limpiarCampos() {
        $(txtPedido).val("");
        limpiarPedido();
    }
});