define(["require", "exports", "componentes/api", "componentes/componentes", "componentes/foco", "componentes/boton", "componentes/campo", "componentes/bloque", "componentes/label", "componentes/desplegable", "componentes/pantalla", "lib/moment/moment"], function (require, exports, api_1, componentes_1, foco_1, boton_1, campo_1, bloque_1, label_1, desplegable_1, pantalla_1, moment) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PantallaEtiquetas = void 0;
    var campos = [];
    const v_mapaDeTipos = {
        CHAR: 'text',
        NUM: 'number',
        FEC: 'date'
    };
    class PantallaEtiquetas extends pantalla_1.Pantalla {
        constructor() {
            super();
            this.inicializa();
            this.asociaComponentes();
            this.opcionesImpresion();
        }
        inicializaComponentes() {
            foco_1.foco.enPrimero(document);
            const vComponentes = {
                _txtArt: (0, campo_1.campo)('txtArtRef')
                    .cambio(async () => {
                    this.actualizaModelo();
                    await this.obtenerArticulo();
                    this.actualizaVista();
                })
                    .notifica('al-validar'),
                _txtArtDescrip: (0, campo_1.campo)('txtArtDescrip')
                    .cambio(() => {
                    this.actualizaModelo();
                }),
                _txtCopias: (0, campo_1.campo)('txtCopias')
                    .cambio(() => {
                    this.actualizaModelo();
                })
                    .valida(() => {
                    foco_1.foco.en(this._tipo);
                }),
                _txtPrograma: (0, campo_1.campo)('txtPrograma')
                    .cambio(() => {
                    this.actualizaModelo();
                }),
                _tipo: (0, desplegable_1.desplegable)('tipo').cambio(() => {
                }),
                _btnConfirmar: (0, boton_1.boton)('btnConfirmar')
                    .clic(async () => {
                    let ok = await this.confirmarEtiquetas();
                    if (ok) {
                        await (0, componentes_1.notificacion)().muestra("Correcto");
                        this.inicializa();
                    }
                    this.actualizaVista();
                })
            };
            return vComponentes;
        }
        asociaComponentes() {
            const v_componentes = this.inicializaComponentes();
            Object.getOwnPropertyNames(v_componentes).forEach(pNombre => this[pNombre] = v_componentes[pNombre].crea());
            this.actualizaVista();
            return;
        }
        inicializa() {
            this._camposEtiquestas = {
                Articulo: "",
                Descripcion: "",
                Ubic: "",
                UbicTemp: "",
                Date: "",
                Copias: "",
                PlaceHolder: "",
                Programa: ""
            };
            this.inicioEtiquetas();
            if (this._tipo != null)
                this._tipo.obtenElemento().selectedIndex = 0;
        }
        actualizaVista() {
            this._txtArt.valor(this._camposEtiquestas.Articulo);
            this._txtArtDescrip.valor(this._camposEtiquestas.Descripcion);
            this._txtCopias.valor(this._camposEtiquestas.Copias);
            this._txtPrograma.valor(this._camposEtiquestas.Programa);
        }
        actualizaModelo() {
            this._camposEtiquestas.Articulo = this._txtArt.valor();
            this._camposEtiquestas.Descripcion = this._txtArtDescrip.valor();
            this._camposEtiquestas.Copias = this._txtCopias.valor();
            this._camposEtiquestas.Programa = this._txtPrograma.valor();
        }
        async inicioEtiquetas() {
            let v_resultado;
            let textCls = '';
            let v_programa;
            let v_parametros;
            try {
                v_programa = this._camposEtiquestas.Programa;
                v_parametros = {
                    empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                    emp_cod: sessionStorage.getItem("EMPR_COD"),
                    programa: v_programa
                };
                [v_resultado] = await (0, api_1.api)('/Etiquetas/Inicio')
                    .metodo('get')
                    .parametros(v_parametros)
                    .invoca();
                if (v_resultado) {
                    if (v_resultado.COPIAS) {
                        this._camposEtiquestas.Copias = v_resultado.COPIAS;
                    }
                    if (v_resultado.Campos.length > 0) {
                        v_resultado.Campos.forEach(c => {
                            const labelInit = this.creaElemento("label");
                            const divInit_A = this.creaElemento("div");
                            const inputInit = this.creaElemento("input", c.PARAMETRO);
                            const divInit_B = this.creaElemento("div");
                            const v_label = (0, label_1.label)(labelInit).crea();
                            const v_innerDiv = (0, bloque_1.bloque)(divInit_A).crea();
                            const v_newCampo = (0, campo_1.campo)(inputInit).crea();
                            const v_fieldset = (0, bloque_1.bloque)(divInit_B).crea();
                            const v_inputPlaceHolder = (0, bloque_1.bloque)('inputPlaceHolder').crea();
                            v_label.texto(c.PROMPT);
                            v_label.obtenElemento().className = "col-xs-4";
                            let tipoInput = v_mapaDeTipos[c.TIPO];
                            if (tipoInput === 'date') {
                                let dateArray = c.VALOR.split('/');
                                let date = new Date(dateArray[1] + '/' + dateArray[0] + '/' + dateArray[2]);
                                v_newCampo.valor(moment(date).format("YYYY-MM-DD"));
                            }
                            else {
                                textCls = v_mapaDeTipos[c.TIPO] === 'number' ? ' text-right' : '';
                                v_newCampo.valor(c.VALOR);
                                v_newCampo.obtenElemento().setAttribute("type", textCls);
                            }
                            v_newCampo.obtenElemento().className = "form-control input-sm input-xs focusable" + (textCls != null ? " " + textCls : "");
                            v_newCampo.obtenElemento().id = c.PARAMETRO;
                            v_newCampo.obtenElemento().setAttribute("PARAMETRO", c.PARAMETRO);
                            campos.push(v_newCampo.obtenElemento());
                            v_innerDiv.elemento().className = "col-xs-8";
                            v_innerDiv.elemento().append(v_newCampo.obtenElemento());
                            v_fieldset.elemento().className = "fieldset";
                            v_fieldset.elemento().append(v_label.obtenElemento());
                            v_fieldset.elemento().append(v_innerDiv.elemento());
                            v_inputPlaceHolder.elemento().append(v_fieldset.elemento());
                        });
                    }
                }
                this.actualizaVista();
            }
            catch ([v_mensaje]) {
                await (0, componentes_1.mensaje)().error().muestra(v_mensaje);
            }
        }
        async obtenerArticulo() {
            let v_resultado;
            let v_parametros;
            let v_art;
            try {
                v_art = this._camposEtiquestas.Articulo;
                v_parametros = {
                    empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                    emp_cod: sessionStorage.getItem("EMPR_COD"),
                    gaart_cod: v_art
                };
                [v_resultado] = await (0, api_1.api)('/Etiquetas/Articulo')
                    .metodo('get')
                    .parametros(v_parametros)
                    .invoca();
                if (v_resultado) {
                    this._camposEtiquestas.Articulo = v_resultado.COD;
                    this._camposEtiquestas.Descripcion = v_resultado.DESCRIP;
                    foco_1.foco.en(this._txtCopias);
                }
                else {
                    this.inicializa();
                    foco_1.foco.en(this._txtArt);
                }
            }
            catch ([v_mensaje]) {
                await (0, componentes_1.mensaje)().error().muestra(v_mensaje);
                this.inicializa();
                foco_1.foco.en(this._txtArt);
            }
        }
        async opcionesImpresion() {
            let v_resultado;
            let v_parametros;
            let v_programa;
            let v_opciones;
            let v_atributos;
            try {
                v_programa = this._camposEtiquestas.Programa;
                v_parametros = {
                    empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                    emp_cod: sessionStorage.getItem("EMPR_COD"),
                    programa: v_programa
                };
                [v_resultado] = await (0, api_1.api)('/Etiquetas/OpcionesImpresion')
                    .metodo('get')
                    .parametros(v_parametros)
                    .invoca();
                if (v_resultado) {
                    v_resultado.map((obj, index) => {
                        if (index === 0) {
                            v_opciones = new Array(0);
                            v_atributos = new Array(0);
                        }
                        v_atributos.push({
                            attr: "OPCION:" + obj.OPCION,
                            attr0: "DOCTIP:" + obj.DOCTIP
                        });
                        v_opciones.push(obj.OPCION.trim());
                    });
                    this._tipo.valores(v_opciones, v_atributos);
                }
                else {
                    this.inicializa();
                    foco_1.foco.en(this._txtArt);
                }
            }
            catch ([v_mensaje]) {
                this.inicializa();
                await (0, componentes_1.mensaje)().error().muestra(v_mensaje);
                foco_1.foco.en(this._txtArt);
            }
        }
        async confirmarEtiquetas() {
            let ok = false;
            let v_resultado;
            let v_parametros;
            let result = {
                parametro: "",
                value: ""
            };
            let v_innerParams = {};
            try {
                campos.map((elemento) => {
                    elemento.getAttributeNames().map((name) => {
                        if (name.toUpperCase().trim() === "PARAMETRO") {
                            result = {
                                parametro: name.toUpperCase().trim(),
                                value: elemento.getAttribute(name)
                            };
                        }
                    });
                    v_innerParams[result.parametro] = result.value;
                });
                let tipoAsSelect = this._tipo.obtenElemento();
                v_parametros = {
                    EMPGRUPO_COD: sessionStorage.getItem("EMPRGRUP_COD"),
                    EMP_COD: sessionStorage.getItem("EMPR_COD"),
                    PROGRAMA: this._txtPrograma.valor(),
                    GAART_COD: this._txtArt.valor(),
                    COPIAS: this._txtCopias.valor(),
                    Parametros: v_innerParams,
                    DOCTIP: tipoAsSelect.options[tipoAsSelect.selectedIndex].dataset.doctip,
                    OPCION: tipoAsSelect.value
                };
                console.log(v_parametros);
                [v_resultado] = await (0, api_1.api)('/Etiquetas/Imprimir')
                    .metodo('put')
                    .parametros(v_parametros)
                    .invoca();
                if (v_resultado == null) {
                    ok = true;
                }
            }
            catch ([v_mensaje]) {
                await (0, componentes_1.mensaje)().error().muestra(v_mensaje);
            }
            return ok;
        }
        creaElemento(tagName, idParameter) {
            let newElement = document.createElement(tagName);
            if (idParameter != null)
                newElement.setAttribute("id", idParameter);
            return newElement;
        }
    }
    exports.PantallaEtiquetas = PantallaEtiquetas;
});
