define(["require", "exports", "componentes/api", "lib/moment/moment", "componentes/componentes"], function (require, exports, api_1, moment, componentes_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.DialogoFirma = void 0;
    var canvas;
    var signaturePad;
    class DialogoFirma {
        constructor(_modal, _data) {
            this._modal = _modal;
            this._data = _data;
            this.clearCanvas();
            this.resizeCanvas();
            window.onresize = this.resizeCanvas;
            this._btnAcceptSignature =
                _modal.boton('accept')
                    .clic(async () => {
                    let vResultado;
                    let peticion;
                    let base64Data = this.getBase64();
                    if (base64Data != null) {
                        peticion = {
                            EMPGRUPO_COD: sessionStorage.getItem("EMPRGRUP_COD"),
                            EMP_COD: sessionStorage.getItem("EMPR_COD"),
                            TIP_VC: _data.TIP_VC,
                            GGALBTIP_COD: _data.Albaran.split("-")[0],
                            N_ALBARAN: parseInt(_data.Albaran.split("-")[1]),
                            GPOPER_COD: _data.Operario,
                            CLINOM: _data.NomCli,
                            DIRCOMPLETA: _data.Direccion,
                            GGMENVIO_DES: _data.Transporte,
                            FECHA_EXW: moment(_data.Fecha).
                                set({
                                hour: new Date().getHours(),
                                minute: new Date().getMinutes(),
                                second: new Date().getSeconds(),
                                millisecond: new Date().getMilliseconds()
                            }).toDate(),
                            MATRICULA: _data.Matricula,
                            Telefono: {
                                INT: _data.Int,
                                PAIS: _data.Pais,
                                NUMERO: _data.Telefono
                            },
                            Firma: base64Data
                        };
                        vResultado = await (0, api_1.api)('/RF_Exwork/Finaliza')
                            .metodo('put')
                            .parametros(peticion)
                            .invoca().catch(async (val) => {
                            await (0, componentes_1.notificacion)().error().muestra("No ha sido posible guardar la firma!");
                            return null;
                        });
                        if (vResultado !== null) {
                            this._modal.cierra(true);
                        }
                        else {
                            await (0, componentes_1.notificacion)().error().muestra("No ha sido posible guardar la firma!");
                        }
                    }
                    else {
                        await (0, componentes_1.notificacion)().error().muestra("La firma es OBLIGATORIA!");
                    }
                }).crea();
            this._btnCancelarSignature =
                _modal.boton('cancel')
                    .clic(() => {
                    this._modal.cierra(false);
                }).crea();
            this._btnLimpiarSignature =
                _modal.boton('clear')
                    .clic(() => {
                    this.clearCanvas();
                }).crea();
        }
        clearCanvas() {
            let wrapper = document.querySelectorAll("[id$=signature-pad]");
            canvas = wrapper[0].querySelector("canvas");
            signaturePad = new SignaturePad(canvas, {
                backgroundColor: 'rgb(255, 255, 255)'
            });
            signaturePad.clear();
        }
        resizeCanvas() {
            let ratio = parseInt(Math.max(window.devicePixelRatio || 1, 1).toFixed(0));
            canvas.width = canvas.offsetWidth * ratio;
            canvas.height = canvas.offsetHeight * ratio;
            canvas.getContext("2d").scale(ratio, ratio);
            signaturePad.clear();
        }
        getBase64() {
            let data = null;
            if (!signaturePad.isEmpty()) {
                let dataURL = signaturePad.toDataURL();
                data = dataURL.split(';base64,')[1];
            }
            return data;
        }
    }
    exports.DialogoFirma = DialogoFirma;
});
