﻿$(document).ready(function () {
    var table = $('#KitMontaje');
    generateTable();
    //drawTable();
    var dataTable = table.DataTable();

    var txtArtCod = document.getElementById('txtArticuloCod');
    var txtArtDescrip = document.getElementById('txtArticuloDescrip');
    var txtExistenciasAgrupadas = document.getElementById('txtExistenciasAgrupadas');
    var txtExistenciasAlmacen = document.getElementById('txtExistenciasAlmacen');
    var txtUnidad = document.getElementById('txtUnidad');
    var txtCant = document.getElementById('txtCant');
    var txtLoteDest = document.getElementById('txtLoteDest');
    var txtUbicacionDest = document.getElementById('txtUbicacionDest');

    var btnGenerar = document.getElementById('btnGenerar');
    var btnLote = document.getElementById('btnLote');
    var btnUbicacion = document.getElementById('btnUbicacion');
    var btnNuevo = document.getElementById('btnNuevo');

    var CONFIG = {
        Ubicacion: "",
        Lote: ""
    };

    var components = {};

    var intentos = 0;

    var Articulo_inicial = {};
    var Articulo_aux = {};
    var Articulo = {
        "EMPGRUPO_COD": "",
        "EMP_COD": "",
        "GAART_COD": "",
        "C_UNID1": 0,
        "C_UNID2": 0,
        Lotes: [],
        "Componentes": [
        ]
    };

    inicio();
    modCellValue();
    var CellValueModifier = new ModifyCellValue("#KitMontaje", "C_UNID1");
    CellValueModifier.modCellValue(function () { }, "Float", false);

    CONFIG.PERMITE_MODIF_CANT_COMP ? CellValueModifier.Activate() : CellValueModifier.Deactivate();

    //drawRows();

    //Eventos
    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$(txtArtCod).keypress(function (e) { if (e.which === 13) buscaArticulo(); });
    //$(txtCant).keypress(function (e) { if (e.which === 13) obtenerComponentes(); });
    //$(txtUbicacionDest).keypress(function (e) { if (e.which === 13) validarUbicacion(); });
    $(txtArtCod).on("change", function (e) { buscaArticulo(); });
    $(txtCant).on("change", function (e) { obtenerComponentes(); });
    $(txtUbicacionDest).on("change", function (e) { validarUbicacion(); });

    addEvent(btnLote, 'click', obtenLotes, false);
    addEvent(btnUbicacion, 'click', obtenUbicaciones, false);
    addEvent(btnGenerar, 'click', function () { montarKit(); }, false);
    addEvent(btnNuevo, 'click', function () { clear(); }, false);

    function clearArticle() {
        Articulo_inicial = {
            "EMPGRUPO_COD": "",
            "EMP_COD": "",
            "GAART_COD": "",
            "C_UNID1": 0,
            "C_UNID2": 0,
            "LOTES_SN": "",
            "UBIC_SN": "",
            "LOTE": "",
            Lotes: [],
            "GAUBIC_COD": "",
            "Componentes": [
            ]
        };
        components = {};
        Articulo_aux = {};
        Articulo = JSON.parse(JSON.stringify(Articulo_inicial));
    }

    function clear() {
        clearArticle();
        intentos = 0;
        $(txtArtCod).val("");
        $(txtArtDescrip).val("");
        $(txtExistenciasAgrupadas).val("");
        $(txtExistenciasAlmacen).val("");
        $(txtUnidad).val("");
        $(txtCant).val("");
        $(txtLoteDest).val(CONFIG.LOTE_ENTRADA_DEF);
        $(txtUbicacionDest).val(CONFIG.UBIC_ENTRADA_DEF);

        dataTable.clear().draw();
        $(txtArtCod).focus().select();
    }

    function clearBatches() {
        Articulo = JSON.parse(JSON.stringify(Articulo_inicial));

        Articulo.Lotes = [];
        components = dataTable.rows().data().toArray();

        components.forEach(function (C) {
            if (C)
                C.Lotes = [];
        });
    }
    function inicio() {
        var url = "RF_Kits/Inicio";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD")
        };
        var success = function (response) {
            if (response.Ok) {
                var obj = response.Objeto;
                CONFIG.PERMITE_MODIF_CANT_COMP = obj.PERMITE_MODIF_CANT_COMP;
                CONFIG.PERMITE_MODIF_CANT_COMP ? CellValueModifier.Activate() : CellValueModifier.Deactivate();
                CONFIG.VER_LOTEUBIC_UNICO_E = obj.VER_LOTEUBIC_UNICO_E;
                CONFIG.LOTE_ENTRADA_DEF = obj.LOTE_ENTRADA_DEF;
                CONFIG.UBIC_ENTRADA_DEF = obj.UBIC_ENTRADA_DEF;

                $(txtLoteDest).val(obj.LOTE_ENTRADA_DEF);
                $(txtUbicacionDest).val(obj.UBIC_ENTRADA_DEF);
                $(txtArtCod).focus();
                if (!CONFIG.VER_LOTEUBIC_UNICO_E) {
                    $('.destino').css('display', 'none');
                } else {
                    $('.destino').css('display', 'block');
                }
            } else {
                lanzarMensaje(response.Ok, response.Mensaje);
            }
        };
        apiGeneral(url, method, data, success);
    }

    function completarArticulo() {
        components = dataTable.rows().data().toArray();
        Articulo.EMPGRUPO_COD = sessionStorage.getItem("EMPRGRUP_COD");
        Articulo.EMP_COD = sessionStorage.getItem("EMPR_COD");
        if (!Articulo.Componentes || Articulo.Componentes.length === 0) {
            Articulo.Componentes = JSON.parse(JSON.stringify(components));
        }

        for (var i = 0; i < components.length; i++) {
            if (Articulo.Componentes[i])
                Articulo.Componentes[i].C_UNID1 = components[i] ? components[i].C_UNID1 : 0;
        }
        Articulo.GAART_COD = $(txtArtCod).val();
        Articulo.C_UNID1 = $(txtCant).val();
        if (Articulo.Lotes && Articulo.Lotes.length === 0) {
            var ubicDef = {
                LOTE: $(txtLoteDest).val(),
                GAUBIC_COD: $(txtUbicacionDest).val(),
                C_UNID1: $(txtCant).val()
            };
            Articulo.Lotes.push(ubicDef);
        }

        Articulo.Componentes.forEach(function (art) {
            if (art)
                art.PR_PRECIO = art.PRECIO;
        });
        return Articulo;
    }

    function montarKit() {
        if ($(txtCant).val().length === 0) {
            lanzarMensaje(
                false,
                'La cantidad es obligatoria!',
                function () { $(txtCant).focus().select(); }
            );
        } else if ($(txtCant).val() <= "0") {
            lanzarMensaje(
                false,
                'La cantidad no puede ser "menor o igual a 0"!',
                function () { $(txtCant).focus().select(); }
            );
        } else {
            var url = "RF_Kits/MontarKit";
            var method = "PUT";
            var data = JSON.parse(JSON.stringify(completarArticulo()));
            delete data["GAUBIC_COD"];
            delete data["LOTE"];
            delete data["LOTES_SN"];
            delete data["UBIC_SN"];
            var success = function (response) {
                var obj;
                if (response.Ok) {
                    if (response.Mensaje && !response.Objeto) {
                        clear();
                        successMessage(response.Mensaje);
                    } else if (response.Objeto) {
                        obj = response.Objeto;
                        if (obj.ReiniciarSolicitud && obj.ReiniciarSolicitud.length > 0) {
                            lanzarMensaje(false, response.Mensaje);
                            fnResetComponents(obj);
                        }
                        if (obj.LotesASolicitar && obj.LotesASolicitar.length > 0) {
                            if (intentos === 0) {
                                fnComponents(obj);
                                intentos++;
                            } else {
                                lanzarMensaje(false, response.Mensaje, function () { fnComponents(obj); });
                            }
                        }
                    } else {
                        clear();
                        successMessage("Montaje generado correctamente");
                    }

                } else {
                    //Articulo = Object.assign({}, Articulo_inicial);
                    lanzarMensaje(false, response.Mensaje);
                }
            };
            apiGeneral(url, method, data, success);
        }
    }

    function generateArticle() {
        Articulo.GAART_COD = $(txtArtCod).val();
        getComponents(0);
    }

    function getComponents(components) {
        if (components.length !== 0) {

            var v_row = 0;
            var component = components.shift();
            var v_data = JSON.parse(JSON.stringify(component));
            var compMessage = component.MENSAJE;
            var isParentComponent = component.GAART_COD === Articulo.GAART_COD;
            if (isParentComponent) {
                Articulo.Lotes = [];
                v_data = JSON.parse(JSON.stringify(component));
                v_data.C_UNID1 = Articulo.C_UNID1;
                v_data.GAART_DESCRIP = Articulo_inicial.GAART_DESCRIP;
            } else {
                dataTable.rows(function (idx, data, node) {
                    if (data['GAART_COD'] === component.GAART_COD) {

                        v_data['GAART_DESCRIP'] = data.GAART_DESCRIP;
                        v_data['C_UNID1'] = data.C_UNID1;
                        v_row = idx;
                    }

                });
                v_data.Lotes = component.Lotes;
            }
            Articulo.Componentes[v_row].Lotes = [];
            //var v_url = Router.action("Dialog", "Dialog");
            var v_url = "Dialog/Dialog";
            var dialogId = '#dialogLoV';
            var tableName = 'tablaUbic';
            var v_columns = [
                generateColumn("GAUBIC_COD", 'Ubicacion'),
                generateColumn("LOTE", Resources.table_head_batch),
                generateColumn("C_UNID1", Resources.table_head_quantity)
            ];
            var columnDefs = [
                { "width": "10em", "targets": 0 },
                { "width": "5em", "targets": 2 }
            ];
            var v_buttons;
            if (isParentComponent) {
                v_buttons = [
                    generateSingleButton('btnAccept', Resources.button_accept, "pull-right")
                ];
            } else {
                v_buttons = [
                    generateSingleButton('btnReset', "Reiniciar", 'pull-left', 'gray'),
                    generateSingleButton('btnAccept', Resources.button_accept, "pull-right")
                ];
            }
            var v_inputs = [
                generateSingleInput(12, "Ubicación", 'diagTxtUbic', "", "", "focusable"),
                generateSingleInput(12, "Lote", 'diagTxtLote', "", "", "focusable"),
                generateSingleInput(12, "Cantidad", 'diagTxtCant', "", "", "focusable text-right")
            ];
            var v_upperInputs = [
                generateSingleInput(8, 'Artículo', 'diagTxtDescrip', v_data.GAART_DESCRIP),
                generateSingleInput(4, 'Cantidad', 'diagTxtPdte', v_data.C_UNID1, "", "text-right")
            ];

            var regEncontrado = false;
            var v_datos_aux = JSON.parse(JSON.stringify(v_data.Lotes));
            generarDialogAuto(v_url, dialogId, tableName, null, v_data.Lotes, v_columns, v_buttons, v_inputs, v_upperInputs,
                function () { confirmComponent(dialogId, tableName, isParentComponent, regEncontrado, v_row, components); },
                "Ubicaciones y lotes", null, compMessage, null, null, null, null, columnDefs);

        } else {
            montarKit();
        }

    }

    function confirmComponent(dialogId, tableName, isParentComponent, regEncontrado, v_row, components) {
        tabulado(dialogId);
        var tBody = $('#' + tableName + ' tbody');
        tBody.on('mousedown', function (e) { componentData(e, tableName); });
        tBody.on('click', function () { setQty(isParentComponent, tableName); $('#diagTxtCant').focus(); });
        addComponent(isParentComponent, regEncontrado, tableName, v_row, Comp);
        var diagTxtLote = $('#diagTxtLote');
        var diagTxtUbic = $('#diagTxtUbic');

        // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
        //diagTxtUbic.keypress(function (e) {
        //    if (e.which === 13)
        diagTxtUbic.on("change", function (e) {
            if (!diagTxtLote.is(':visible')) {
                seleccionFila('#' + tableName, [{
                    KEY: "GAUBIC_COD", VALUE: diagTxtUbic.val()
                }]);
                setQty(isParentComponent, tableName);
            }
        });
        // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
        //diagTxtLote.keypress(function (e) {
        //    if (e.which === 13) {
        diagTxtLote.on("change", function (e) {
            {
                regEncontrado = $('#diagTxtUbic').is(':visible') ? seleccionFila('#' + tableName, [{ KEY: "GAUBIC_COD", VALUE: diagTxtUbic.val() }, { KEY: "LOTE", VALUE: diagTxtLote.val() }]) : seleccionFila('#' + tableName, [{ KEY: "LOTE", VALUE: diagTxtLote.val() }]);
                setQty(isParentComponent, tableName);
            }
        });



        if (isParentComponent && typeof Articulo.Componentes[v_row] === 'undefined') {
            Articulo.Componentes[v_row] = {
                GAART_COD: v_data.GAART_COD,
                C_UNID1: 0,
                Lotes: []
            };
        }
        var Comp;



        var btnReset = document.getElementById('btnReset');
        var btnAccept = document.getElementById('btnAccept');
        if (!isParentComponent)
            addEvent(btnReset, 'click', function () { resetData(data, v_row); }, false);
        addEvent(btnAccept, 'click', function () { accept(isParentComponent, regEncontrado, tableName, v_row, Comp, components); }, false);
        /////////////==============================================================================
    }
    function setQty(isParentComponent, tableName) {
        if (isParentComponent)
            $('#diagTxtCant').val($('#diagTxtPdte').val());
        else {
            var diagDataTable = $('#' + tableName).DataTable();
            var qty = setOptimumQty(diagDataTable.row('.selected').data().C_UNID1, $('#diagTxtPdte').val());
            $('#diagTxtCant').val(qty);
            //if (diagDataTable.rows().length > 0 && diagDataTable.row('.selected').data().C_UNID1 < $('#diagTxtPdte').val()) {
            //    $('#diagTxtCant').val(diagDataTable.row('.selected').data().C_UNID1);
            //} else {
            //    $('#diagTxtCant').val($('#diagTxtPdte').val());
            //}
        }
    }
    function addQty(isParentComponent, regEncontrado, tableName, p_row, Comp) {
        if ($('#diagTxtCant').val() !== "") {
            var table = $('#tablaUbic').DataTable();
            var cant = TryParseFloat($('#diagTxtCant').val(), 0);
            var encontrado = false;
            var row;
            if (isParentComponent && !regEncontrado) {
                var foundRow = seleccionFila('#' + tableName, [{ KEY: "GAUBIC_COD", VALUE: $("#diagTxtUbic").val() }, { KEY: "LOTE", VALUE: $("#diagTxtLote").val() }]);
                if (!foundRow) {
                    row = { GAUBIC_COD: $('#diagTxtUbic').val(), LOTE: $('#diagTxtLote').val(), C_UNID1: 0 };
                    var rowNode = table.row.add(row).draw().node();
                    $(rowNode).addClass('selected');
                }
                $('tr.selected').click();
                //table.row('.selected').click();
            }
            row = table.row('.selected');
            isParentComponent ? row.data().C_UNID1 += cant : row.data().C_UNID1 -= cant;
            row.invalidate();
            $('#diagTxtPdte').val(TryParseFloat($('#diagTxtPdte').val()) - cant);

            Comp = isParentComponent ? Object.assign({}, Articulo) : JSON.parse(JSON.stringify(getComponentValues(Comp, p_row, cant)));
            Comp.Lotes.forEach(function (exist) {
                if (exist.Lote === $('#diagTxtLote').val() && exist.GAUBIC_COD === $('#diagTxtUbic').val()) {

                    encontrado = true;
                    exist.C_UNID1 += cant;
                }
            });
            if (!encontrado) {
                Comp.Lotes.push({
                    LOTE: $('#diagTxtLote').val(),
                    GAUBIC_COD: $('#diagTxtUbic').val(),
                    C_UNID1: cant
                });

            }
        }
        if (!isParentComponent)
            Articulo.Componentes[p_row] = Comp;
        $('#diagTxtCant').val("");

    }

    function componentData(e, tableName) {
        var diagDataTable = $('#' + tableName).DataTable();
        var selectedRow = diagDataTable.row(e.target);
        if (diagDataTable.row(selectedRow).data()) {
            $('#diagTxtUbic').val(diagDataTable.row(selectedRow).data().GAUBIC_COD);
            $('#diagTxtLote').val(diagDataTable.row(selectedRow).data().LOTE);
            $('#diagTxtCant').focus();
        }
    }

    function fnComponents(obj) {
        Articulo_aux = JSON.parse(JSON.stringify(Articulo));
        getComponents(obj.LotesASolicitar);
    }

    function fnResetComponents(obj) {

        obj.ReiniciarSolicitud.forEach(function (art) {
            var found = false;
            for (var i = 0; i < Articulo.Componentes.length && !found; i++) {
                if (Articulo.Componentes[i].GAART_COD === art.GAART_COD) {
                    Articulo.Componentes[i].Lotes = [];
                    found = true;
                }
            }
        });
    }

    function addComponent(isParentComponent, regEncontrado, tableName, p_row, Comp) {
        // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
        //$('#diagTxtCant').keypress(function (e) {
        //    if (e.which === 13) {
        $('#diagTxtCant').on("change", function (e) {
            {
                addQty(isParentComponent, regEncontrado, tableName, p_row, Comp);
            }
        });
    }

    function resetData(data, row) {
        var table = $('#tablaUbic').DataTable();
        table.rows().clear();
        table.rows.add(data).draw();

        Articulo.Componentes[row].Lotes = [];
        //dataTable.row(v_row).data().C_UNID1 += Articulo.Componentes[row].C_UNID1;
        dataTable.rows().invalidate();
        Articulo.Componentes[row].C_UNID1 = 0;
        $('#diagTxtPdte').val(dataTable.row(row).data().C_UNID1);
    }
    function accept(isParentComponent, regEncontrado, tableName, p_row, Comp, components) {
        addQty(isParentComponent, regEncontrado, tableName, p_row, Comp);
        closeModal('#dialogLoV');
        getComponents(components);
    }

    function getComponentValues(Comp, row, cant) {
        if (typeof Comp === 'undefined') {
            Comp = JSON.parse(JSON.stringify(Articulo.Componentes[row]));
        }
        if (typeof Comp.Lotes === 'undefined') {
            Comp.Lotes = [];
        }
        Comp.C_UNID1 += cant;
        Comp.C_UNID1 = JSON.parse(JSON.stringify(Articulo.Componentes[row])).C_UNID1 - $('#diagTxtPdte').val();
        return Comp;
    }
    /////// ======================================================================
    function resetCompData() {
        Articulo = JSON.parse(JSON.stringify(Articulo_aux));
        table.DataTable().clear().draw();
        table.DataTable().rows.add(Articulo.Componentes).draw();
        drawRows();
    }

    function generateTable() {
        var v_columns = [
            generateColumn("GAART_COD", Resources.table_head_article),
            generateColumn("GAART_DESCRIP", Resources.table_head_description),
            generateColumn("C_UNID1", Resources.table_head_quantity, true, true),
            generateColumn("GAUNITIP_COD1", "Un.", true, true)
        ];

        var columnDefs = [
            { "targets": 0, "className": 'rowMax4em' },
            { "targets": 1, "className": 'rowMax5em' },
            { "targets": 2, "className": 'rowMax2em' },
            { "targets": 3, "className": 'rowMax2em' }
        ];

        createTableJson('#KitMontaje', null, v_columns, 6, null, columnDefs, false);
    }

    function buscaArticulo() {
        var art = $(txtArtCod).val();
        clear();
        $(txtArtCod).val(art);
        var url = "RF_Kits/Articulo";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            GAART_COD: art
        };
        var success = function (response) {
            if (response.Ok) {
                var obj = response.Objeto;
                $(txtArtCod).val(obj.GAART_COD);
                $(txtArtDescrip).val(obj.GAART_DESCRIP);
                $(txtExistenciasAlmacen).val(obj.C_EXIST1);
                $(txtExistenciasAgrupadas).val(obj.C_EXIST1_ALMAGRU);

                Articulo_inicial.GAART_COD = obj.GAART_COD;
                Articulo_inicial.GAART_DESCRIP = obj.GAART_DESCRIP;
                Articulo_inicial.C_EXIST1 = obj.C_EXIST1;
                Articulo_inicial.C_EXIST1_ALMAGRU = obj.C_EXIST1_ALMAGRU;

            } else {
                lanzarMensaje(response.Ok, response.Mensaje, function () { $(txtArtCod).focus().select(); });
            }
        };
        apiGeneral(url, method, data, success);
    }

    function obtenerComponentes() {
        if ($(txtCant).val().length === 0) {
            lanzarMensaje(
                false,
                'La cantidad es obligatoria!',
                function () { $(txtCant).focus().select(); }
            );
        } else if (!$.isNumeric($(txtCant).val())) {
            lanzarMensaje(
                false,
                'No se admiten valores no numéricos!',
                function () { $(txtCant).focus().select(); }
            );
        } else if ($(txtCant).val() <= "0") {
            lanzarMensaje(
                false,
                'La cantidad no puede ser "menos o igual a 0"!',
                function () { $(txtCant).focus().select(); }
            );
        } else {
            var url = "RF_Kits/Componentes";
            var method = "GET";
            var data = {
                empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                emp_cod: sessionStorage.getItem("EMPR_COD"),
                GAART_COD: $(txtArtCod).val(),
                C_UNID1: $(txtCant).val()
            };
            Articulo_inicial.C_UNID1 = $(txtCant).val();

            var success = function (response) {
                table.DataTable().clear().draw();
                if (response.Ok) {
                    var obj = response.Objeto;

                    dataTable.rows.add(obj).draw();
                    drawRows();
                } else {
                    lanzarMensaje(response.Ok, response.Mensaje, function () { $(txtCant).focus().select(); });
                }
            };
            apiGeneral(url, method, data, success);
        }
    }

    function drawRows() {
        dataTable.rows().every(function (rowIdx, tableLoop, rowLoop) {
            var data = this.data();
            if (data.EXIST_SUF === "S") {
                $(this.node()).removeClass('red');
            } else {
                $(this.node()).addClass('red');
            }
        });
    }

    function modCellValue() {
        var col = 2;

        $(dataTable.table().container()).on('click', 'td', function () {
            if (!$(this).find('input').length) {
                var cell = dataTable.cell(this);
                var columns = dataTable.settings().init().aoColumns;

                var index = cell.index();
                var $cell = $(this);

                if (CONFIG.PERMITE_MODIF_CANT_COMP && columns[index.column].mDataProp === 'C_UNID1') {
                    var C_UNID1 = $cell.context.innerHTML;
                    $cell.context.innerHTML = '<input id="modInput" class="col-xs-12 text-right modInput" value="' + C_UNID1 + '" />';
                    $('.modInput').focus().select();
                    $('.modInput').on('click', function () {
                        $(this).select();
                    });
                    $('.modInput').keypress(function (e) { if (e.which === 13) $('.modInput').blur(); });
                    $('.modInput').on('blur', function () {
                        var data = dataTable.row(index.row).data();
                        data.C_UNID1 = TryParseInt($(this).val(), C_UNID1);
                        dataTable.row(index.row).invalidate();
                        data = dataTable.row(index.row).data();
                        drawRows();
                    });
                }
            }
        });
    }

    function obtenUbicaciones() {
        var url = "RF_Kits/Ubicaciones";
        var method = "GET";
        var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), GAART_COD: $(txtArtCod).val() };
        var success = function (response) {
            if (response.Ok) {
                //var url = Router.action('Dialog', 'Dialog');
                var url = "Dialog/Dialog";
                var columns = [generateColumn('COD', Resources.table_head_code)];
                var buttons = [generateSingleButton('aceptar', Resources.button_accept)];
                generarDialogAuto(url, "#dialogLoV", "ubicTable", null, response.Objeto, columns, buttons, null, null, recogeUbicacion, "Ubicaciones");
            } else {
                lanzarMensaje(false, response.Mensaje);
            }
        };
        apiGeneral(url, method, datos, success);
    }
    function recogeUbicacion() {
        var btnAccept = document.getElementById('aceptar');
        addEvent(btnAccept, 'click', recogeUbic);

        var table = $('#ubicTable').DataTable();

        function recogeUbic() {
            if (table.rows().data().length !== 0) {
                $(txtUbicacionDest).val(table.rows('.selected').data()[0].COD);
            }
            closeModal('#dialogLoV');
        }
    }
    function obtenLotes() {
        var url = "RF_Kits/Lotes";
        var method = "GET";
        var datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD"), GAART_COD: $(txtArtCod).val() };
        var success = function (response) {
            if (response.Ok) {
                //var url = Router.action('Dialog', 'Dialog');
                var url = "Dialog/Dialog";
                var columns = [generateColumn('COD', Resources.table_head_batch)];
                var buttons = [generateSingleButton('aceptar', Resources.button_accept)];

                generarDialogAuto(url, "#dialogLoV", "LoteTable", null, response.Objeto, columns, buttons, null, null, recogeLote, "Lotes");
            } else {
                lanzarMensaje(false, response.Mensaje);
            }
        };
        apiGeneral(url, method, datos, success);
    }

    function recogeLote() {
        var btnAccept = document.getElementById('aceptar');
        addEvent(btnAccept, 'click', recogeLot);
    }
    function recogeLot() {
        var table = $('#LoteTable').DataTable();
        if (table.rows().data().length !== 0) {
            $(txtLoteDest).val(table.rows('.selected').data()[0].COD);
        }
        closeModal('#dialogLoV');
    }

    function validarUbicacion() {
        var url = "/RF_Kits/Ubicacion";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            GAART_COD: $(txtArtCod).val(),
            gaubic_cod: $(txtUbicacionDest).val()
        };
        var success = function (response) {
            var Ok = function () {
                $(txtUbicacionDest).val(response.Objeto.COD);
            };
            var Error = function () {
                $(txtUbicacionDest).focus().select();
            };
            handleResponse(response, Ok, Error);
        };
        apiGeneral(url, method, data, success);
    }
});
