define(["require", "exports", "componentes/api", "componentes/bloque", "componentes/boton", "componentes/campo", "componentes/foco", "componentes/lov", "componentes/mensaje", "Movimientos/Shared/modelos/DatosAlmacen", "Utilidades/assert"], function (require, exports, api_1, bloque_1, boton_1, campo_1, foco_1, lov_1, mensaje_1, DatosAlmacen_1, assert) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.BloqueOrigen = void 0;
    class BloqueOrigen {
        constructor(Padre) {
            this._datosOrigen = new DatosAlmacen_1.DatosAlmacen();
            const vComponentes = this.inicializaComponentes();
            Object.getOwnPropertyNames(vComponentes).forEach(pNombre => this[pNombre] = vComponentes[pNombre].crea());
            this._PantallaPadre = Padre;
        }
        onUpdateCallBack(fn) {
            fn();
        }
        get Datos() {
            return this._datosOrigen;
        }
        set Datos(value) {
            this._datosOrigen = value;
            this.actualizaBloque();
        }
        inicializaComponentes() {
            const vComponentes = {
                _botonConsulta: (0, boton_1.boton)('btnOrigenConsulta')
                    .clic(async () => {
                    const vUbicacionSeleccionada = await this.ConsultaDatos();
                    if (!vUbicacionSeleccionada && (this._datosOrigen.ControlLotes || this._datosOrigen.ControlUbicaciones))
                        if (!this._datosOrigen.Almacen)
                            foco_1.foco.en(this._inputAlmacen);
                        else
                            foco_1.foco.enSiguienteA(this._inputAlmacen);
                    else
                        foco_1.foco.enSiguienteA(this._inputLote);
                }),
                _inputAlmacen: (0, campo_1.campo)('txtOrigenAlmacen')
                    .cambio(async (valor) => {
                    this.Almacen = valor;
                    const AlmacenValido = await this.ValidarAlmacen();
                    if (!AlmacenValido) {
                        foco_1.foco.en(this._inputAlmacen);
                    }
                    else {
                        foco_1.foco.enSiguienteA(this._inputAlmacen);
                        await this.GestionaUbicacionDefecto();
                    }
                    this._PantallaPadre.limpiaCampoCantidad();
                    this.actualizaVista();
                }),
                _botonConsultaAlmacen: (0, boton_1.boton)('btnOrigenAlmacen').clic(async () => {
                    const AlmacenSeleccionado = await this.ConsultaAlmacen();
                    if (AlmacenSeleccionado)
                        foco_1.foco.enSiguienteA(this._inputAlmacen);
                    else
                        foco_1.foco.en(this._inputAlmacen);
                }),
                _bloqueOrigenUbicacion: (0, bloque_1.bloque)('bloqueOrigenUbicacion'),
                _bloqueOrigenLote: (0, bloque_1.bloque)('bloqueOrigenLote'),
                _inputUbicacion: (0, campo_1.campo)('txtOrigenUbicacion')
                    .cambio(async () => {
                    this.actualizaModelo();
                    const vUbicacionValida = await this.ValidarUbicacionLote();
                    if (!vUbicacionValida) {
                        await (0, mensaje_1.mensaje)().error().muestra(Resources.PantallaMovimientos.Error.Ubicacion_no_valida);
                        foco_1.foco.en(this._inputUbicacion);
                        this.Datos.Ubicacion = null;
                    }
                    this._PantallaPadre.limpiaCampoCantidad();
                    this.actualizaVista();
                }),
                _inputLote: (0, campo_1.campo)('txtOrigenLote')
                    .cambio(async () => {
                    this.actualizaModelo();
                    const vLoteValido = await this.ValidarUbicacionLote();
                    if (!vLoteValido) {
                        if (this._datosOrigen.ControlUbicaciones) {
                            await (0, mensaje_1.mensaje)().error().muestra(Resources.PantallaMovimientos.Error.Lote_ubicacion_no_activas);
                            foco_1.foco.en(this._inputUbicacion);
                        }
                        else {
                            await (0, mensaje_1.mensaje)().error().muestra(Resources.PantallaMovimientos.Error.Lote_no_valido);
                            foco_1.foco.en(this._inputLote);
                        }
                        this.Datos.Lote = null;
                    }
                    this._PantallaPadre.limpiaCampoCantidad();
                    this.actualizaVista();
                })
            };
            return vComponentes;
        }
        Inicializa() {
            this.Articulo = null;
            this.actualizaBloque();
        }
        set Articulo(p_value) {
            this._datosOrigen = new DatosAlmacen_1.DatosAlmacen({ Articulo: p_value, Almacen: this._datosOrigen.AlmacenDefecto, AlmacenDefecto: this._datosOrigen.AlmacenDefecto });
            this._datosOrigen.Articulo = p_value;
        }
        set Almacen(p_value) {
            this._datosOrigen.Almacen = p_value;
            this._datosOrigen.Ubicacion = null;
            this._datosOrigen.Lote = null;
        }
        set ControlLotes(p_lotes) {
            this._datosOrigen.ControlLotes = p_lotes === 'S';
            this._bloqueOrigenUbicacion.clase('l2', !this._datosOrigen.ControlLotes);
        }
        set ControlUbicaciones(p_ubicaciones) {
            this._datosOrigen.ControlUbicaciones = p_ubicaciones === 'S';
            this._bloqueOrigenLote.clase('l2', !this._datosOrigen.ControlUbicaciones);
        }
        actualizaVista() {
            this.actualizaBloque();
            this._PantallaPadre.actualizaModelo();
            this._PantallaPadre.actualizaVista();
        }
        actualizaBloque() {
            this._inputAlmacen.valor(this._datosOrigen.Almacen);
            if (this._datosOrigen.ControlUbicaciones) {
                this.ControlUbicaciones = 'S';
                this._inputUbicacion.valor(this._datosOrigen.Ubicacion);
                this._bloqueOrigenUbicacion.visible(true);
            }
            else {
                this.ControlUbicaciones = 'N';
                this._bloqueOrigenUbicacion.visible(false);
            }
            if (this._datosOrigen.ControlLotes) {
                this.ControlLotes = 'S';
                this._inputLote.valor(this._datosOrigen.Lote);
                this._bloqueOrigenLote.visible(true);
            }
            else {
                this.ControlLotes = 'N';
                this._bloqueOrigenLote.visible(false);
            }
            this._inputLote.valor(this._datosOrigen.Lote);
            if (this._datosOrigen.Articulo)
                this.HabilitarCampos();
            else
                this.DeshabilitarCampos();
        }
        DeshabilitarCampos() {
            this._botonConsulta.deshabilita();
            this._botonConsultaAlmacen.deshabilita();
            this._inputAlmacen.deshabilita();
            this._inputUbicacion.deshabilita();
            this._inputLote.deshabilita();
        }
        HabilitarCampos() {
            this._botonConsulta.habilita();
            this._botonConsultaAlmacen.habilita();
            this._inputAlmacen.habilita();
            this._inputUbicacion.habilita();
            this._inputLote.habilita();
        }
        actualizaModelo() {
            this._datosOrigen.Almacen = this._inputAlmacen.valor();
            this._datosOrigen.Ubicacion = this._inputUbicacion.valor();
            this._datosOrigen.Lote = this._inputLote.valor();
        }
        async ValidarUbicacionLote() {
            const LotesDisponibles = await this.ObtenerLotesArticuloAlmacen();
            const UbicacionLoteValido = LotesDisponibles.some(pLote => (!this._datosOrigen.Ubicacion || pLote.GAUBIC_COD === this._datosOrigen.Ubicacion) &&
                (!this._datosOrigen.Lote || pLote.LOTE === this._datosOrigen.Lote));
            return UbicacionLoteValido;
        }
        async ConsultaDatos() {
            try {
                const v_lotesArticuloAlmacen = await this.ObtenerLotesArticuloAlmacen();
                const v_columnas = [
                    { propiedad: 'C_UNID1', titulo: Resources.PantallaMovimientos.ConsultaUbicacionLote.Tabla.Disponible }
                ];
                if (this._datosOrigen.ControlLotes)
                    v_columnas.unshift({ propiedad: 'LOTE', titulo: Resources.PantallaMovimientos.ConsultaUbicacionLote.Tabla.Lote });
                if (this._datosOrigen.ControlUbicaciones)
                    v_columnas.unshift({ propiedad: 'GAUBIC_COD', titulo: Resources.PantallaMovimientos.ConsultaUbicacionLote.Tabla.Ubicacion, ancho: '6em' });
                let v_elegido = await (0, lov_1.lov)()
                    .titulo(Resources.PantallaMovimientos.ConsultaUbicacionLote.Origen.Titulo)
                    .columnas(v_columnas)
                    .elige(v_lotesArticuloAlmacen);
                if (typeof v_elegido !== 'undefined') {
                    this._datosOrigen.Ubicacion = v_elegido.GAUBIC_COD;
                    this._datosOrigen.Lote = v_elegido.LOTE;
                    this._PantallaPadre.limpiaCampoCantidad();
                    this.actualizaVista();
                    return true;
                }
            }
            catch ([p_mensajeError]) {
                await (0, mensaje_1.mensaje)().error().muestra(p_mensajeError);
            }
            return false;
        }
        async ObtenerLotesArticuloAlmacen() {
            let v_lotesArticuloAlmacen = null;
            [v_lotesArticuloAlmacen] = await (0, api_1.api)("/Movimientos/LotesArticuloAlmacen")
                .metodo('get')
                .parametros({
                empgrupo_cod: this._datosOrigen.Grupo,
                emp_cod: this._datosOrigen.Empresa,
                gaalmnom_cod: this._datosOrigen.Almacen,
                gaart_cod: this._datosOrigen.Articulo,
                opcion: 'ORIGEN'
            })
                .invoca();
            return v_lotesArticuloAlmacen;
        }
        async ValidarUbicacion() {
            let v_ubicacion = null;
            try {
                [v_ubicacion] = await (0, api_1.api)("/Inventario/Ubicacion")
                    .metodo('get')
                    .parametros({
                    "empgrupo_cod": this._datosOrigen.Grupo,
                    "emp_cod": this._datosOrigen.Empresa,
                    "gaart_cod": this._datosOrigen.Articulo,
                    "gaalmnom_cod": this._datosOrigen.Almacen,
                    "gaubic_cod": this._datosOrigen.Ubicacion,
                    "lote": this._datosOrigen.Lote
                })
                    .invoca();
            }
            catch ([p_mensajeError]) {
                await (0, mensaje_1.mensaje)().error().muestra(p_mensajeError);
            }
            if (v_ubicacion)
                return true;
            return false;
        }
        async ValidarAlmacen() {
            const v_almacenes = await this.ObtenerAlmacenesActivos();
            const v_almacenValido = v_almacenes.some(pAlmacen => pAlmacen.COD === this._inputAlmacen.valor());
            if (!v_almacenValido) {
                await (0, mensaje_1.mensaje)().error().muestra(Resources.PantallaMovimientos.Error.Almacen_no_valido);
                this.Almacen = null;
            }
            return v_almacenValido;
        }
        async ObtenerAlmacenesActivos() {
            let v_almacenes;
            try {
                [v_almacenes] = await (0, api_1.api)('/Movimientos/AlmacenesActivos')
                    .parametros({
                    empgrupo_cod: this.Datos.Grupo,
                    emp_cod: this.Datos.Empresa,
                    gaart_cod: this.Datos.Articulo,
                    opcion: "P"
                })
                    .invoca();
            }
            catch ([p_mensajeError]) {
                await (0, mensaje_1.mensaje)().error().muestra(p_mensajeError);
                return;
            }
            assert.esUnArrayDe(v_almacenes, 'COD', 'DESCRIP');
            return v_almacenes;
        }
        async ConsultaAlmacen() {
            const v_almacenes = await this.ObtenerAlmacenesActivos();
            let v_elegido = await (0, lov_1.lov)()
                .titulo(Resources.PantallaMovimientos.ConsultaAlmacen.Origen.Titulo)
                .columnas([
                { propiedad: 'COD', titulo: Resources.PantallaMovimientos.ConsultaAlmacen.Tabla.Codigo, ancho: '6em' },
                { propiedad: 'DESCRIP', titulo: Resources.PantallaMovimientos.ConsultaAlmacen.Tabla.Descripcion }
            ])
                .elige(v_almacenes);
            if (typeof v_elegido !== 'undefined') {
                this.Almacen = v_elegido.COD;
                await this.GestionaUbicacionDefecto();
                this._PantallaPadre.limpiaCampoCantidad();
                this.actualizaVista();
                return true;
            }
            return false;
        }
        async GestionaUbicacionDefecto() {
            const v_ubicacionOrigen = await this.UbicacionDefecto();
            this._datosOrigen.Ubicacion = v_ubicacionOrigen.GAUBIC_DEF;
            if (this._datosOrigen.Ubicacion) {
                const vUbicacionValida = await this.ValidarUbicacionLote();
                if (!vUbicacionValida) {
                    this._datosOrigen.Ubicacion = null;
                    foco_1.foco.en(this._inputUbicacion);
                }
                else {
                    foco_1.foco.enSiguienteA(this._inputUbicacion);
                }
            }
        }
        async UbicacionDefecto() {
            if (!this.Datos.Almacen)
                return { GAUBIC_DEF: null };
            let v_ubicDefArticulo;
            try {
                [v_ubicDefArticulo] = await (0, api_1.api)("/Movimientos/UbicDefArticulo")
                    .metodo('get')
                    .parametros({
                    empgrupo_cod: this.Datos.Grupo,
                    emp_cod: this.Datos.Empresa,
                    gaart_cod: this._datosOrigen.Articulo,
                    gaalmnom_cod: this._datosOrigen.Almacen
                })
                    .invoca();
            }
            catch ([p_mensajeError]) {
                await (0, mensaje_1.mensaje)().error().muestra(p_mensajeError);
                return;
            }
            assert.esUn(v_ubicDefArticulo, "GAUBIC_DEF");
            return v_ubicDefArticulo;
        }
    }
    exports.BloqueOrigen = BloqueOrigen;
});
