﻿$(document).ready(function () {

    // Input[type=text]
    var txtAlbaran = document.getElementById("txtAlbaran");
    var txtProvCod = document.getElementById("txtProvCod");
    var txtProvDescrip = document.getElementById("txtProvDescrip");
    var txtArticulo = document.getElementById("txtArticulo");

    var btnUbicReal = document.getElementById("btnUbicReal");
    var btnLimpiar = document.getElementById("btnLimpiar");


    // Tabla
    const tablaDatosAlbaran = document.getElementById('tablaDatosAlbaran');
    const $dataTable = generateTable();
    const DataTable = $(tablaDatosAlbaran).DataTable();

    function generateTable() {
        var v_columns = [
            generateColumn("GAART_COD", "Artículo"),
            generateColumn("DESCRIP", "Descrip."),
            generateColumn("C_UNI1", "Cant.", true, true),
            generateColumn("GAUNITIP_UNI1", "Un.")
        ];

        var columnDefs = [
            { "width": "8em", "targets": 0 },
            { "width": "20em", "targets": 1 },
            { "width": "1em", "targets": 2 },
            { "width": "1em", "targets": 3 }
        ];

        createTableJson("#" + tablaDatosAlbaran.id, null, v_columns, 6, null, columnDefs, false);

        return $(tablaDatosAlbaran).dataTable();
    }

    class Linea {
        constructor() {
            this.N_LIN = "";
            this.GAART_COD = "";
            this.DESCRIP = "";
            this.C_UNI1 = 0;
            this.GAUNITIP_UNI1 = "";
            this.CANT_ALB_ORI = 0;
            this.CANT_ALB_DES = 0;
            this.Parametros = new Parametros();
            this.Lotes = [];
        }

        AddLotes(p_lote) {
            var found = false;
            this.Lotes.forEach(function (lote) {
                if (lote.GAUBIC_COD === p_lote.GAUBIC_COD /*&& lote.LOTE === p_lote.LOTE*/) {
                    lote.C_UNI1 += p_lote.C_UNI1;
                    found = true;
                }
            });
            if (!found)
                this.Lotes.push(p_lote);
        }

        Assign(Object) {
            this.N_LIN = Object.N_LIN;
            this.GAART_COD = Object.GAART_COD;
            this.DESCRIP = Object.DESCRIP;
            this.C_UNI1 = Object.C_UNI1;
            this.GAUNITIP_UNI1 = Object.GAUNITIP_UNI1;
            this.CANT_ALB_ORI = Object.CANT_ALB_ORI;
            this.CANT_ALB_DES = Object.CANT_ALB_DES;
            this.Lotes = Object.Lotes || [];
            return this;
        }
    }

    class TiposAlbaran {
        constructor() {
            this.COD = "";
            this.DESCRIP = "";
        }
    }

    class Parametros {

        constructor() { }

        Assign(Object) {
            if (Object) {
                for (var prop in Object) {
                    this[prop] = Object[prop];
                }
            } else {
                this.Assign(new Parametros());
            }
        }

        Value() {
            if (this.P_PREGUNTA)
                return this;
            else return {};
        }
    }

    class Lote {
        constructor() {
            this.GAUBIC_COD = "";
            //this.LOTE = "";
            this.C_UNI1 = 0;
        }

        Assign(Object) {
            this.GAUBIC_COD = Object.GAUBIC_COD;
            //this.LOTE = Object.LOTE;
            this.C_UNI1 = Object.C_UNI1;
        }

    }

    class Ubicaciones {
        constructor() {
            this.Registros = [];
        }
    }

    class Albaran {

        constructor() {
            this.EMPGRUPO_COD = sessionStorage.getItem("EMPRGRUP_COD");
            this.EMP_COD = sessionStorage.getItem("EMPR_COD");

            this.GGALBTIP_COD = "";
            this.N_ALBARAN = "";
            this.Albaran = "";
            this.GAART_COD = "";
            this.GGCLIPR_COD = "";
            this.GGCLIPR_NOMBRE = "";
            this.TiposAlbaran = new Array();
            this.Lineas = new Array();

            this.Parametros = new Parametros();
            this.GGALBTIP_COD_DES = "";
            this.Ubicaciones = new Ubicaciones();
        }

        UpdateValues() {
            this.Albaran = $(txtAlbaran).val();
            this.GAART_COD = $(txtArticulo).val();
        }

        UpdateView() {
            $(txtAlbaran).val(this.Albaran);
            $(txtProvCod).val(this.GGCLIPR_COD);
            $(txtProvDescrip).val(this.GGCLIPR_NOMBRE);
            $(txtArticulo).val(this.GAART_COD);
        }

        UpdateTable() {
            DataTable.clear();
            DataTable.rows.add(this.Lineas).draw();
            this.Lineas.forEach(function (p_linea, i) {
                if (p_linea.Lotes.length)
                    $(DataTable.row(i).node()).addClass("green");
            });
        }

        Assign(Object) {
            this.GGALBTIP_COD = Object.GGALBTIP_COD;
            this.N_ALBARAN = Object.N_ALBARAN;
            this.Albaran = Object.Albaran;
            this.GAART_COD = Object.GAART_COD;

            this.GGCLIPR_COD = Object.GGCLIPR_COD;
            this.GGCLIPR_NOMBRE = Object.GGCLIPR_NOMBRE;
            this.TiposAlbaran = Object.TiposAlbaran;
            this.Lineas = Object.Lineas;
            if (this.Lineas) {
                this.Lineas = this.Lineas.map(function (linea) {
                    if (!linea.CANT_ALB_ORI)
                        linea.CANT_ALB_ORI = linea.C_UNI1;

                    return new Linea().Assign(linea);
                });
            } else {
                this.Lineas = new Array();
            }
            this.Parametros = new Parametros();
            this.Parametros.Assign(Object.Parametros);
            this.GGALBTIP_COD_DES = Object.GGALBTIP_COD_DES;
            this.Ubicaciones = Object.Ubicaciones || new Ubicaciones();

        }

        AlbaranTransito() {
            var self = this;
            var url = "RF_Recepcion/AlbaranTransito";
            var method = "POST";
            var data = {
                emp_cod: this.EMP_COD,
                empgrupo_cod: this.EMPGRUPO_COD,
                lecturaalbaran: this.Albaran,
                ggalbtip_cod_des: this.GGALBTIP_COD_DES,
                parametros: this.Parametros.Value()
            };

            var success = function (response) {
                var Ok = function () {
                    var obj = response.Objeto;
                    // Asignamos el Albaran al objeto recibido para no perderlo al realizar el Assign.
                    obj.Albaran = self.Albaran;
                    console.log(self);
                    obj.Ubicaciones = self.Ubicaciones;
                    //obj.GGALBTIP_COD_DES = self.GGALBTIP_COD_DES;
                    self.Assign(obj);

                    self.UpdateView();
                    self.UpdateTable();

                    if (!self.GGALBTIP_COD_DES) {
                        self.GestionaPregunta();
                    } else {
                        $(txtArticulo).focus().select();
                    }
                };
                var Error = function () {
                    $(txtAlbaran).focus().select();
                };
                handleResponse(response, Ok, Error);
            };
            apiGeneral(url, method, data, success);
        }

        ValidaUbicacion(p_ubicacion, p_callback) {
            var url = "RF_Recepcion/ValidaUbicacion";
            var method = "GET";
            var data = {
                emp_cod: this.EMP_COD,
                empgrupo_cod: this.EMPGRUPO_COD,
                GAUBIC_COD: p_ubicacion,
                GGALBTIP_COD_DES: this.GGALBTIP_COD_DES
            };

            var success = function (response) {
                p_callback(response);
            };
            apiGeneral(url, method, data, success);
        }

        EditLinea(p_linea) {
            this.Lineas = this.Lineas.map(function (linea) {
                if (linea.N_LIN === p_linea.N_LIN)
                    linea = p_linea;
                return linea;
            });
        }

        GestionaPregunta() {
            var self = this;
            if (self.Parametros.P_PREGUNTA) {

                var dTableName = "tbPedidos";
                var dTableColumns = [
                    generateColumn("COD", "Código"),
                    generateColumn("DESCRIP", "Descripción")
                ];



                //lanzarConfirmacion(response.Objeto.PREGUNTA_HIST, acceptFn, cancelFn);

                var dFunctions = function () {
                    var v_table = $(document.getElementById(dTableName)).DataTable();

                    var acceptFn = function () {
                        self.GGALBTIP_COD_DES = v_table.row('.selected').data().COD;
                        self.AlbaranTransito();
                        closeModal("#dialogLoV");
                    };
                    var cancelFn = function () {
                        closeModal("#dialogLoV");
                    };
                    $("#btnPHSi").on("click", acceptFn);
                    $("#btnPHNo").on("click", cancelFn);
                };
                //var url = Router.action('Dialog', 'Dialog');
                var url = "Dialog/Dialog";
                var buttons = [
                    generateSingleButton("btnPHSi", "Aceptar", "pull-right", "default"),
                    generateSingleButton("btnPHNo", "Cancelar", "pull-left", "gray")
                ];

                generarDialogAuto(url, "#dialogLoV", dTableName, null, self.TiposAlbaran, dTableColumns, buttons, null, null, dFunctions, "Mensaje", null, self.Parametros.P_PREGUNTA);
            }
        }

        UbicacionesArticulo() {
            var self = this;

            var LineaSeleccionada = new Linea().Assign(DataTable.row('.selected').data());

            var url = "Recepcion/UbicacionesArticulo";
            var method = "GET";
            var data = {
                EMPGRUPO_COD: this.EMPGRUPO_COD,
                EMP_COD: this.EMP_COD,
                GAART_COD: LineaSeleccionada.GAART_COD,
                GGALBTIP_COD_DES: self.GGALBTIP_COD_DES
            };
            var success = function (response) {
                var Ok = function () {

                    var btnAccept = "btnModalAccept";
                    var dTxtUbicacion = "dTxtUbicacion";
                    //var dTxtLote = "dTxtLote";
                    var dTxtCant = "dTxtCant";
                    var dTxtArticulo = "dTxtArticulo";
                    var dTxtDescripcion = "dTxtDescripcion";
                    var dTxtPdte = "dTxtPdte";


                    var dTableName = "tbUbicaciones";
                    var dTableColumns = [
                        generateColumn("GAUBIC_COD", "Ubicación"),
                        //generateColumn("LOTE", "Lote"),
                        generateColumn("C_UNI1", "Cant.", true, true)
                    ];

                    var dInputArray = [
                        generateSingleInput(6, "Ubicación", dTxtUbicacion, ""),
                        //generateSingleInput(4, "Lote", dTxtLote, ""),
                        generateSingleInput(6, "Cant", dTxtCant, "", null, null, true)
                    ];

                    var dUpperInputArray = [
                        generateSingleInput(4, "Artículo", dTxtArticulo, LineaSeleccionada.GAART_COD, null, null, null, null, true),
                        generateSingleInput(5, "Descripción", dTxtDescripcion, LineaSeleccionada.DESCRIP, null, null, null, null, true),
                        generateSingleInput(3, "Pdte.", dTxtPdte, LineaSeleccionada.C_UNI1, null, null, true, null, true)
                    ];



                    //lanzarConfirmacion(response.Objeto.PREGUNTA_HIST, acceptFn, cancelFn);
                    if (vAlbaran.Ubicaciones.Registros.length === 0)
                        vAlbaran.Ubicaciones.Registros = response.Objeto;

                    var actualizaValoresLotes = function () {
                        //vAlbaran.Ubicaciones.Registros = vAlbaran.Ubicaciones.Registros.map(function (p_registro) {
                        //    LineaSeleccionada.Lotes.forEach(function (lote) {
                        //        if (lote.GAUBIC_COD === p_registro.GAUBIC_COD /*&& lote.LOTE === p_registro.LOTE*/) {
                        //            p_registro.C_UNI1 += lote.C_UNI1;
                        //        }
                        //    });
                        //    return p_registro;
                        //});
                    };
                    var dFunctions = function () {

                        var _dTxtUbicacion = document.getElementById(dTxtUbicacion);
                        //var _dTxtLote = document.getElementById(dTxtLote);
                        var _dTxtCant = document.getElementById(dTxtCant);
                        var _dTxtPdte = document.getElementById(dTxtPdte);
                        var v_table = $(document.getElementById(dTableName)).DataTable();

                        $(_dTxtUbicacion).focus();

                        var updateLotes = function () {
                            if ($(_dTxtCant).val()) {
                                //LineaSeleccionada.CANT_ALB_DES += TryParseFloat($(_dTxtCant).val(), 0);
                                LineaSeleccionada.C_UNI1 -= TryParseFloat($(_dTxtCant).val(), 0);
                                if (!LineaSeleccionada.CANT_ALB_DES)
                                    LineaSeleccionada.CANT_ALB_DES = TryParseFloat($(_dTxtCant).val(), 0);
                                else
                                    LineaSeleccionada.CANT_ALB_DES += TryParseFloat($(_dTxtCant).val(), 0);
                                var v_Lote = new Lote();
                                v_Lote.GAUBIC_COD = $(_dTxtUbicacion).val();
                                //v_Lote.LOTE = $(_dTxtLote).val();
                                v_Lote.C_UNI1 = TryParseFloat($(_dTxtCant).val(), 0);
                                LineaSeleccionada.AddLotes(v_Lote);
                                self.EditLinea(LineaSeleccionada);
                                self.UpdateTable();
                            }

                        };

                        var UpdateTableLote = function () {
                            v_table.clear();
                            v_table.rows.add(vAlbaran.Ubicaciones.Registros).draw();
                        };

                        var cambioColorLotes = function () {
                            vAlbaran.Ubicaciones.Registros.forEach(function (p_registro, i) {
                                LineaSeleccionada.Lotes.forEach(function (lote) {
                                    if (lote.GAUBIC_COD === p_registro.GAUBIC_COD /*&& lote.LOTE === p_registro.LOTE*/) {
                                        $(v_table.row(i).node()).addClass("green");
                                        return;
                                    }
                                    if (!vAlbaran.Ubicaciones.Registros.includes(lote)) {
                                        $(v_table.row(i).node()).addClass("green");
                                        return;
                                    }
                                });
                                return p_registro;
                            });

                        };

                        cambioColorLotes();

                        $('#' + dTableName + ' tbody').on('click', function () {
                            if (v_table.rows()[0].length > 0) {
                                var selectedRow = v_table.row('.selected')[0];
                                $(_dTxtUbicacion).val(v_table.rows(selectedRow).data()[0].GAUBIC_COD);
                                //$(_dTxtLote).val(v_table.rows(selectedRow).data()[0].LOTE);

                                var pendiente = $(_dTxtPdte).val();
                                var cantidadEnUbic = v_table.row(selectedRow).data().C_UNI1;
                                $(_dTxtCant).val(pendiente);
                                $(_dTxtCant).focus().select();
                            }
                        });

                        var actualizarPantallaLotes = function () {
                            seleccionFila("#tbUbicaciones", [
                                { KEY: "GAUBIC_COD", VALUE: $(_dTxtUbicacion).val() }/*,
                                { KEY: "LOTE", VALUE: $(_dTxtLote).val() }*/
                            ]);
                            var cantidad = TryParseFloat($(_dTxtCant).val(), 0);
                            v_table.row('.selected').data().C_UNI1 += cantidad;
                            v_table.rows().invalidate();
                            $(_dTxtCant).val("");
                            $(_dTxtUbicacion).val("");
                            //$(_dTxtLote).val("");
                            $(_dTxtPdte).val($(_dTxtPdte).val() - cantidad);
                            UpdateTableLote();
                        };

                        $(_dTxtCant).keypress(function (e) {

                            var ubicacion = $(_dTxtUbicacion).val();
                            seleccionFila("#tbUbicaciones", [
                                { KEY: "GAUBIC_COD", VALUE: ubicacion }/*,
                                    { KEY: "LOTE", VALUE: $(_dTxtLote).val() }*/
                            ]);

                            if (v_table.rows('.selected').count() > 0 && e.which === 13) {


                                if ($(_dTxtCant).val()) {
                                    updateLotes();
                                    actualizarPantallaLotes();
                                    cambioColorLotes();
                                    $(_dTxtUbicacion).focus();
                                }
                                $(_dTxtUbicacion).focus();
                            } else {
                                if (!v_table.rows('.selected').count() && ubicacion && e.which === 13) {
                                    var addUbicacion = function (resp) {
                                        if (resp.Ok) {
                                            var nuevaUbic = { GAUBIC_COD: ubicacion, C_UNI1: 0 };
                                            vAlbaran.Ubicaciones.Registros.push(nuevaUbic);
                                            v_table.clear();
                                            v_table.rows.add(vAlbaran.Ubicaciones.Registros).draw();
                                            $(_dTxtCant).trigger(jQuery.Event('keypress', { which: 13 }));
                                        } else {
                                            lanzarMensaje(false, resp.Mensaje, function () {
                                                $(_dTxtUbicacion).focus();
                                            });
                                        }
                                    };
                                    self.ValidaUbicacion(ubicacion, addUbicacion);
                                }
                            }
                        });
                        $(_dTxtUbicacion).keypress(function (e) {
                            if (e.which === 13) {
                                seleccionFila("#tbUbicaciones", [
                                    { KEY: "GAUBIC_COD", VALUE: $(_dTxtUbicacion).val() }/*,
                                    { KEY: "LOTE", VALUE: $(_dTxtLote).val() }*/
                                ]);
                                $(v_table.row('.selected').node()).click();
                                $(_dTxtCant).focus();
                            }
                        });

                        /*$(_dTxtLote).keypress(function (e) {
                            if (e.which === 13) {
                                seleccionFila("#tbUbicaciones", [
                                    { KEY: "GAUBIC_COD", VALUE: $(_dTxtUbicacion).val() },
                                    { KEY: "LOTE", VALUE: $(_dTxtLote).val() }
                                ]);
                                $(v_table.row('.selected').node()).click();
                                $(_dTxtCant).focus();
                            }
                        });*/


                        var acceptFn = function () {
                            updateLotes();
                            closeModal("#dialogLoV");

                        };

                        var cancelFn = function () {
                            closeModal("#dialogLoV");
                        };

                        var _btnAccept = document.getElementById(btnAccept);
                        $(_btnAccept).on("click", acceptFn);
                    };
                    //var url = Router.action('Dialog', 'Dialog');
                    var url = "Dialog/Dialog";
                    var buttons = [
                        generateSingleButton(btnAccept, "Aceptar", "pull-right", "default")
                    ];


                    if (vAlbaran.Ubicaciones.Registros.length === 0)
                        vAlbaran.Ubicaciones.Registros = response.Objeto;
                    generarDialogAuto(url, "#dialogLoV", dTableName, null, vAlbaran.Ubicaciones.Registros, dTableColumns, buttons, dInputArray, dUpperInputArray, dFunctions, "Ubicación");
                };
                var Error = function () {

                };
                handleResponse(response, Ok, Error);
            };
            apiGeneral(url, method, data, success);
        }

        Clear() {
            this.Assign(new Albaran());
            this.UpdateView();
            this.UpdateTable();
            $(txtAlbaran).focus();
        }

        ConfirmarAlbaranTransito() {
            var self = this;
            var url = "Recepcion/ConfirmarAlbaranTransito";
            var method = "POST";

            var data = {
                "EMPGRUPO_COD": self.EMPGRUPO_COD,
                "EMP_COD": self.EMP_COD,
                "GGALBTIP_COD": self.GGALBTIP_COD,
                "N_ALBARAN": self.N_ALBARAN,
                "GGALBTIP_FIJO_DES": self.GGALBTIP_COD_DES,
                "Parametros": self.Parametros,
                "Lineas": self.Lineas.map(function (linea) {
                    return {
                        "N_LIN": linea.N_LIN,
                        "CANT_ALB_ORI": linea.CANT_ALB_ORI,
                        "CANT_ALB_DES": linea.CANT_ALB_DES || 0,
                        "Lotes": linea.Lotes.map(function (lote) {
                            return {
                                "GAUBIC_COD": lote.GAUBIC_COD,
                                "C_UNID1": lote.C_UNI1
                            };
                        })
                    };
                })
            }
                ;
            var success = function (response) {

                var Ok = function () {
                    self.Clear();
                    lanzarMensaje(true, "Operación completada correctamente. \n Se ha generado el albarán " + response.Objeto.GGALBTIP_COD_DES + "-" + response.Objeto.N_ALBARAN_DES);
                };
                var Error = function () {

                };
                handleResponse(response, Ok, Error);
            };
            apiGeneral(url, method, data, success);
        }
    }

    var vAlbaran = new Albaran();
    addEvent(btnLimpiar, "click", function () { vAlbaran.Clear(); }, false);
    addEvent(btnUbicReal, "click", function () { vAlbaran.ConfirmarAlbaranTransito(); }, false);
    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$(txtAlbaran).keypress(function (e) {
    //    if (e.which === 13) {
    $(txtAlbaran).on("change", function (e) {
        {
            var albaran = $(txtAlbaran).val();
            vAlbaran.Clear();
            $(txtAlbaran).val(albaran);
            vAlbaran.UpdateValues();
            vAlbaran.AlbaranTransito();
        }
    });

    // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
    //$(txtArticulo).keypress(function (e) {
    //    if (e.which === 13 && $(txtArticulo).val()) {
    $(txtArticulo).on("change", function (e) {
        if ($(txtArticulo).val()) {
            vAlbaran.UpdateValues();
            var encontrado = seleccionFila("#tablaDatosAlbaran", [{ KEY: "GAART_COD", VALUE: vAlbaran.GAART_COD }]);
            if (encontrado) {
                vAlbaran.UbicacionesArticulo();
            } else {
                lanzarMensaje(false, "El artículo indicado no se encuentra en la lista", function () {
                    $(txtArticulo).focus().select();
                });
            }

        }
    });
    $('#tablaDatosAlbaran tbody').on('click', function () { vAlbaran.UbicacionesArticulo(); });
});