define(["require", "exports", "Recepcion/dialogos/js/dialogo-datos-adicionales-albaran", "Recepcion/dialogos/js/dialogo-lotes-ubicaciones", "Recepcion/dialogos/js/dialogo-lotes-ubicaciones-traspasos", "Recepcion/dialogos/js/dialogo-seleccion-albaran", "Recepcion/dialogos/modelos/dialogo-lotes-ubicaciones-modelo", "Recepcion/dialogos/modelos/dialogo-seleccion-albaran-modelo", "Recepcion/modelos/albaran", "Recepcion/modelos/pantalla_modelo", "Recepcion/modelos/pedido", "Recepcion/modelos/pedido_linea", "Utilidades/assert", "componentes/api", "componentes/bloque", "componentes/boton", "componentes/campo", "componentes/componentes", "componentes/cortina", "componentes/foco", "componentes/pantalla", "componentes/tabla", "lib/lodash/lodash"], function (require, exports, dialogo_datos_adicionales_albaran_1, dialogo_lotes_ubicaciones_1, dialogo_lotes_ubicaciones_traspasos_1, dialogo_seleccion_albaran_1, dialogo_lotes_ubicaciones_modelo_1, dialogo_seleccion_albaran_modelo_1, albaran_1, pantalla_modelo_1, pedido_1, pedido_linea_1, assert, api_1, bloque_1, boton_1, campo_1, componentes_1, cortina_1, foco_1, pantalla_1, tabla_1, _) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PantallaRecepcion = void 0;
    class PantallaRecepcion extends pantalla_1.Pantalla {
        constructor() {
            super();
            this.inicializa();
            this.asociaComponentes();
        }
        asociaComponentes() {
            const vComponentes = this.inicializaComponentes();
            Object.getOwnPropertyNames(vComponentes).forEach(pNombre => this[pNombre] = vComponentes[pNombre].crea());
            this.actualizaVista();
        }
        actualizaVista() {
            this._inputPedido.valor(this._DatosPantalla.ReferenciaPedido);
            this._inputReferencia.valor(this._DatosPantalla.ReferenciaArticulo);
            this._inputReferencia.habilitado(this._DatosPantalla.PedidoActivo);
            this._botonConfirmar.habilitado(this._DatosPantalla.PedidoActivo && this._PedidoPreparado.Lineas.length > 0);
            if (this._DatosPantalla?.AlbaranSeleccionado) {
                const v_opcionFechaAlbaran = this._cortina.opciones['fecha-albaran'];
                const v_albaranSeleccionadoClon = Object.assign({}, this._DatosPantalla.AlbaranSeleccionado);
                const v_esValida = moment(new Date(v_albaranSeleccionadoClon.F_ALBARAN)).isValid();
                let v_fechaFormateada = null;
                if (v_esValida) {
                    if (v_albaranSeleccionadoClon?.F_ALBARAN)
                        v_fechaFormateada = moment(v_albaranSeleccionadoClon.F_ALBARAN).format('DD/MM/YYYY');
                }
                if (v_opcionFechaAlbaran)
                    v_opcionFechaAlbaran.valor(v_fechaFormateada);
            }
            this._tabla.datos(this._Pedido.Lineas);
            this._tabla.buscaYSelecciona(null, { notificar: false });
            this._bloqueReferencia.clase('solo-referencia', !this._LineaSeleccionada || this._LineaSeleccionada.GAART_LOTES_SN === "S" || this._LineaSeleccionada.GAART_UBIC_SN === "S");
        }
        actualizaModelo() {
            this._DatosPantalla.ReferenciaPedido = this._inputPedido.valor();
            this._DatosPantalla.ReferenciaArticulo = this._inputReferencia.valor();
        }
        inicializa() {
            this._Pedido = new pedido_1.Pedido();
            this._DatosPantalla = new pantalla_modelo_1.DatosPantalla();
            this._PedidoPreparado = new pedido_1.PedidoPreparado({ EMPGRUPO_COD: this._DatosPantalla.Grupo, EMP_COD: this._DatosPantalla.Empresa, });
            this._LineaSeleccionada = null;
            let v_cortina = this.generaCortina();
            this._cortina = v_cortina.activa();
        }
        inicializaComponentes() {
            foco_1.foco.enPrimero(document);
            const vComponentes = {
                _botonNuevo: (0, boton_1.boton)('btnNuevo')
                    .clic(() => {
                    this.nuevo();
                }),
                _botonConfirmar: (0, boton_1.boton)('btnConfirmar')
                    .clic(async () => {
                    await this.recepcionar();
                }),
                _inputPedido: (0, campo_1.campo)('txtPedido')
                    .cambio(async () => {
                    this.actualizaModelo();
                    await this.ObtenerPedido();
                    this.actualizaVista();
                }),
                _inputReferencia: (0, campo_1.campo)('txtArticulo')
                    .valida(async () => {
                    this.actualizaModelo();
                    const vEncontrado = await this.cambiaReferencia.bind(this)();
                    if (!vEncontrado)
                        foco_1.foco.en(this._inputReferencia);
                }),
                _inputCantidad: (0, campo_1.campo)('campCant')
                    .cambio(this.actualizaPreparadoArticuloSinLotesNiUbicaciones.bind(this)),
                _bloqueReferencia: (0, bloque_1.bloque)('ref'),
                _tabla: (0, tabla_1.tabla)('tablaPedidos')
                    .columnas([
                    { propiedad: 'GAART_COD', titulo: Resources.PantallaRecepcion.tabla.columna.GAART_COD, ancho: '6em' },
                    { propiedad: 'GAART_DESCRIP', titulo: Resources.PantallaRecepcion.tabla.columna.GAART_DESCRIP },
                    { propiedad: 'C_PDTE', titulo: Resources.PantallaRecepcion.tabla.columna.C_PDTE, numerico: true, ancho: '3em' },
                ])
                    .seleccionado(async (item) => {
                    await this.seleccionaLinea(item);
                    this.actualizaVista();
                })
                    .formatoFila((p_formato, p_linea) => {
                    const v_index = this._PedidoPreparado.Lineas.findIndex(l => _.isEqual(l.N_LIN, p_linea.N_LIN));
                    if (v_index !== -1 && this._PedidoPreparado.Lineas[v_index].C_UNI1 !== 0)
                        p_formato.fondo('verde');
                }),
            };
            return vComponentes;
        }
        generaCortina() {
            let v_cortina = (0, cortina_1.cortina)();
            if (!this._Pedido || !this._DatosPantalla.AlbaranSeleccionado)
                return v_cortina;
            v_cortina = v_cortina
                .opcionFecha('fecha-albaran', p_opcion => p_opcion
                .titulo(Resources.PantallaRecepcion.Cortina.Titulo.Fecha_Albaran)
                .icono('fecha')
                .cambio(p_valor => {
                this._DatosPantalla.AlbaranSeleccionado.F_ALBARAN = p_valor;
            })
                .valor(''));
            return v_cortina;
        }
        nuevo() {
            this.inicializa();
            this.actualizaVista();
            this._inputPedido.foco();
        }
        async ObtenerPedido() {
            let vResultado;
            try {
                [vResultado] = await (0, api_1.api)('/Recepcion/Pedido')
                    .metodo('get')
                    .parametros({
                    EMPGRUPO_COD: this._DatosPantalla.Grupo,
                    EMP_COD: this._DatosPantalla.Empresa,
                    LecturaPedido: this._DatosPantalla.ReferenciaPedido
                })
                    .invoca();
            }
            catch ([vMensaje]) {
                await (0, componentes_1.mensaje)().error().muestra(vMensaje);
                foco_1.foco.en(this._inputPedido);
                return;
            }
            assert.esUn(vResultado);
            this._Pedido = new pedido_1.Pedido(vResultado);
            this._DatosPantalla.AlbaranSeleccionado = await this.ObtenerAlbaranes();
            if (!this._DatosPantalla.AlbaranSeleccionado) {
                this._DatosPantalla.AlbaranSeleccionado = new albaran_1.Albaran();
            }
            this._DatosPantalla.PedidoActivo = true;
            if (this._Pedido.OBSER)
                await (0, componentes_1.mensaje)(this._Pedido.OBSER).muestra();
            const v_cortina = this.generaCortina();
            this._cortina = v_cortina.activa();
            foco_1.foco.en(this._inputReferencia);
        }
        async ObtenerAlbaranes() {
            if (!this._Pedido.Albaranes || !this._Pedido.Albaranes.length)
                return null;
            const vResultadoSeleccionAlbaran = await (0, componentes_1.dialogo)()
                .titulo(Resources.PantallaRecepcion.DialogoSeleccionAlbaran.Titulo)
                .plantilla('recepcion/dialogos/plantillas/dialogo-seleccion-albaran')
                .construye(pModal => new dialogo_seleccion_albaran_1.DialogoSeleccionAlbaran(new dialogo_seleccion_albaran_modelo_1.SeleccionAlbaranModel({ modal: pModal, albaranes: this._Pedido.Albaranes })))
                .abre();
            return vResultadoSeleccionAlbaran;
        }
        async cambiaReferencia() {
            this.actualizaModelo();
            if (!this._DatosPantalla.PedidoActivo) {
                await (0, componentes_1.mensaje)(Resources.error.select.order).muestra();
                this.nuevo();
                return;
            }
            let vSeleccionado = this.BuscarReferenciaEnTabla(this._DatosPantalla.ReferenciaArticulo);
            if (!vSeleccionado)
                vSeleccionado = await this.BuscarCodigosAlternativos(this._DatosPantalla.ReferenciaArticulo);
            if (!vSeleccionado) {
                await (0, componentes_1.mensaje)(Resources.PantallaRecepcion.notificacion.error.ArticuloNoEncontrado).muestra();
            }
            return vSeleccionado ? true : false;
        }
        BuscarReferenciaEnTabla(Articulo) {
            const vSeleccionado = this._tabla.buscaYSelecciona({ GAART_COD: Articulo }, null);
            return vSeleccionado;
        }
        async dameArticulos(p_lectura) {
            let v_articulos;
            try {
                [v_articulos] = await (0, api_1.api)('/Articulo/Articulos')
                    .parametros({
                    empgrupo_cod: this._DatosPantalla.Grupo,
                    emp_cod: this._DatosPantalla.Empresa,
                    codigoBarras: p_lectura
                })
                    .invoca();
            }
            catch ([v_mensaje]) {
                await (0, componentes_1.mensaje)().error().muestra(v_mensaje);
                return;
            }
            if (!v_articulos)
                return;
            assert.esUnArrayDe(v_articulos, 'GAART_COD', 'GAART_DESCRIP');
            const v_filtrados = v_articulos.filter(p_articulo => this._Pedido.Lineas.find(p_linea => p_linea.GAART_COD === p_articulo.GAART_COD));
            return v_filtrados;
        }
        async resuelveArticulo(p_lectura) {
            const v_articulos = await this.dameArticulos(p_lectura);
            if (!v_articulos)
                return;
            switch (v_articulos.length) {
                case 0:
                    return;
                case 1:
                    return v_articulos[0];
                default:
                    const v_articulo = await (0, componentes_1.lov)()
                        .titulo(Resources.PantallaRecepcion.CodigosAlternativos.Lov.Titulo)
                        .columnas([
                        { propiedad: 'GAART_COD', titulo: Resources.PantallaRecepcion.CodigosAlternativos.Lov.Tabla.Codigo, ancho: '6em' },
                        { propiedad: 'GAART_DESCRIP', titulo: Resources.PantallaRecepcion.CodigosAlternativos.Lov.Tabla.Descripcion }
                    ])
                        .elige(v_articulos);
                    if (typeof v_articulo === 'undefined')
                        return;
                    return v_articulo;
            }
        }
        async BuscarCodigosAlternativos(Articulo) {
            let v_articulo = await this.resuelveArticulo(Articulo);
            v_articulo = await this.completaLectura(Articulo, v_articulo);
            let vGaartCod = v_articulo?.GAART_COD;
            const vSeleccionado = this.BuscarReferenciaEnTabla(vGaartCod);
            return vSeleccionado;
        }
        async completaLectura(p_lectura, p_seleccionado) {
            return p_seleccionado;
        }
        async seleccionaLinea(item) {
            this._LineaSeleccionada = item;
            if (this._LineaSeleccionada?.GAART_LOTES_SN === "S" || this._LineaSeleccionada?.GAART_UBIC_SN === "S") {
                let vResultadoSeleccionLinea;
                if (this._Pedido.TipoPedido !== 'T') {
                    vResultadoSeleccionLinea = await (0, componentes_1.dialogo)()
                        .titulo(Resources.PantallaRecepcion.DialogoLotesUbicaciones.Titulo)
                        .plantilla('Recepcion/dialogos/plantillas/dialogo-lotes-ubicaciones')
                        .construye(pModal => new dialogo_lotes_ubicaciones_1.DialogoLotesUbicaciones(new dialogo_lotes_ubicaciones_modelo_1.LotesUbicacionesModel({
                        modal: pModal,
                        Pedido: this._Pedido,
                        Linea: this._LineaSeleccionada
                    })))
                        .abre();
                }
                else {
                    vResultadoSeleccionLinea = await (0, componentes_1.dialogo)()
                        .titulo(Resources.PantallaRecepcion.DialogoLotesUbicaciones.TituloTranspasos)
                        .plantilla('Recepcion/dialogos/plantillas/dialogo-lotes-ubicaciones-traspasos')
                        .construye(pModal => new dialogo_lotes_ubicaciones_traspasos_1.DialogoLotesUbicacionesTraspasos(new dialogo_lotes_ubicaciones_modelo_1.LotesUbicacionesModel({
                        modal: pModal,
                        Pedido: this._Pedido,
                        Linea: this._LineaSeleccionada
                    })))
                        .abre();
                }
                if (!vResultadoSeleccionLinea) {
                    foco_1.foco.en(this._inputReferencia);
                    return;
                }
                assert.esUn(vResultadoSeleccionLinea);
                this.ActualizaCantidadesPedido(this._LineaSeleccionada, vResultadoSeleccionLinea);
                foco_1.foco.en(this._inputReferencia);
            }
            else {
                this._DatosPantalla.ReferenciaArticulo = this._LineaSeleccionada.GAART_COD;
                this.actualizaVista();
                this._inputCantidad.foco();
            }
        }
        ActualizaCantidadesPedido(pLineaSeleccionada, pResultadoSeleccionLinea) {
            pLineaSeleccionada.Existencias = pResultadoSeleccionLinea.Disponible;
            pLineaSeleccionada.C_PDTE -= pResultadoSeleccionLinea.Preparado.C_PREP;
            const vLinea = this._PedidoPreparado.Lineas.find(pLinea => pLinea.N_LIN === pLineaSeleccionada.N_LIN);
            if (vLinea) {
                vLinea.C_UNI1 += pResultadoSeleccionLinea.Preparado.C_PREP;
                pResultadoSeleccionLinea.Preparado.Detalles.forEach(pItemPreparado => {
                    const vLineaEncontrada = vLinea.Detalles.find(pItemLinea => pItemPreparado.GAUBIC_DES === pItemLinea.GAUBIC_DES && pItemPreparado.LOTE_DES === pItemLinea.LOTE_DES);
                    if (vLineaEncontrada)
                        vLineaEncontrada.C_UNI1 += pItemPreparado.C_UNI1;
                });
                pLineaSeleccionada.Detalles = vLinea.Detalles;
            }
            else {
                this._PedidoPreparado.Lineas.push(new pedido_linea_1.PedidoLineaPreparada({
                    N_LIN: pLineaSeleccionada.N_LIN,
                    C_UNI1: pResultadoSeleccionLinea.Preparado.C_PREP,
                    Detalles: pResultadoSeleccionLinea.Preparado.Detalles
                }));
                pLineaSeleccionada.Detalles = pResultadoSeleccionLinea.Preparado.Detalles;
            }
        }
        async actualizaPreparadoArticuloSinLotesNiUbicaciones(pValor) {
            let vDisponible = this._LineaSeleccionada.Existencias;
            let vLineaPreparada = new dialogo_lotes_ubicaciones_modelo_1.LineaPreparada({ Disponible: vDisponible, Preparado: new dialogo_lotes_ubicaciones_modelo_1.DetallesLineaPreparada({ C_PREP: this._LineaSeleccionada.C_PREP || 0 + pValor }) });
            this.ActualizaCantidadesPedido(this._LineaSeleccionada, vLineaPreparada);
            this._LineaSeleccionada = null;
            this._inputCantidad.valor('');
            this.actualizaVista();
            this._inputReferencia.foco();
        }
        async ObtenerDatosAdicionalesAlbaran() {
            const vDatosAdicionales = await (0, componentes_1.dialogo)()
                .titulo(Resources.PantallaRecepcion.DialogoDatosAdicionales.Titulo)
                .plantilla('recepcion/dialogos/plantillas/dialogo-datos-adicionales-albaran')
                .construye(pModal => new dialogo_datos_adicionales_albaran_1.DialogoDatosAdicionalesAlbaran(pModal, { F_ALBARAN: this._DatosPantalla.AlbaranSeleccionado.F_ALBARAN, SU_REF_ALB: this._DatosPantalla.AlbaranSeleccionado.SU_REF_ALB }))
                .abre();
            assert.esUn(vDatosAdicionales);
            this._DatosPantalla.AlbaranSeleccionado.SU_REF_ALB = vDatosAdicionales?.SU_REF_ALB ? vDatosAdicionales?.SU_REF_ALB : null;
            return vDatosAdicionales;
        }
        async recepcionar() {
            const v_datosAdicionales = await this.ObtenerDatosAdicionalesAlbaran();
            if (v_datosAdicionales) {
                this._PedidoPreparado.F_ALBARAN = moment.utc(this._DatosPantalla.AlbaranSeleccionado.F_ALBARAN, 'DD/MM/YYYY').toISOString(true);
                this._PedidoPreparado.GGALBTIP_COD = this._DatosPantalla.AlbaranSeleccionado.GGALBTIP_COD;
                this._PedidoPreparado.N_ALBARAN = this._DatosPantalla.AlbaranSeleccionado.N_ALBARAN;
                this._PedidoPreparado.SU_REF_ALB = this._DatosPantalla.AlbaranSeleccionado.SU_REF_ALB;
                this._PedidoPreparado.GGPEDTIP_COD = this._Pedido.GGPEDTIP_COD;
                this._PedidoPreparado.N_PEDIDO = this._Pedido.N_PEDIDO;
                let vResultado;
                let vMensaje;
                try {
                    [vResultado, vMensaje] = await (0, api_1.api)('/Recepcion/Recepcionar')
                        .metodo('post')
                        .parametros(this._PedidoPreparado)
                        .invoca();
                    await (0, componentes_1.mensaje)().muestra(vMensaje);
                }
                catch ([vMensaje]) {
                    await (0, componentes_1.mensaje)().error().muestra(vMensaje);
                }
                this.nuevo();
            }
        }
    }
    exports.PantallaRecepcion = PantallaRecepcion;
});
