﻿var v_fecha;
var v_fecha_string;

$(document).ready(function () {
});

function menuDatePicker(p_id, p_cambio) {
    const v_id = typeof p_id === 'string' ? p_id : 'menuDate';
    const v_cambio = typeof p_cambio === 'function' ? p_cambio : () => { };
    const v_lang = $("html").attr("lang") ? $("html").attr("lang").split('-')[0] : 'es';

    Globalize.load({
        "supplemental": {
            "version": {
                "_unicodeVersion": "13.0.0",
                "_cldrVersion": "37"
            },
            "likelySubtags": {
                "es": "es-Latn-ES",
                "en": "en-Latn-US",
                "pt": "pt-Latn-BR",
                "fr": "fr-Latn-FR"
            }
        }
    });
    Globalize.locale(v_lang);

    $('#' + v_id + ' div input')
        .datepicker({
            format: 'dd/mm/yyyy',
            language: $("html").attr("lang") ? $("html").attr("lang").split('-')[0] : 'es',
            autoclose: true,
            orientation: "bottom right",
            //todayBtn: true
            clearBtn: true
        })
        .on("changeDate", function (p_evento) {
            v_cambio(moment(p_evento.date).format('DD/MM/YYYY'));
        })
        .on("clearDate", function () {
            v_cambio(null);
        });

    $('#' + v_id + ' div input > .form-control').prop('disabled', true);

    var dateShowing = false;

    $('#' + v_id + ' div input')
        .datepicker()
        .on('hide', function (e) {
            dateShowing = false;

        });

    $('#' + v_id + '')
        .on('click', function () {
            if (typeof data !== 'undefined') {
                if (dateShowing) {
                    $('#' + v_id + ' div input').datepicker('hide');
                } else {
                    $('#' + v_id + ' div input').datepicker('show');
                    dateShowing = true;
                }

            }
        });
}

function dateToString(v_date) {
    var format = Globalize($("html").attr("lang")).culture().calendar.patterns.d.toUpperCase();

    return moment(new Date(v_date)).format(format);
}

function updateDatePicker(v_date, p_id) {
    const v_id = typeof p_id === 'string' ? p_id : 'menuDate';

    v_date && $('#' + v_id + ' div input').datepicker('setDate', new Date(v_date));
}

function getDateAlb(albaran) {
    var v_date = albaran ? albaran.F_ALBARAN_HID : new Date();
    return v_date;
}

function fechaAlbaran(fecha_string) {
    var date;
    if (fecha_string === "") {
        date = new Date();
    } else {
        date = new Date(fecha_string);
    }
    return date;
}

function getFechaAlbaran(p_id) {
    const v_id = typeof p_id === 'string' ? p_id : 'menuDate';
    var d = $('#' + v_id + ' div input').datepicker('getDate');

    return new Date(d.getTime() - d.getTimezoneOffset() * 60000).toJSON();
}
