﻿function leerEtiqueta(p_etiqueta) {

    var v_sinConversion = function (p_texto) { return p_texto; };

    var v_conversionFecha = function (p_texto) {
        var v_anyo = Number(p_texto.substr(0, 2));
        var v_mes = Number(p_texto.substr(2, 2));
        var v_dia = Number(p_texto.substr(4, 2));
        if (v_anyo < 50) {
            v_anyo = 2000 + v_anyo;
        }
        return new Date(v_anyo, v_mes, v_dia);
    };


    //var v_gs = "\x1d";
    //var v_gs = "\[GS]";
    var v_gs = String.fromCharCode(29);

    var v_exclusion = "[^" + v_gs + "]";
    //var v_alfanumerico = "[a-zA-Z][0-9]";
    // v_alfanumerico + "{    =>     ".{
    var v_fijos = [
        { ia: "00", patron: "[0-9]{18}", conversor: v_sinConversion },
        { ia: "01", patron: "[0-9]{14}", conversor: v_sinConversion },
        { ia: "02", patron: "[0-9]{14}", conversor: v_sinConversion },
        { ia: "11", patron: "[0-9]{6}", conversor: v_conversionFecha },
        { ia: "12", patron: "[0-9]{6}", conversor: v_conversionFecha },
        { ia: "13", patron: "[0-9]{6}", conversor: v_conversionFecha },
        { ia: "15", patron: "[0-9]{6}", conversor: v_conversionFecha },
        { ia: "17", patron: "[0-9]{6}", conversor: v_conversionFecha },
        { ia: "20", patron: "[0-9]{2}", conversor: v_sinConversion },
        { ia: "402", patron: "[0-9]{17}", conversor: v_sinConversion },
        { ia: "410", patron: "[0-9]{13}", conversor: v_sinConversion },
        { ia: "411", patron: "[0-9]{13}", conversor: v_sinConversion },
        { ia: "412", patron: "[0-9]{13}", conversor: v_sinConversion },
        { ia: "413", patron: "[0-9]{13}", conversor: v_sinConversion },
        { ia: "414", patron: "[0-9]{13}", conversor: v_sinConversion },
        { ia: "415", patron: "[0-9]{13}", conversor: v_sinConversion },
        { ia: "422", patron: "[0-9]{3}", conversor: v_sinConversion },
        { ia: "424", patron: "[0-9]{3}", conversor: v_sinConversion },
        { ia: "425", patron: "[0-9]{3}", conversor: v_sinConversion },
        { ia: "426", patron: "[0-9]{3}", conversor: v_sinConversion },
        { ia: "7001", patron: "[0-9]{13}", conversor: v_sinConversion },
        { ia: "8001", patron: "[0-9]{14}", conversor: v_sinConversion },
        { ia: "8005", patron: "[0-9]{6}", conversor: v_sinConversion },
        { ia: "8006", patron: "[0-9]{14}[0-9]{2}[0-9]{2}", conversor: v_sinConversion },
        { ia: "8018", patron: "[0-9]{18}", conversor: v_sinConversion },
        { ia: "8100", patron: "[0-9]{1}[0-9]{5}", conversor: v_sinConversion },
        { ia: "8101", patron: "[0-9]{1}[0-9]{5}[0-9]{4}", conversor: v_sinConversion },
        { ia: "8102", patron: "[0-9]{1}[0-9]{1}", conversor: v_sinConversion }
    ];

    var v_variables = [
        { ia: "10", patron: v_exclusion + "{1,20}", conversor: v_sinConversion },
        { ia: "21", patron: v_exclusion + "{1,20}", conversor: v_sinConversion },
        { ia: "22", patron: v_exclusion + "{1,29}", conversor: v_sinConversion },
        { ia: "240", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "241", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "250", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "251", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "37", patron: "[0-9]{1,8}", conversor: parseInt },

        { ia: "3900", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3901", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3902", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3903", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3904", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3905", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3906", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3907", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3908", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3909", patron: "[0-9]{1,15}", conversor: parseInt },

        { ia: "3910", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3911", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3912", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3913", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3914", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3915", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3916", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3917", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3918", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3919", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },

        { ia: "3920", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3921", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3922", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3923", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3924", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3925", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3926", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3927", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3928", patron: "[0-9]{1,15}", conversor: parseInt },
        { ia: "3929", patron: "[0-9]{1,15}", conversor: parseInt },

        { ia: "3930", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3931", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3932", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3933", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3934", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3935", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3936", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3937", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3938", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },
        { ia: "3939", patron: "[0-9]{3}[0-9]{1,15}", conversor: v_sinConversion },

        { ia: "400", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "401", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "403", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },

        { ia: "420", patron: "[0-9]{1,20}", conversor: v_sinConversion },
        { ia: "421", patron: "[0-9]{3}.{1,9}", conversor: v_sinConversion },
        { ia: "423", patron: "[0-9]{3}[0-9]{1,12}", conversor: v_sinConversion },

        { ia: "7002", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "7030", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7031", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7032", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7033", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7034", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7035", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7036", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7037", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7038", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },
        { ia: "7039", patron: "[0-9]{3}.{1,27}", conversor: v_sinConversion },

        { ia: "8002", patron: "[0-9]{1,20}", conversor: v_sinConversion },
        { ia: "8003", patron: "[0-9]{14}.{1,16}", conversor: v_sinConversion },
        { ia: "8004", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },

        { ia: "8007", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "8008", patron: "[0-9]{8}[0-9]{1,4}", conversor: v_sinConversion },
        { ia: "8020", patron: v_exclusion + "{1,25}", conversor: v_sinConversion },

        { ia: "90", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "91", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "92", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "93", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "94", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "95", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "96", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "97", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "98", patron: v_exclusion + "{1,30}", conversor: v_sinConversion },
        { ia: "99", patron: v_exclusion + "{1,30}", conversor: v_sinConversion }
    ];


    var v_descriptores = getDescriptores();

    function getDescriptores() {        
        var map = new Array();
        var v_todos = new Array();
        for (i = 0; i < v_fijos.length; i++) {
            v_todos.push({ ia: v_fijos[i].ia, patron: "(" + v_fijos[i].ia + "(?:" + v_fijos[i].patron + "))", conversor: v_fijos[i].conversor });
        }           
        for (i = 0; i < v_variables.length; i++) {
            v_todos.push({ ia: v_variables[i].ia, patron: "(" + v_variables[i].ia + "(?:" + v_variables[i].patron + ")" + v_gs + ")", conversor: v_variables[i].conversor });
        }
        for (i = 0; i < v_variables.length; i++) {
            v_todos.push({ ia: v_variables[i].ia, patron: "(" + v_variables[i].ia + "(?:" + v_variables[i].patron + "))", conversor: v_variables[i].conversor });
        }
        for (i = 0; i < v_todos.length; i++) {
            map.push({ ia: v_todos[i].ia, posicion: i, patron: v_todos[i].patron, conversor: v_todos[i].conversor });
        }
        return map;
    }
    
    var v_patron = "^" + v_gs + "?";
    for (i = 0; i < v_descriptores.length; i++) {
        v_patron = v_patron + v_descriptores[i].patron + "|"
    }
    v_patron = v_patron.replace(/.$/, "$");    

    var v_regex = new RegExp(v_patron, "gy");
    
    var v_conversores = new Array();
    for (i = 0; i < v_descriptores.length; i++) {
        v_conversores.push([v_descriptores[i].ia, v_descriptores[i].conversor]);
    }
    v_conversores = objectify(v_conversores);
    function objectify(array) {
        return array.reduce(function (p, c) {
            p[c[0]] = c[1];
            return p;
        }, {});
    }

    var obtenerIdentificadores = function (p_etiqueta) {
        var v_identificadores = [];
        var v_coincidencia;
        while ((v_coincidencia = v_regex.exec(p_etiqueta)) !== null) {
            // This is necessary to avoid infinite loops with zero-width matches
            if (v_coincidencia.index === p_etiqueta.lastIndex) {
                p_etiqueta.lastIndex++;
            }

            v_coincidencia.forEach(function (p_coincidencia, p_posicion) {
                if (p_coincidencia != null && p_posicion > 0) {
                    var v_ia = v_descriptores[p_posicion - 1].ia;
                    var v_texto = p_coincidencia.substring(v_ia.length);
                    var v_conversor = v_conversores[v_ia];
                    var v_valor = v_conversor(v_texto.replace(v_gs, ""));
                    v_identificadores.push({ ia: v_ia, valor: v_valor });
                }
            });
        }

        return v_identificadores;
    };    
    return { obtenerIdentificadores: obtenerIdentificadores(p_etiqueta) };
};
