﻿var v_albaranSeleccionado;

function selectAlbaran() {
    // Para cambios de albarán en medio de un pedido en proceso
    $('#tablaAlbaranes').on('dblclick', function () {
        seleccionAlbaran();
        closeModal('#dialogLoV');
    });

    $('#seleccionarAlbaran').on("click", function () {
        seleccionAlbaran();
        closeModal('#dialogLoV');
    });

    $('#nuevoAlbaran').on("click", function () {
        datosAlbaran("", "", "");
        closeModal('#dialogLoV');
    });
}

function selectAlbaranPintarPed() {
    // Selección de albarán que añade los datos del pedido a la tabla
    $('#tablaAlbaranes').on('dblclick', function () {
        seleccionAlbaran();
        pintarTablaPedidos();
        closeModal('#dialogLoV');
    });

    $('#seleccionarAlbaran').on("click", function () {
        seleccionAlbaran();
        pintarTablaPedidos();
        closeModal('#dialogLoV');
    });

    $('#nuevoAlbaran').on("click", function () {
        datosAlbaran("", "", "");
        pintarTablaPedidos();
        closeModal('#dialogLoV');
    });
}

function datosAlbaran( tipoAlbaran, numAlbaran, fechaAlbaran) {
    // Recoge los datos del albaran y actualiza los datos en el menú
    $('#tipoAlbaran').val( tipoAlbaran);
    $('#numAlbaran').val( numAlbaran);
    $('#confirmar').prop('disabled', false);
    $('#dialogAlbaranes').modal('hide');
    v_fecha = fechaAlbaran === "" ? new Date() : new Date(fechaAlbaran);
    updateDatePicker(v_fecha);
    cambioAlbaran();
}

function seleccionAlbaran() {
    if ($('#tablaAlbaranes').DataTable().rows()[0].length > 0) {
        v_albaranSeleccionado = $('#tablaAlbaranes').DataTable().row('.selected').data();
        var v_albaran_seleccionado = $('#tablaAlbaranes').DataTable().rows('.selected').data()[0];
        var v_tipoAlbaran = v_albaran_seleccionado.GGALBTIP_COD;
        var v_numAlbaran = v_albaran_seleccionado.N_ALBARAN;
        var v_fechaAlbaran = v_albaran_seleccionado.F_ALBARAN_HID;
        datosAlbaran(v_tipoAlbaran, v_numAlbaran, v_fechaAlbaran);
        cambioAlbaran();
    }
}

function pintarTablaPedidos() {
    data = dataAux;

    // Clon de data para que los datos no sean modificados 
    // en el caso de que se cancele la operación
    v_dataClon = JSON.parse(JSON.stringify(data));

    initialize();
    generarMenu();

    var v_table = $('#tablaPedidos').DataTable();
    v_table.clear().draw();
    if (v_table.rows.length === 0) {
        v_table.rows.add(data.Lineas).draw();
        v_lineas = v_table.rows().data();
        selectRow('#tablaPedidos');
    }
    $('#menuObservaciones').show();

    $('#txtRefer').addClass('col-xs-10');
    $('#txtRefer').removeClass('col-xs-5');
    $('.sinLote').hide();

        $('#campRefer').val("").get(0).focus();
    // Si el pedido tiene alguna observación
    if (data.OBSER) {
        $('#menuObservaciones input').val(Resources.menu_show);
    } else {
        $('#menuObservaciones input').val(Resources.menu_no_observations);
    }

    // Si el albarán no es nuevo
    if (typeof v_albaranSeleccionado !== 'undefined') {
        var refAlb = v_albaranSeleccionado.SU_REF_ALB;
        $('#menuRefAlbaran input').val(refAlb);
        $('#codRefAlbaran').val(refAlb);
    }
    closeModal("#dialogAlbaranes");
}


function cambioAlbaran() {
    // Actualiza el menú desplegable con el albarán seleccionado
    if ($("#tipoAlbaran").val() !== "" && $("#numAlbaran").val() !== "") {
        v_albaran = $("#tipoAlbaran").val() + "-" + $("#numAlbaran").val();
    } else {
        v_albaran = Resources.menu_new;
    }
    $('#menuAlbaran div input').val(v_albaran);
}