﻿
/**
 * TODO AAZ: Faltan descripciones de parametros
 * 
 * Genera una ventana modal que adapta su contenido a los elementos que se se añaden en la función.
 * 
 * var dialog = "#ejemplo";
 * var columnsWidth => número entre [ 1 - 12 ]
 * 
 * @param {string} href                x
 * @param {string} dialog              x
 * @param {string} tableName           x
 * @param {JSON} data                  x
 * @param {Array<JSON>} dataJSON       x
 * @param {Array} columnsJSON          x
 * @param {Array} buttonArray          x
 * @param {Array} inputArray           x
 * @param {Array} upperInputArray      x
 * @param {function} funcionName       x
 * @param {string} title               x
 * @param {Array<string>} innerDialogs x
 * @param {string} message             x
 * @param {number} columnsWidth        x
 * @param {string} zeroRecordsMessage  x
 * @param {number} displayLength       x
 * @param {boolean} responsive         x
 * @param {Array<Object>} columnDefs   x
 * @param {boolean} searchField        Mostrar Campo de búsqueda
 * 
 * @returns {boolean} false
 */
function generarDialogAuto(href, dialog, tableName, data, dataJSON, columnsJSON, buttonArray, inputArray, upperInputArray,
    funcionName, title, innerDialogs, message, columnsWidth, zeroRecordsMessage, displayLength, responsive, columnDefs, searchField, closable) {
    var v_success = function (response, status, xhr) {
        if (response.Ok) {
            if (response.Objeto) {
                dataJSON = JSON.parse(response.Objeto);
            }
            $(dialog).html(response.Mensaje);
            showDialog(dialog);
            if (tableName) {
                $(dialog + ' table').prop('id', tableName);
                generateTable(dialog, dataJSON, columnsJSON, tableName, zeroRecordsMessage, displayLength, responsive, columnDefs, searchField);
            } else {
                $(dialog + ' .lateralTable').hide();
            }

            if (message) {
                generateMessage(message, dialog, tableName);
                if (!tableName && !inputArray)
                    $(dialog + ' #lovMessage').css('height', '100%');
            }

            if (buttonArray) {
                generateButtons(buttonArray, dialog, inputArray, message, tableName);
            }
            if (inputArray) {
                generateInputs(inputArray, dialog);
                if (tableName) {
                    $(dialog + ' .lateralTable').addClass('hasInputField');
                } else
                    $(dialog + ' .lateralInputs').css('height', '100%');
                $(dialog + ' .lateralInputs').css('display', 'table-row');
            }

            if (upperInputArray) {
                generateUpperInputs(upperInputArray, dialog);
            }

            if (funcionName) {
                funcionName();
            }
            toUpper();

            if (innerDialogs) {
                newDialogs(innerDialogs, dialog);
            }

            autoselect(dialog);
            tabulado(dialog);

            $(dialog + ' .modal-header .modal-title').html(title);
            //$('#' + tableName).DataTable().columns.adjust().responsive.rebuild().responsive.recalc();
            $('.disabled').prop('disabled', true);

            if (closable === false) {
                $(dialog + ' .modal-close').css('display', 'none');
            }
        } else {
            lanzarMensaje(response.Ok, response.Mensaje);
        }
    };

    if (href.toLowerCase() === 'dialog/dialog') {
        var v_mensaje = '<div class="modal-dialog" >' +
            '    <div class="modal-content" style="width:100%">' +
            '        <div class="modal-header">' +
            '            <label class="modal-title"></label>' +
            '            <div class="modal-close">' +
            '                <div type="button" class="rf-icon-button rf-cerrar" data-dismiss="modal"></div>' +
            '            </div>' +
            '        </div>' +
            '' +
            '        <div class="modal-body spy-display spy-display-table-row">' +
            '            <div class="modal-bodyContainer spy-display spy-display-table">' +
            '                <div class="botonera botoneraDialog">' +
            '                    <div class="buttonPlaceholder"></div>' +
            '                </div>' +
            '                <div class="lateralTable spy-display spy-display-table spy-inline">' +
            '                    <table class="table table-striped table-hover table-condensed" style="width:100%;table-layout:fixed;">' +
            '                        <thead><tr></tr></thead>' +
            '                        <tbody></tbody> ' +
            '                    </table>' +
            '                </div>' +
            '                <div class="fieldset fieldsetSinMargin lateralInputs spy-inline inputField" style="display:none;"></div>' +
            '                <div class="botonera botoneraDialog">' +
            '                    <div class="botoneraInf"></div>' +
            '                </div>' +
            '            </div>' +
            '        </div>' +
            '    </div>' +
            '</div>';
        v_success({ Ok: true, Mensaje: v_mensaje || "", Objeto: null });
    }
    else {
        $.ajax({
            url: href,
            cache: false,
            //dataType: 'json',
            data: data,
            success: v_success,
            error: function (xhr, error) {
                console.log(xhr);
                console.error(error);
            }
        });
    }

    return false;
}

function generateButtons(buttons, dialog, inputs, message, tableName) {
    if (!buttons) {
        buttons = [];
    }
    var buttonString = "";
    for (i = 0; i < buttons.length; i++) {
        var position = "pull-right";
        if (buttons[i].position && buttons[i].position !== "") {
            position = buttons[i].position;
        }
        var btnClass = buttons[i].btnClass ? buttons[i].btnClass : "default";
        buttonString = buttonString + "<button class='boton boton-" + btnClass + " " + position + "' id='" + buttons[i].id + "'>" + buttons[i].value + "</button>";
    }
    if (buttons.length === 1) {
        $(dialog + " .botoneraInf").html(buttonString);
        $(dialog + " .modal-bodyContainer.spy-display.spy-display-table").addClass("blank-space");
        //$(dialog + " .botoneraInf").css('position', 'absolute').css('left', '0').css('bottom', '0');
        $(dialog + " .botoneraInf button").css('width', '100%');
    } else {
        $(dialog + " .buttonPlaceholder").html(buttonString);
    }

    if ((buttons.length > 2 /*|| message*/) && buttons.length <= 5 && !inputs) {
        $(dialog + " .botoneraDialog").addClass('botoneraLateral');
        if (buttons.length === 4) {
            $(dialog + " .buttonPlaceholder").addClass('botones-4');
        }
    } else if (buttons.length > 5 && !inputs) {
        $(dialog + " .buttonPlaceholder").addClass('medium-button-field');
    } else if ((inputs || message) && buttons.length > 2) {
        $(dialog + " .buttonPlaceholder").addClass('small-button-field');
    } else if (!inputs && !message && buttons.length <= 2) {
        $(dialog + " .botoneraDialog").addClass('botoneraLarga');
        $('#' + tableName + "_wrapper").addClass('longTable');
    }
}

function generateSingleInput(width, label, inputId, value, fieldsetId, className, isNumeric, type, disabled) {
    var input = { width: width, label: label, id: inputId, value: value, fieldId: fieldsetId, className: className, isNumeric: isNumeric, type: type, disabled: disabled };
    return input;
}

function generateSearchInput(width, label, id, value, descriptionField, validationFunction, searchButtonFunction, className) {
    var input = {
        width: width,
        label: label,
        id: id,
        value: value,
        validationFunction: validationFunction,
        className: className,
        descriptionField: descriptionField,
        searchButtonFunction: searchButtonFunction,
        search: true
    };
    return input;
}

//<div id="buscaAlmacen" class=" col-xs-12">
//    @Html.LabelFor(p => p.v_almacen, new { @class = "col-xs-4 control-label" })
//                        <div class="col-xs-8">
//        <div class="searchField">
//            @Html.TextBoxFor(p => p.v_almacen, new { @id = "GAALMNOM_COD", @class = "form-control input-sm input-xs" })
//                            </div>
//        <div class="rf-icon-button rf-buscador" id="btnBuscaAlmacen"></div>
//    </div>
//    <input type="text" id="GAALMNOM_DESCRIP" class="form-control input-sm input-xs" disabled="disabled" />
//</div>

//function generateInputs(inputs, dialog) {
//    for (i = 0; i < inputs.length; i++) {
//        var fieldSet = document.createElement('div');
//        $(fieldSet).addClass('col-xs-' + inputs[i].width).prop('id', inputs[i].fieldId);
//        var label = document.createElement('label');
//        $(label).addClass(labelClass).text(inputs[i].label);
//        var input = document.createElement('input'); 
//        $(input).prop('id', inputs[i].id).addClass('form-control input-xs ' + inputs[i].className).val(inputs[i].value);

//        if (search) {
//            $(fieldSet).addClass("searchInput");
//        } else {
//            var labelClass = "";
//            if (inputs[i].className)
//                if (inputs[i].className.indexOf('text-right') !== -1) {
//                    labelClass = 'numberInputLabel';
//                }
//            if (inputs[i].isNumeric) {
//                $(input).prop('type', 'text');
//                labelClass = 'pull-right';
//            }
//        }
//        $(fieldSet).append(label);
//        $(fieldSet).append(input);
//        $(dialog + " .inputField").append(fieldSet);    
//    }
//}

function generateInputs(inputs, dialog) {
    for (i = 0; i < inputs.length; i++) {
        var fieldSet = document.createElement('div');
        $(fieldSet).addClass('col-xs-' + inputs[i].width).prop('id', inputs[i].fieldId);
        var labelClass = "";
        if (inputs[i].className)
            if (inputs[i].className.indexOf('text-right') !== -1) {
                labelClass = 'numberInputLabel';
            }
        var label = document.createElement('label');
        $(label).addClass(labelClass).text(inputs[i].label);
        var input;
        if (inputs[i].search) {
            var searchFieldDiv = document.createElement('div');
            $(searchFieldDiv).addClass('searchField');

            input = document.createElement('input');
            $(input).prop('id', inputs[i].id).addClass('form-control input-xs');

            $(searchFieldDiv).append(input);

            var searchButton = document.createElement('div');
            $(searchButton).addClass('rf-icon-button rf-buscador');
            var labelContainer = document.createElement("div");
            labelContainer.classList = "fillAvailable";
            $(labelContainer).append(label);
            $(fieldSet).append(labelContainer);
            $(fieldSet).append(searchFieldDiv);
            $(fieldSet).append(searchButton);
            if (inputs[i].descriptionField) {
                var searchDescripFieldset = document.createElement('div');
                $(searchDescripFieldset).addClass('col-xs-12');
                var descrInput = document.createElement('input');
                $(descrInput).addClass("form-control input-sm input-xs");
                $(descrInput).prop('disabled', 'disabled');
                $(descrInput).prop('id', inputs[i].descriptionField);

                $(searchDescripFieldset).append(descrInput);
                $(fieldSet).append(searchDescripFieldset);
            }
            addEvent(input, 'change', inputs[i].validationFunction);
            addEvent(searchButton, 'click', inputs[i].searchButtonFunction);
        } else {
            input = document.createElement('input');
            if (inputs[i].isNumeric) {
                $(input).prop('type', 'text');
                $(input).addClass('text-right');
                $(input).on('change', function () { $(input).val(TryParseFloat($(input).val(), 0)); })
                $(fieldSet).css("text-align", "right");
            }
            $(input).prop('id', inputs[i].id).addClass('form-control input-xs ' + inputs[i].className).val(inputs[i].value);
            $(input).prop('disabled', inputs[i].disabled);
            $(fieldSet).append(label);
            $(fieldSet).append(input);
        }
        $(dialog + " .inputField").append(fieldSet);
    }
}


function generateTable(dialog, dataJSON, columnsJSON, table, zeroRecordsMessage, displayLength, responsive, columnDefs, searchField) {
    if (columnsJSON) {
        var col = "";
        for (i = 0; i < columnsJSON.length; i++) {
            col = col + '<th>' + columnsJSON[i].name + '</th>';
        }
        $(dialog + ' #' + table + ' thead tr').html(col);

        createTableJson('#' + table, dataJSON, columnsJSON, displayLength, zeroRecordsMessage, columnDefs, responsive, null, searchField);
    } else {
        createTable('#' + table, null, zeroRecordsMessage, responsive, searchField);
    }
}

function generateUpperInputs(upperInputs, dialog) {
    var inputField = document.createElement('div');
    $(inputField).addClass('campSupUbi');
    for (i = 0; i < upperInputs.length; i++) {
        var fieldSet = document.createElement('div');
        var input = document.createElement('input');
        var label = document.createElement("label");
        if (upperInputs[i].type === "Button") {

            var btnClass = upperInputs[i].className ? upperInputs[i].className : "default";
            var button = document.createElement("button");
            $(fieldSet).addClass('fieldset col-xs-' + upperInputs[i].width);
            button.classList = "boton boton-" + btnClass;
            button.id = upperInputs[i].id;
            button.innerText = upperInputs[i].value;
            $(button).css("display", "block").css("width", "100%");
            //buttonString = buttonString + "<button class='boton boton-" + btnClass + " " + position + "' id='" + upperInputs[i].id + "'>" + upperInputs[i].value + "</button>";

            $(fieldSet).append(label);
            $(fieldSet).append(button);

        } else {
            var labelClass = "";
            if (upperInputs[i].className)
                if (upperInputs[i].className.indexOf('text-right') !== -1) {
                    labelClass = 'pull-right';
                }
            $(fieldSet).addClass('fieldset col-xs-' + upperInputs[i].width).prop('id', upperInputs[i].fieldId);
            $(label).addClass(labelClass).text(upperInputs[i].label);
            if (upperInputs[i].search) {
                var searchFieldDiv = document.createElement('div');
                $(searchFieldDiv).addClass('searchField');

                $(input).prop('id', upperInputs[i].id).addClass('form-control input-xs focusable ' + upperInputs[i].className);
                $(input).prop("disabled", upperInputs[i].disabled);

                $(searchFieldDiv).append(input);

                var searchButton = document.createElement('div');
                $(searchButton).addClass('rf-icon-button rf-buscador');


                var labelContainer = document.createElement("div");
                labelContainer.classList = "fillAvailable";
                $(labelContainer).append(label);
                $(fieldSet).append(labelContainer);

                $(fieldSet).append(searchFieldDiv);
                $(fieldSet).append(searchButton);
                if (upperInputs[i].descriptionField) {
                    var searchDescripFieldset = document.createElement('div');
                    $(searchDescripFieldset).addClass('col-xs-12');
                    var descrInput = document.createElement('input');
                    $(descrInput).addClass("form-control input-sm input-xs");
                    $(descrInput).prop('disabled', 'disabled');
                    $(descrInput).prop('id', upperInputs[i].descriptionField);

                    $(searchDescripFieldset).append(descrInput);
                    $(fieldSet).append(searchDescripFieldset);
                }

                addEvent(input, 'change', upperInputs[i].validationFunction);
                addEvent(searchButton, 'click', upperInputs[i].searchButtonFunction);

            } else {
                $(input).prop('id', upperInputs[i].id).addClass('form-control input-xs focusable ' + upperInputs[i].className).val(upperInputs[i].value);
                $(input).prop("disabled", upperInputs[i].disabled);
                if (upperInputs[i].isNumeric) {
                    $(input).addClass('text-right');
                    $(input).prop('type', 'text');
                    $(input).on('change', function () { $(input).val(TryParseFloat($(input).val(), 0)); })
                    $(fieldSet).css("text-align", "right");
                }
                $(label).addClass(labelClass).text(upperInputs[i].label);
                $(fieldSet).append(label);
                $(fieldSet).append(input);
            }
        }

        $(inputField).append(fieldSet);
    }

    $(dialog + ' .lateralTable ').before(inputField);

    //var inputString = "<div class='campSupUbi'>";
    //var inputClass = 'form-control input-xs ';
    //for (i = 0; i < upperInputs.length; i++) {
    //    inputString = inputString +
    //        "<div class='fieldset col-xs-" + upperInputs[i].width + "' id='" + upperInputs[i].fieldId + "'> \
    //            <label>" + upperInputs[i].label + ":</label> \
    //            <input id='" + upperInputs[i].id + "' class='" + inputClass + upperInputs[i].className + "' value='" + upperInputs[i].value + "'> \
    //        </div>";
    //}
    //inputString = inputString  + '</div>';
    //$(dialog + ' .modal-bodyContainer').prepend(inputString);
}

function generateSingleButton(id, name, position, btnClass) {
    return { id: id, value: name, position: position, btnClass: btnClass };
}

function newDialogs(dialogs, dialog) {
    var dialogString = "";
    for (i = 0; i < dialogs.length; i++) {
        dialogString = dialogString + '<div class="modal fade" id="' + dialogs[i] + '" role="dialog"></div>';
    }
    $(dialog).append(dialogString);
}

function generateColumn(code, name, bVisible, bNumeric, sClass) {
    sClass = sClass || "";
    if (bNumeric) sClass += ' dt-right';
    bVisible = typeof bVisible === 'undefined' || bVisible === null || bVisible ? true : false;
    var data = { 'name': name, 'title': name, "bVisible": bVisible };
    if (code) {
        data.mDataProp = code;
    }
    if (sClass !== "") {
        data.sClass = sClass;
    }
    return data;
}

function generateMessage(message, dialog, table) {
    var v_message;
    if (table) {
        v_message = '<div id="lovMessage">\
                            <div>\
                                ' + message + '\
                            </div>\
                        </div>';
        $(dialog + ' .dataTables_scrollBody').addClass('messageTable');
        $(dialog + ' .modal-bodyContainer').prepend(v_message);
    } else {
        v_message = '<div id="lovMessage" style="height:1px;">\
                            <div style="max-height: unset; margin: 10px 0">\
                                ' + message + '\
                            </div>\
                        </div>';
        $(dialog + ' .modal-bodyContainer').prepend(v_message);
    }
}