define(["require", "exports", "componentes/manejador-teclado", "componentes/componente-html"], function (require, exports, manejador_teclado_1, componente_html_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.boton = exports.Boton = exports.DefinicionBoton = void 0;
    class DefinicionBoton extends componente_html_1.ComponenteHTML {
        constructor(_elemento, _valores) {
            super(_elemento);
            this._valores = _valores;
        }
        clic(p_funcion) {
            return new DefinicionBoton(this._elemento, { ...this._valores, clic: p_funcion });
        }
        tecla(p_tecla) {
            return new DefinicionBoton(this._elemento, { ...this._valores, tecla: p_tecla });
        }
        crea() {
            return new Boton(this._elemento, this._valores);
        }
    }
    exports.DefinicionBoton = DefinicionBoton;
    class Boton extends componente_html_1.ComponenteHTML {
        constructor(_elemento, _valores) {
            super(_elemento);
            this._valores = _valores;
            const v_clic = _valores.clic;
            const v_this = this;
            this._elemento.addEventListener('click', function (p_evento) {
                if (v_this.habilitado()) {
                    v_clic(v_this, p_evento);
                }
            });
            if (typeof _valores.tecla === 'string') {
                manejador_teclado_1.manejadorTeclado.captura(_valores.tecla, this._elemento, function (p_evento) {
                    if (v_this.habilitado() && v_this.visible())
                        v_clic(v_this, p_evento);
                });
            }
        }
        etiqueta(p_valor) {
            this._elemento.innerText = p_valor;
            return this;
        }
        deshabilita() {
            this._elemento.setAttribute("disabled", "true");
            return this;
        }
        habilita() {
            this._elemento.removeAttribute("disabled");
            return this;
        }
        habilitado(p_valor) {
            if (arguments.length === 0)
                return !this._elemento.hasAttribute('disabled');
            else if (p_valor)
                this.habilita();
            else
                this.deshabilita();
        }
        visible(p_valor) {
            if (arguments.length === 0)
                return !this._elemento.classList.contains('oculto');
            else if (p_valor)
                this._elemento.classList.remove('oculto');
            else
                this._elemento.classList.add('oculto');
        }
        ;
    }
    exports.Boton = Boton;
    function boton(p_elemento, p_valores = {}) {
        const v_elemento = p_elemento instanceof HTMLElement ? p_elemento : document.getElementById(p_elemento);
        return new DefinicionBoton(v_elemento, { ...p_valores, clic: void 0 });
    }
    exports.boton = boton;
});
