define(["require", "exports", "Utilidades/utilidades", "Utilidades/assert", "componentes/componente-html"], function (require, exports, utilidades_1, assert_1, componente_html_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.foco = void 0;
    class Foco {
        constructor() {
            this._timer = null;
        }
        determinaFocusables(p_contenedor) {
            const v_elementos = p_contenedor.querySelectorAll('*:not([disabled]).focusable');
            const v_focusables = Array.from(v_elementos).filter(p_focusable => p_focusable instanceof HTMLElement);
            return v_focusables;
        }
        en(p_elemento) {
            if (arguments.length === 0) {
                return document.activeElement;
            }
            else {
                const v_elemento = p_elemento instanceof componente_html_1.ComponenteHTML ? p_elemento.obtenElemento() : p_elemento;
                if (this._timer !== null)
                    clearTimeout(this._timer);
                if (typeof v_elemento === 'undefined')
                    return;
                this._timer = setTimeout(function () {
                    if (v_elemento.id)
                        (0, utilidades_1.traza)(`Foco en #${v_elemento.id}: ${v_elemento.tagName}`);
                    else
                        (0, utilidades_1.traza)(`Foco en ${v_elemento.tagName}`);
                    if (v_elemento instanceof HTMLInputElement)
                        v_elemento.select();
                    v_elemento.focus();
                }, 10);
            }
        }
        enPrimero(p_contenedor) {
            const v_focoInicial = p_contenedor.querySelectorAll('*:not([disabled]).focusable.foco-inicial')[0];
            if (typeof v_focoInicial !== 'undefined') {
                (0, assert_1.assert)(v_focoInicial instanceof HTMLElement);
                this.en(v_focoInicial);
                return v_focoInicial;
            }
            const v_focusables = this.determinaFocusables(p_contenedor);
            const v_primero = v_focusables[0];
            this.en(v_primero);
            return v_primero;
        }
        enSiguienteA(p_elemento) {
            if (typeof p_elemento === 'undefined')
                return this.enPrimero();
            const v_elemento = p_elemento instanceof componente_html_1.ComponenteHTML ? p_elemento.obtenElemento() : p_elemento;
            let v_contenedor = v_elemento.closest('.formulario,.modal');
            if (v_contenedor === null)
                v_contenedor = document;
            let v_focusables = this.determinaFocusables(v_contenedor);
            if (typeof v_focusables === 'undefined')
                return;
            const v_focusable = Array.prototype.filter.call(v_focusables, p => p.offsetWidth > 0 || p.offsetHeight > 0 || p === v_elemento);
            const v_indice = v_focusable.indexOf(v_elemento);
            if (v_indice > -1) {
                var v_siguiente = v_focusable[v_indice + 1] || v_focusable[0];
                this.en(v_siguiente);
                return v_siguiente;
            }
            else
                return this.enPrimero(v_contenedor);
        }
    }
    exports.foco = new Foco();
});
