define(["require", "exports", "componentes/pregunta"], function (require, exports, pregunta_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.mensaje = void 0;
    class Mensaje {
        constructor(_texto, _error) {
            this._texto = _texto;
            this._error = _error;
        }
        texto(p_texto) {
            if (typeof p_texto !== 'string') {
                throw new Error('No es un texto válido');
            }
            return new Mensaje(p_texto, this._error);
        }
        ;
        error() {
            return new Mensaje(this._texto, true);
        }
        ;
        async muestra(p_texto) {
            const v_texto = typeof p_texto === 'string' ? p_texto : this._texto;
            let v_pregunta = (0, pregunta_1.pregunta)(v_texto)
                .opciones(['Aceptar'])
                .opcionPredeterminada('Aceptar');
            if (this._error)
                v_pregunta = v_pregunta.error();
            return await v_pregunta.muestra();
        }
        ;
    }
    function mensaje(p_texto) {
        if (arguments.length === 0) {
            p_texto = '';
        }
        return new Mensaje(p_texto, false);
    }
    exports.mensaje = mensaje;
});
