define(["require", "exports", "Utilidades/assert", "componentes/api", "componentes/componentes", "componentes/foco", "componentes/label", "componentes/campo", "componentes/pantalla"], function (require, exports, assert, api_1, componentes_1, foco_1, label_1, campo_1, pantalla_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.PantallaConsultaPrecio = void 0;
    class PantallaConsultaPrecio extends pantalla_1.Pantalla {
        constructor() {
            super();
            this.inicializa();
        }
        inicializaComponentes() {
            foco_1.foco.enPrimero(document);
            return {
                campoLecturaArticulo_cod: (0, campo_1.campo)('gaart_cod')
                    .cambio(async () => {
                    this.actualizaModelo();
                    await this.cargaArticulo();
                    this.actualizaVista();
                }),
                campoGaart_descrip: (0, label_1.label)('gaart_descrip'),
                campoPrecio: (0, campo_1.campo)('precio'),
            };
        }
        actualizaVista() {
            if (typeof this.campoLecturaArticulo_cod === 'undefined') {
                const v_componentes = this.inicializaComponentes();
                Object.getOwnPropertyNames(v_componentes).forEach(p_nombre => this[p_nombre] = v_componentes[p_nombre].crea());
            }
            this.campoLecturaArticulo_cod.valor(this.gaart_cod);
            foco_1.foco.en(this.campoLecturaArticulo_cod);
            this.campoGaart_descrip.valor(this.gaart_descrip);
            if (typeof this.precio == 'number') {
                this.campoPrecio.valor(`${this.precio} €`);
            }
            else {
                this.campoPrecio.valor(null);
            }
        }
        actualizaModelo() {
            this.lecturaArticulo = this.campoLecturaArticulo_cod.valor().toUpperCase();
        }
        async inicializa() {
            this.gaart_cod = this.gaart_descrip = this.precio = null;
            await login();
        }
        async cargaArticulo() {
            this.gaart_cod = this.gaart_descrip = this.precio = null;
            let v_articulo;
            try {
                [v_articulo] = await (0, api_1.api)('/Consultas/PrecioArticulo')
                    .parametros({
                    empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
                    emp_cod: sessionStorage.getItem("EMPR_COD"),
                    lecturaArticulo: this.lecturaArticulo
                })
                    .loguea(async () => await login())
                    .invoca();
            }
            catch ([v_mensaje]) {
                await (0, componentes_1.mensaje)().error().muestra(v_mensaje);
                return;
            }
            assert.esUn(v_articulo, 'GAART_COD', 'GAART_DESCRIP', 'PRECIO');
            this.gaart_cod = v_articulo.GAART_COD;
            this.gaart_descrip = v_articulo.GAART_DESCRIP;
            this.precio = v_articulo.PRECIO;
            return true;
        }
    }
    exports.PantallaConsultaPrecio = PantallaConsultaPrecio;
});
