﻿var Consulta = function () { };

Consulta.prototype = {
    CONFIG: {
        PermiteRegularizar: false,
        Reservas: false,
        MostrarAgrupacion: false
    },
    VIEW: {
        v_table: null,
        columnsJSON: null,
        columnDefs: null,
        v_datatable: null,
        v_lineas: null,
        artic: null,
        ubic: null,
        btnConsArt: null,
        btnReset: null,
        btnUpdate: null
    },

    Init: function () {
        var self = this;
        self.VIEW.v_table = $('#tablaConsultas');
        self.VIEW.artic = document.getElementById('articulo');
        self.VIEW.ubic = document.getElementById('ubicacion');
        self.VIEW.btnConsArt = document.getElementById('btnConsArt');
        self.VIEW.btnReset = document.getElementById('btnReset');
        self.VIEW.btnUpdate = document.getElementById('btnUpdate');

        if (self.VIEW.artic) {
            self.InicioArticulo(self.VIEW.artic);
            $(self.VIEW.artic).focus().select();
            addEvent(self.VIEW.btnReset, 'click', function () { self.ClearArtic(); }, false);

        }
        else {
            self.InicioUbicacion(self.VIEW.ubic);
            $(self.VIEW.ubic).focus().select();
            addEvent(self.VIEW.btnReset, 'click', function () { self.ClearUbic(); }, false);

        }
    },
    ClearArtic: function () {
        var self = this;
        self.VIEW.v_table.DataTable().clear().draw();
        $(self.VIEW.artic).val("");
        $('#exist').val("");
        $('#agrup').val("");
        $('#desc').val("");
        $(self.VIEW.artic).focus().select();
    },
    ClearUbic: function () {
        var self = this;
        self.VIEW.v_table.DataTable().clear().draw();
        $(self.VIEW.ubic).val("");
        $('#descrip').val("");
        $(self.VIEW.ubic).focus().select();
    },
    CreateTable: function () {
        var self = this;
        createTableJson('#tablaConsultas', null, self.VIEW.columnsJSON, 8, null, self.VIEW.columnDefs, false);
        v_datatable = self.VIEW.v_table.DataTable();
        v_lineas = v_datatable.rows().data();
    },

    RegularizarCantidadesArt: function () {
        var self = this;
        var tableData = self.VIEW.v_table.DataTable().rows().data()
            .filter(function (d) {
                return parseInt(d.C_UNI1) !== parseInt(d.C_UNI1_aux) ? true : false;
            });
        if (tableData.length > 0) {
            var Movimientos = tableData.map(function (d) {
                return {
                    GAART_COD: $(self.VIEW.artic).val(),
                    GAUBIC_COD: d.GAUBIC_COD,
                    LOTE: d.LOTE,
                    C_UNID1: d.C_UNI1_aux
                };
            }).toArray();
            var url = "Consultas/Regularizar";
            var method = "PUT";
            var data = {
                "EMPGRUPO_COD": sessionStorage.getItem("EMPRGRUP_COD"),
                "EMP_COD": sessionStorage.getItem("EMPR_COD"),
                "Movimientos": Movimientos
            };
            var success = function (response) {
                if (response.Ok) {
                    successMessage("Regularizado");
                    self.ConsultaArticulo();
                } else {
                    lanzarMensaje(false, response.Mensaje);
                }
            };
            apiGeneral(url, method, data, success);
        }
    },

    RegularizarCantidadesUbic: function () {
        var self = this;
        var tableData = self.VIEW.v_table.DataTable().rows().data()
            .filter(function (d) {
                return parseInt(d.C_UNI1) !== parseInt(d.C_UNI1_aux) ? true : false;
            }).map(function (d) {
                return {
                    GAART_COD: d.GAART_COD,
                    GAUBIC_COD: $(self.VIEW.ubic).val(),
                    LOTE: d.LOTE,
                    C_UNID1: d.C_UNI1_aux,
                };
            }).toArray();
        if (tableData.length > 0) {
            var v_url = "Consultas/Regularizar";
            var v_method = "PUT";
            var v_data = {
                "EMPGRUPO_COD": sessionStorage.getItem("EMPRGRUP_COD"),
                "EMP_COD": sessionStorage.getItem("EMPR_COD"),
                "Movimientos": tableData
            };
            var v_success = function (response) {
                if (response.Ok) {
                    successMessage("Regularizado");
                    self.ConsultaUbicacion();

                }
            };
            apiGeneral(v_url, v_method, v_data, v_success);
        }
    },


    InicioArticulo: function (artic) {
        //addEvent(artic, 'keypress', self.BuscaArticulo, false);

        var self = this;
        // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
        //$(artic).keypress(function (e) { if (e.which === 13) { self.ConsultaArticulo(); } });
        $(artic).on("change", function (e) { self.ConsultaArticulo(); });

        self.VIEW.columnsJSON = [
            generateColumn('GAUBIC_COD', Resources.table_head_location),
            generateColumn('LOTE', Resources.table_head_batch),
            generateColumn('C_UNI1_aux', Resources.table_head_shrt_quantity, true, true),
            generateColumn('C_RESER1', "C. Res.", self.CONFIG.Reservas, true),
            generateColumn('C_UNI1', "", false)
        ];
        self.VIEW.columnDefs = [
            { width: '6em', target: 0 },
            { width: '4em', target: 2 },
            { width: '4em', target: 3 }
        ];

        self.CreateTable();
        var url = "consultas/inicioArticulo";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD")
        };
        var success = function (response) {
            if (response.Ok) {
                self.CONFIG.MostrarAgrupacion = response.Objeto.MostrarAgrupacion;
                self.CONFIG.PermiteRegularizar = response.Objeto.PermiteRegularizar;
                self.CONFIG.Reservas = response.Objeto.Reservas;
                self.ResizeAgrup();
            }

            if (self.CONFIG.PermiteRegularizar) {
                addEvent(btnUpdate, 'click', function () { self.RegularizarCantidadesArt(); }, false);

                var CellValueModifier = new ModifyCellValue("#tablaConsultas", "C_UNI1_aux");
                CellValueModifier.modCellValue(function (newValue, oldValue, row) { console.log({ newValue, oldValue, row }); }, "Float", false);

                //modCellValue(2);
                $(self.VIEW.btnUpdate).show();
            } else {
                $(self.VIEW.btnUpdate).hide();
            }
            //cambioTamanioConsulta();
            addEvent(btnConsArt, 'click', function () { self.BusquedaArticulo() }, false);
        };
        apiGeneral(url, method, data, success);
    },
    ResizeAgrup: function () {
        if (this.CONFIG.MostrarAgrupacion) {
            $('#agrupField').show();
            $('#type').removeClass('col-xs-9').addClass('col-xs-6');
            $('#type button').removeClass('col-xs-2').addClass('col-xs-3');
        } else {
            $('#agrupField').hide();
            $('#type').removeClass('col-xs-6').addClass('col-xs-9');
            $('#type button').removeClass('col-xs-3').addClass('col-xs-2');
        }
    },
    InicioUbicacion: function (ubic) {

        var self = this;
        self.VIEW.columnsJSON = [
            generateColumn('GAART_COD', Resources.table_head_code),
            generateColumn('GAART_DESCRIP', Resources.table_head_description, false),
            generateColumn('LOTE', Resources.table_head_batch),
            generateColumn('C_UNI1_aux', Resources.table_head_shrt_quantity, true, true),
            generateColumn('C_RESER1', "C. Res.", self.CONFIG.Reservas, true, true),
            generateColumn('C_UNI1', "", false),
        ];
        self.VIEW.columnDefs = [
            { width: '6em', target: 0 },
            { width: '4em', target: 3 },
            { width: '4em', target: 4 }
        ];
        self.CreateTable();
        // RBM 03/03/20 Cambio la validación con la pulsación del Intro para hacerla con el evento 'change'
        //$(ubic).keypress(function (e) { if (e.which === 13) { self.ConsultaUbicacion(); } });
        $(ubic).on("change", function (e) { self.ConsultaUbicacion(); });

        var url = "consultas/inicioUbicacion";
        var method = "GET";
        var data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD")
        };
        var success = function (response) {
            if (response.Ok) {
                self.CONFIG.PermiteRegularizar = response.Objeto.PermiteRegularizar;
                self.CONFIG.Reservas = response.Objeto.Reservas;
            }
            if (self.CONFIG.PermiteRegularizar) {
                addEvent(btnUpdate, 'click', function () { self.RegularizarCantidadesUbic(); }, false);

                var CellValueModifier = new ModifyCellValue("#tablaConsultas", "C_UNI1_aux");
                CellValueModifier.modCellValue(function (newValue, oldValue, row) { console.log({ newValue, oldValue, row }); }, "Float", false);

                //modCellValue(3);
                $(self.VIEW.btnUpdate).show();
            } else {
                $(self.VIEW.btnUpdate).hide();
            }

            //$('#tablaConsultas_wrapper .dataTables_scroll').after($('#articleField'));

            //addEvent(ubic, 'keypress', buscaUbicacion, false);

            self.SelectUbicacion();
        };
        apiGeneral(url, method, data, success);
    },
    ConsultaArticulo: function () {
        var self = this;
        var v_url = "consultas/existenciasarticulo";
        var v_method = "GET";

        var articulo = $(self.VIEW.artic).val().toUpperCase();
        var v_data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            lecturaArticulo: articulo
        };
        var v_success = function (response, status, xhr) {
            v_datatable.clear().draw();
            if (response.Ok) {
                $("#desc").val(response.Objeto.GAART_DESCRIP);
                $("#exist").val(response.Objeto.C_EXIST1);
                $("#agrup").val(response.Objeto.C_EXIST1_ALMAGRU);

                if (v_datatable.rows.length == 0) {

                    var existencias = response.Objeto.Existencias.map(
                        function (exist) {
                            return {
                                GAUBIC_COD: exist.GAUBIC_COD,
                                LOTE: exist.LOTE,
                                C_UNI1_aux: exist.C_UNI1,
                                C_RESER1: exist.C_RESER1,
                                C_UNI1: exist.C_UNI1,
                            };
                        }
                    );
                    v_datatable.rows.add(existencias).draw();
                    v_lineas = v_datatable.rows().data();
                    selectRow('#tablaConsultas');
                }
            } else {
                $("#exist").val("");
                $("#desc").val("");
                $("#agrup").val("");
                lanzarMensaje(response.Ok, response.Mensaje);
            }
            $('#articulo').focus().select();
        };
        apiGeneral(v_url, v_method, v_data, v_success);
    },


    ConsultaUbicacion: function () {
        var self = this;
        var v_url = "consultas/existenciasubicacion";
        var v_method = "GET";

        var ubicacion = $(self.VIEW.ubic).val().toUpperCase();

        var v_data = {
            empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"),
            emp_cod: sessionStorage.getItem("EMPR_COD"),
            gaubic_cod: ubicacion
        };

        var v_success = function (response, status, xhr) {
            v_datatable.clear().draw();
            if (response.Ok) {
                if (v_datatable.rows.length === 0) {
                    var existencias = response.Objeto.Existencias.map(
                        function (exist) {
                            return {
                                GAART_COD: exist.GAART_COD,
                                GAART_DESCRIP: exist.GAART_DESCRIP,
                                LOTE: exist.LOTE,
                                C_UNI1_aux: exist.C_UNI1,
                                C_RESER1: exist.C_RESER1,
                                C_UNI1: exist.C_UNI1
                            };
                        }
                    );

                    v_datatable.rows.add(existencias).draw();
                    v_lineas = v_datatable.rows().data();
                    selectRow('#tablaConsultas');

                    // RBM 05/06/2020 - Txapuzón
                    $("#descrip").val(existencias[0].GAART_DESCRIP);
                    // FIN RBM 05/06/2020 - Txapuzón

                }
                $(self.VIEW.ubic).focus().select();

            } else {
                lanzarMensaje(response.Ok, response.Mensaje, function () { $(self.VIEW.ubic).focus().select(); });
            }
        };
        apiGeneral(v_url, v_method, v_data, v_success);
    },


    SelectUbicacion: function () {
        // TODO AAZ
        var self = this;
        self.VIEW.v_table.on('mousedown', 'tbody', function (event) {
            if (event && v_lineas.length > 0) {
                var v_gridLine = $(event.target).closest('tr');
                $("#descrip").val(v_datatable.row(v_gridLine).data().GAART_DESCRIP);
            }
        });
    },

    SelectArticles: function () {
        var self = this;
        $('#accept').on('mousedown', function () {
            var v_table = $("#tablaArticulosConsulta").DataTable();
            if (v_table.rows().data().length > 0) {
                var v_codArt = v_table.row('.selected').data().COD;
                var v_descrArt = v_table.row('.selected').data().DESCRIP;
                $(self.VIEW.artic).val(v_codArt);
                $('#desc').val(v_descrArt);
            }
            self.ConsultaArticulo();
            closeModal('#dialogLoV');
        });
    },
    BusquedaArticulo: function () {
        var self = this;
        var v_url = "consultas/articulos";
        var v_datos = { empgrupo_cod: sessionStorage.getItem("EMPRGRUP_COD"), emp_cod: sessionStorage.getItem("EMPR_COD") }
        var v_method = "GET";
        var v_success = function (response) {
            if (response.Ok) {
                //var url = Router.action('Dialog', 'Dialog');
                var url = 'Dialog/Dialog';
                var v_dialog = "#dialogLoV";
                var v_nombre_tabla = 'tablaArticulosConsulta';
                var v_column = [generateColumn('COD', Resources.table_head_code), generateColumn('DESCRIP', Resources.table_head_description)];
                var columnDefs = [
                    { width: '6em', target: 0 }
                ];
                var buttons = [generateSingleButton('accept', Resources.button_accept)];
                var func = function () { self.SelectArticles(); };
                var v_dataJson = response.Objeto;
                generarDialogAuto(url, v_dialog, v_nombre_tabla, null, v_dataJson, v_column, buttons, null, null, func, Resources.title_article_list, null, null, null, null, null, null, columnDefs, true);
            } else {
                lanzarMensaje(response.Ok, response.Mensaje);
            }
        };

        apiGeneral(v_url, v_method, v_datos, v_success);
    }
};
$(document).ready(function () {
    var v_Consulta = new Consulta();
    v_Consulta.Init();
});